// Generated by CoffeeScript 1.8.0
define(['xyzp/UILayer'], function(UILayer) {
  var Breakpoints;
  return Breakpoints = (function() {
    function Breakpoints() {
      this.list = [];
      this.breakpointsByName = {};
      this.breakpoints = {};
    }

    Breakpoints.prototype.addBreakpoints = function(name, breakpoints) {
      this.list.push(breakpoints);
      this.breakpointsByName[name] = breakpoints;
      return this.resolveBreakpoints();
    };

    Breakpoints.prototype.removeBreakpoints = function(name) {
      _.pull(this.list, this.breakpointsByName[name]);
      delete this.breakpointsByName[name];
      return this.resolveBreakpoints();
    };

    Breakpoints.prototype.resolveBreakpoints = function() {
      var breakpoint, breakpoints, resolvedBreakpoints, width, _i, _len, _ref;
      resolvedBreakpoints = {};
      _ref = this.list;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        breakpoints = _ref[_i];
        for (width in breakpoints) {
          breakpoint = breakpoints[width];
          if (resolvedBreakpoints[width] == null) {
            resolvedBreakpoints[width] = [];
          }
          resolvedBreakpoints[width].push(breakpoint);
        }
      }
      return this.breakpoints = resolvedBreakpoints;
    };

    Breakpoints.prototype.update = function(force) {
      var bp, breakpoint, prevBreakpoint, width, widths, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _results;
      if (force == null) {
        force = false;
      }
      $('body').addClass('breakpointed');
      widths = _.map(_.without(_.keys(this.breakpoints), 'else'), function(v) {
        return parseInt(v);
      }).sort(function(a, b) {
        return a - b;
      });
      breakpoint = 'else';
      for (_i = 0, _len = widths.length; _i < _len; _i++) {
        width = widths[_i];
        if ($(window).width() < width) {
          breakpoint = width;
          break;
        }
      }
      if (this.currentBreakpoint !== breakpoint || force) {
        $('body').removeClass("breakpoint-" + this.currentBreakpoint);
        $('body').addClass("breakpoint-" + breakpoint);
        if (this.breakpointLayer) {
          this.breakpointLayer.destruct();
        }
        this.breakpointLayer = new UILayer;
        prevBreakpoint = this.currentBreakpoint;
        this.currentBreakpoint = breakpoint;
        if (this.breakpoints[breakpoint]) {
          _ref = this.breakpoints[breakpoint];
          for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
            bp = _ref[_j];
            if (typeof bp.init === "function") {
              bp.init(this.breakpointLayer);
            }
          }
        }
        if (this.currentBreakpoint !== prevBreakpoint && prevBreakpoint) {
          if (typeof this.onBreakpointChanged === "function") {
            this.onBreakpointChanged(this.currentBreakpoint, prevBreakpoint);
          }
        }
      }
      if (this.breakpoints[breakpoint]) {
        _ref1 = this.breakpoints[breakpoint];
        _results = [];
        for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
          bp = _ref1[_k];
          _results.push(typeof bp.resize === "function" ? bp.resize($(window).width()) : void 0);
        }
        return _results;
      }
    };

    return Breakpoints;

  })();
});

//# sourceMappingURL=Breakpoints.js.map
