// Generated by CoffeeScript 1.8.0
var __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

define(['app/UIHelpers', 'xyzp/ObjectListAggregate', 'xyzp/FormattedValue', 'xyzp/UILayer'], function(UIHelpers, ObjectListAggregate, FormattedValue, UILayer) {
  var DivvyDose;
  return window.DivvyDose = DivvyDose = {
    getPacketsByTimeOnDay: function(day) {
      var beginDate, date, divvyPack, divvyPacks, packet, packetsByTime, time, _i, _len, _ref;
      packetsByTime = {};
      if (g_userCont.get()) {
        date = moment(day).format('YYYY-MM-DD');
        if (divvyPacks = g_userCont.get().get('divvyPacks')) {
          for (beginDate in divvyPacks) {
            divvyPack = divvyPacks[beginDate];
            _ref = divvyPack.packets;
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              packet = _ref[_i];
              if (packet.time.substr(0, 10) === date) {
                time = packet.time.substr(11, 5);
                packetsByTime[time] = _.map(packet.doses, function(dose) {
                  if (divvyPack.prescriptions[dose.rxNumber]) {
                    return divvyPack.prescriptions[dose.rxNumber];
                  } else {
                    console.log(divvyPack.prescriptions);
                    console.log("" + dose.rxNumber + " not found");
                    return {
                      name: 'ERROR',
                      presciber: 'ERROR',
                      sig: 'ERROR'
                    };
                  }
                });
              }
            }
          }
        }
      }
      return packetsByTime;
    },
    getPacketsByTime: function() {
      return DivvyDose.getPacketsByTimeOnDay(moment());
    },
    timesForDay: function(day, beforeNow) {
      var beginDate, divvyPack, divvyPacks, now, packet, times, _i, _len, _ref;
      if (beforeNow == null) {
        beforeNow = false;
      }
      times = [];
      now = dataManager.now();
      if (g_userCont.get()) {
        if (divvyPacks = g_userCont.get().get('divvyPacks')) {
          for (beginDate in divvyPacks) {
            divvyPack = divvyPacks[beginDate];
            day = moment(day).format('YYYY-MM-DD');
            _ref = divvyPack.packets;
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              packet = _ref[_i];
              if (beforeNow && packet.time > now.toLocalMysqlFormat()) {
                continue;
              }
              if (packet.time.substr(0, 10) === day) {
                times.push(packet.time);
              }
            }
          }
        }
      }
      return times;
    },
    nextTimes: function(num) {
      var beginDate, divvyPack, divvyPacks, now, packet, t, time, times, _i, _j, _len, _len1, _ref;
      times = [];
      if (g_userCont.get()) {
        now = new Date().toLocalMysqlFormat();
        if (divvyPacks = g_userCont.get().get('divvyPacks')) {
          for (beginDate in divvyPacks) {
            divvyPack = divvyPacks[beginDate];
            t = {};
            _ref = divvyPack.packets;
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              packet = _ref[_i];
              t[packet.time] = true;
            }
            t = _.keys(t);
            t.sort();
            for (_j = 0, _len1 = t.length; _j < _len1; _j++) {
              time = t[_j];
              if (time >= now) {
                if (!(__indexOf.call(times, time) >= 0)) {
                  times.push(Date.create(time));
                  if (times.length === num) {
                    break;
                  }
                }
              }
            }
          }
        }
      }
      return times;
    },
    completedForDay: function(day) {
      var completed, time, timesSoFar, totalTimes, _i, _len;
      if (g_userCont.get().get('demo')) {
        switch (moment().diff(moment(day), 'days')) {
          case 0:
            return 1;
          case 1:
            return 1;
          case 2:
            return 1;
          case 3:
            return 3 / 4;
          case 4:
            return 1;
          case 5:
            return 1;
          case 6:
            return 3 / 4;
        }
      } else {
        timesSoFar = DivvyDose.timesForDay(day, true);
        if (timesSoFar.length) {
          totalTimes = DivvyDose.timesForDay(day, false);
          timesSoFar.length / totalTimes.length;
          completed = 0;
          for (_i = 0, _len = timesSoFar.length; _i < _len; _i++) {
            time = timesSoFar[_i];
            if (g_userCont.get().get('medicineLogEntries').exists({
              time: time,
              event: 'taken'
            })) {
              completed++;
            }
          }
          completed / timesSoFar.length;
          return (1 - timesSoFar.length / totalTimes.length) + timesSoFar.length / totalTimes.length * completed / timesSoFar.length;
        } else {
          return 1;
        }
      }
    },
    timesTillNow: function() {
      var divvyPack, divvyPacks, now, nowFormatted, packet, startDate, startDates, times, _i, _j, _len, _len1, _ref;
      now = new Date();
      nowFormatted = now.toLocalMysqlFormat();
      if (g_userCont.get()) {
        if (divvyPacks = g_userCont.get().get('divvyPacks')) {
          times = {};
          startDates = _.keys(divvyPacks);
          startDates.sort();
          for (_i = 0, _len = startDates.length; _i < _len; _i++) {
            startDate = startDates[_i];
            if (Date.create(startDate).getTime() <= now.getTime()) {
              divvyPack = divvyPacks[startDate];
              _ref = divvyPack.packets;
              for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
                packet = _ref[_j];
                if (packet.time < nowFormatted) {
                  times[packet.time] = true;
                }
              }
            }
          }
          return _.keys(times).sort().reverse();
        }
      }
      return [];
    },
    backlog: function() {
      var times;
      times = DivvyDose.timesTillNow();
      g_userCont.get().get('medicineLogEntries').each(function(logEntry) {
        return _.pull(times, logEntry.get('time'));
      });
      return times;
    },
    packetForTime: function(time) {
      var divvyPack, divvyPacks, packet, startDate, _i, _len, _ref;
      if (divvyPacks = g_userCont.get().get('divvyPacks')) {
        for (startDate in divvyPacks) {
          divvyPack = divvyPacks[startDate];
          _ref = divvyPack.packets;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            packet = _ref[_i];
            if (packet.time === time) {
              return packet;
            }
          }
        }
      }
    },
    log: function(time, event) {
      var dose, medicineLogEntry, packet, _i, _len, _ref, _results;
      console.log(time, event);
      if (!dataManager.model('MedicineLogEntry').findOne({
        user: g_userCont.get(),
        time: time
      })) {
        packet = DivvyDose.packetForTime(time);
        if (packet) {
          medicineLogEntry = dataManager.model('MedicineLogEntry').create({
            user: g_userCont.get(),
            time: time,
            timestamp: new Date(),
            event: event
          });
          _ref = packet.doses;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            dose = _ref[_i];
            _results.push(dataManager.model('MedicineLogEntryDose').create({
              medicineLogEntry: medicineLogEntry,
              prescription: dataManager.model('Prescription').findOne({
                rxNumber: dose.rxNumber
              }),
              quantity: dose.quantity
            }));
          }
          return _results;
        }
      }
    },
    prescriptionNameWithoutFormat: function(name) {
      var format, formats, lastSpace, lastWord, _i, _len;
      formats = 'CAPSULE, GEL CAPSULE, TABLET, POWDER, PILL, PUFF, DROPS, EYE DROP, CREAM, CHEW, SUPPOSITORY, LIQUID, OINTMENT, SPRAY, SHAMPOO, SOLUTION, KIT, CLEANSER, CHEWABLE, ENEMA, FOAM, SUSPENSION, PUMP, ELIXIR, ACTUATION, VIAL, SYRUP, INHALER, CAPLET, DISKUS, AMPULE, SYRINGE'.split(', ');
      lastSpace = name.lastIndexOf(' ');
      if (lastSpace !== -1) {
        lastWord = name.substr(lastSpace + 1);
        for (_i = 0, _len = formats.length; _i < _len; _i++) {
          format = formats[_i];
          if (lastWord === format.substr(0, lastWord.length)) {
            name = name.substr(0, lastSpace);
            break;
          }
        }
      }
      return name;
    },
    monthlyProductPrice: function(product, options) {
      var days, packetTime, quantity;
      return parseFloat((function() {
        var _i, _len, _ref;
        switch (product.get('type')) {
          case 'pack':
            return product.get('price') * options.quantity * 28;
          case 'item':
            switch (options.packaging) {
              case 'divvyPACK':
                days = 0;
                switch (options.frequency) {
                  case 'every day':
                    days = 28;
                    break;
                  case 'every other day':
                    days = 14;
                    break;
                  case 'on specific days':
                    if (options.specificDays.monday) {
                      ++days;
                    }
                    if (options.specificDays.tuesday) {
                      ++days;
                    }
                    if (options.specificDays.wednesday) {
                      ++days;
                    }
                    if (options.specificDays.thursday) {
                      ++days;
                    }
                    if (options.specificDays.friday) {
                      ++days;
                    }
                    if (options.specificDays.saturday) {
                      ++days;
                    }
                    if (options.specificDays.sunday) {
                      ++days;
                    }
                    days *= 4;
                }
                quantity = 0;
                _ref = options.packetTimes;
                for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                  packetTime = _ref[_i];
                  quantity += parseInt(packetTime.quantity);
                }
                return days * quantity * product.get('price');
              case 'Bottle':
                return product.get('computedPrice', options.packaging);
            }
        }
      })());
    },
    dailyProductPrice: function(product, options) {
      var packetTime, quantity;
      return parseFloat((function() {
        var _i, _len, _ref;
        switch (product.get('type')) {
          case 'pack':
            return product.get('price') * options.quantity;
          case 'item':
            switch (options.packaging) {
              case 'divvyPACK':
                quantity = 0;
                _ref = options.packetTimes;
                for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                  packetTime = _ref[_i];
                  quantity += parseInt(packetTime.quantity);
                }
                return quantity * product.get('price');
              case 'Bottle':
                return (product.get('computedPrice', options.packaging)) / 28;
            }
        }
      })());
    },
    orderProducts: function(items, done) {
      var el, modalBox;
      el = $("<div class='divvyMarket-orderConfirmation'>" + rootLayer.tmpls.orderConfirmation + "</div>");
      modalBox = UIHelpers.showModalBox(el);
      return modalBox.layer.bind(el, {
        user: g_userCont,
        items: items,
        cancel: function() {
          return modalBox.close();
        },
        confirm: function() {
          var item, order, _i, _len;
          el.addClass('loading');
          order = dataManager.model('Order').create({
            user: g_userCont.get(),
            createdAt: new Date()
          });
          for (_i = 0, _len = items.length; _i < _len; _i++) {
            item = items[_i];
            dataManager.model('OrderItem').create({
              order: order,
              product: item.product,
              options: item.options
            });
          }
          if (typeof done === "function") {
            done();
          }
          return setTimeout((function() {
            el = $("<div class='divvyMarket-orderComplete'>" + rootLayer.tmpls.orderComplete + "</div>");
            modalBox = UIHelpers.showModalBox(el);
            return modalBox.layer.bind(el, {
              user: g_userCont,
              items: items,
              gotIt: function() {
                return modalBox.close();
              }
            }, {
              'items.price': function(product, options) {
                return '$' + DivvyDose.monthlyProductPrice(product, options).format(2);
              }
            });
          }), 2000);
        }
      }, {
        'items.price': function(product, options) {
          return '$' + DivvyDose.monthlyProductPrice(product, options).format(2);
        }
      });
    },
    openShoppingCart: function() {
      return UIHelpers.openModelView({
        icon: 'shoppingCart.svg',
        html: rootLayer.tmpls.cart,
        title: 'Cart',
        "class": 'shoppingCartWindow',
        componentIniter: function() {
          var layer;
          layer = this.layer;
          return layer.bind(this.el, {
            user: g_userCont,
            total: new FormattedValue((function(value) {
              return "$" + (value.format(2));
            }), new ObjectListAggregate(g_userCont.get().get('shoppingCartItems'), 'monthlyPrice')).retain(),
            checkOut: (function(_this) {
              return function() {
                var items;
                items = [];
                g_userCont.get().get('shoppingCartItems').each(function(shoppingCartItem) {
                  return items.push({
                    product: shoppingCartItem.get('product'),
                    options: shoppingCartItem.get('options')
                  });
                });
                return DivvyDose.orderProducts(items, function() {
                  var item, shoppingCartItems, _i, _len, _results;
                  shoppingCartItems = [];
                  g_userCont.get().get('shoppingCartItems').each(function(item) {
                    return shoppingCartItems.push(item);
                  });
                  _results = [];
                  for (_i = 0, _len = shoppingCartItems.length; _i < _len; _i++) {
                    item = shoppingCartItems[_i];
                    _results.push(item["delete"]());
                  }
                  return _results;
                });
              };
            })(this)
          });
        }
      });
    },
    productAddedToCartMessage: function() {
      var el, layer, messageEl, srcEl;
      el = $('<a href="#" id="shoppingCartClone"><span class="count" bind-value="user.shoppingCartItems.length" /></a>');
      layer = new UILayer;
      layer.bind(el, {
        user: g_userCont
      });
      layer.addHtml($('body'), el);
      srcEl = $('header .shoppingCart');
      el.css({
        position: 'absolute',
        left: srcEl.offset().left,
        top: srcEl.offset().top,
        zIndex: 999999
      });
      layer.addCss(srcEl, {
        visibility: 'hidden'
      });
      layer;
      messageEl = $("<div class='addedToCartMessage'>" + rootLayer.tmpls.addedToCart + "</div>");
      layer.addHtml($('body'), messageEl);
      layer.bind(messageEl, {
        gotIt: function() {
          return layer.destruct();
        },
        goToCart: function() {
          layer.destruct();
          return rootFrame.navigate('shoppingCart');
        }
      });
      messageEl.css({
        position: 'absolute',
        left: el.offset().left + el.width() / 2 - messageEl.outerWidth() / 2,
        top: el.offset().top + el.height() + 16,
        zIndex: 999999
      });
      return $('<div />').css({
        position: 'absolute',
        left: 0,
        right: 0,
        top: -11,
        margin: 'auto',
        width: 32,
        height: 11,
        overflow: 'hidden'
      }).append($('<div />').css({
        'background-color': '#606467',
        'border-radius': '2px',
        'box-shadow': '0 2px 3px 0 rgba(0,0,0,0.24)',
        'transform': 'rotate(45deg)',
        'width': '32px',
        'height': '32px',
        position: 'absolute',
        top: 6
      })).appendTo(messageEl);
    }
  };
});

//# sourceMappingURL=DivvyDose.js.map
