// Generated by CoffeeScript 1.8.0
define(function() {
  var UIFrame;
  return UIFrame = (function() {
    UIFrame.nextFrameId = 1;

    UIFrame.frames = {};

    function UIFrame() {
      var framePackage;
      if (this.framePackage = framePackage = UIFrame.framePackage) {
        delete UIFrame.framePackage;
        this.handle = framePackage.handle;
        if (this.handle) {
          UIFrame.frames[this.handle] = this;
        }
        this.cameFrom = framePackage.navigatedFrom;
        this.rootFrame = this.cameFrom.rootFrame;
        this.edge = this.cameFrom.navigationalDirection;
        this.cameFrom.onFrame(this, framePackage);
      } else {
        this.rootFrame = this;
        this.frames = {};
      }
    }

    UIFrame.prototype.setupUI = function(cb) {
      return this._func = cb;
    };

    UIFrame.prototype.onDestroyUI = function(_onDestroyUI) {
      this._onDestroyUI = _onDestroyUI;
    };

    UIFrame.prototype.onInitUI = function(_onInitUI) {
      this._onInitUI = _onInitUI;
    };

    UIFrame.prototype.onReenterUI = function(_onReenterUI) {
      this._onReenterUI = _onReenterUI;
    };

    UIFrame.prototype.destroyUI = function() {
      if (this._onDestroyUI) {
        this._onDestroyUI.call(this);
      }
      delete this.slots;
      return UIFrame.frames = {};
    };

    UIFrame.prototype.initUI = function() {
      if (this._onInitUI) {
        return this._onInitUI.call(this);
      }
    };

    UIFrame.prototype.onFrame = function(frame, framePackage) {
      var _ref;
      this.navigationFrame = frame;
      if (this.nextSlot) {
        frame.slot = this.nextSlot;
        if (this.slots == null) {
          this.slots = {};
        }
        if (framePackage.context === 'navigation') {
          if ((_ref = this.slot[this.nextSlot]) != null) {
            if (typeof _ref.exit === "function") {
              _ref.exit();
            }
          }
        }
        this.slot[this.nextSlot] = frame;
        delete this.nextSlot;
      }
      if (framePackage.context === 'navigation') {
        frame.linkNumber = this.rootFrame.extendChain(frame.edge);
      } else if (framePackage.context === 'restore') {
        frame.linkNumber = framePackage.linkNumber;
        this.rootFrame.chain.push([]);
      }
      return this.rootFrame.frames[frame.linkNumber] = frame;
    };

    UIFrame.prototype.slot = function(slot) {
      return this.nextSlot = slot;
    };

    UIFrame.prototype.call = function(params) {
      if (this._func) {
        if (this._func.call(this, _.clone(params)) === false) {
          if (this.cameFrom) {
            return this.cameFrom.call(_.clone(params));
          }
        }
      } else {
        if (this.cameFrom) {
          return this.cameFrom.call(_.clone(params));
        }
      }
    };

    UIFrame.prototype.shift = function(id, params, linkNumber, cb) {
      if (cb == null) {
        cb = null;
      }
      UIFrame.framePackage = {
        context: 'restore',
        navigatedFrom: this,
        handle: UIFrame.nextFrameId++,
        cb: cb,
        linkNumber: linkNumber
      };
      if (_.isPlainObject(id)) {
        this.navigationalDirection = {
          id: id.id,
          params: id.params
        };
        return this.call(_.merge(id, {
          context: 'restore',
          frameHandle: UIFrame.framePackage.handle
        }));
      } else {
        this.navigationalDirection = {
          id: id,
          params: params
        };
        return this.call({
          context: 'restore',
          id: id,
          params: params,
          frameHandle: UIFrame.framePackage.handle
        });
      }
    };

    UIFrame.prototype.navigate = function(id, params, cb) {
      if (cb == null) {
        cb = null;
      }
      UIFrame.framePackage = {
        context: 'navigation',
        navigatedFrom: this,
        handle: UIFrame.nextFrameId++,
        cb: cb
      };
      if (_.isPlainObject(id)) {
        this.navigationalDirection = {
          id: id.id,
          params: id.params
        };
        return this.call(_.merge(id, {
          context: 'navigation',
          frameHandle: UIFrame.framePackage.handle
        }));
      } else {
        this.navigationalDirection = {
          id: id,
          params: params
        };
        return this.call({
          context: 'navigation',
          id: id,
          params: params,
          frameHandle: UIFrame.framePackage.handle
        });
      }
    };

    UIFrame.prototype.denavigate = function() {};

    UIFrame.prototype.unlinkAt = function(linkNumber) {
      var iFrame;
      console.log(linkNumber);
      this.chain = this.chain.slice(0, linkNumber);
      iFrame = this.frames[this.chain.length - 1];
      console.log('unlink', iFrame);
      return iFrame != null ? typeof iFrame.reenter === "function" ? iFrame.reenter() : void 0 : void 0;
    };

    UIFrame.prototype.unlink = function(frame) {
      return this.unlinkAt(frame.linkNumber);
    };

    UIFrame.prototype.reenter = function() {
      console.log(this, 'reentered', this._onReenterUI);
      if (this._onReenterUI) {
        return this._onReenterUI.call(this);
      }
    };

    UIFrame.prototype.createSubFrame = function() {
      return this.adoptFrame(new UIFrame);
    };

    UIFrame.prototype.adoptFrame = function(frame) {
      frame.parent = this;
      return frame;
    };

    UIFrame.prototype.extendChain = function(edge) {
      var linkNumber;
      if (this.chain == null) {
        this.chain = [];
      }
      linkNumber = this.chain.length;
      this.chain.push(edge);
      return linkNumber;
    };

    UIFrame.prototype.destruct = function() {
      if (this.cameFrom) {
        this.cameFrom.denavigate(this);
      }
      if (this.rootFrame) {
        this.rootFrame.unlink(this);
      }
      if (this.handle) {
        return delete UIFrame.frames[this.handle];
      }
    };

    UIFrame.prototype.exit = function() {
      return this.destruct();
    };

    UIFrame.prototype["return"] = function() {
      return this.exit();
    };

    UIFrame.prototype.exitFrame = function(handle) {
      return UIFrame.frames[handle].exit();
    };

    UIFrame.prototype.uiInited = function() {
      var _ref;
      if ((_ref = this.framePackage) != null ? _ref.cb : void 0) {
        return this.framePackage.cb(this);
      }
    };

    return UIFrame;

  })();
});

//# sourceMappingURL=UIFrame.js.map
