// Generated by CoffeeScript 1.8.0
define(['xyzp/UILayer', 'app/UIFrame', 'app/Component'], function(UILayer, UIFrame, Component) {
  var UIHelpers;
  return UIHelpers = {
    form: {
      setErrors: function(formEl, errors) {
        var error, field, fieldEl, _results;
        formEl.find('.errorText').remove();
        formEl.find("[name], .field, .fieldGroup").removeClass('error');
        _results = [];
        for (field in errors) {
          error = errors[field];
          fieldEl = formEl.find("[name=" + field + "], .field." + field + ", .fieldGroup." + field);
          fieldEl.addClass('error');
          _results.push(fieldEl.after("<span class='errorText'>" + error + "</span>"));
        }
        return _results;
      },
      validate: function(formEl, val, cb) {
        var done, e, errorField, errors, field, v, waiting;
        errors = {};
        waiting = 0;
        done = function() {
          if (!waiting || !--waiting) {
            UIHelpers.form.setErrors(formEl, errors);
            return cb(_.isEmpty(errors));
          }
        };
        if (_.isFunction(val)) {
          val(formEl, errors);
        } else {
          for (field in val) {
            v = val[field];
            errorField = field;
            if (!_.isFunction(v)) {
              if (_.isPlainObject(v)) {
                errorField = v.field;
                v = v.validate;
              }
              v = (function() {
                switch (v) {
                  case 'notEmpty':
                    return function(value) {
                      if (!value) {
                        return 'Please enter value.';
                      }
                    };
                }
              })();
            }
            e = v(formEl.find("[name=" + field + "]").val(), formEl.find("[name=" + field + "]"));
            if (_.isString(e)) {
              errors[errorField] = e;
            }
          }
        }
        if (!waiting) {
          return done();
        }
      }
    },
    inputData: function(el, mapping) {
      var data;
      if (mapping == null) {
        mapping = {};
      }
      data = {};
      el.find('[name]').each(function() {
        var inputEl, name, _ref;
        inputEl = $(this);
        name = inputEl.attr('name');
        if (inputEl.is('input') && ((_ref = inputEl.attr('type')) === 'text' || _ref === 'email' || _ref === 'password') || inputEl.is('select') || inputEl.is('textarea')) {
          return data[name] = mapping[name] ? mapping[name](inputEl.val()) : inputEl.val();
        } else if (inputEl.is('input') && inputEl.attr('type') === 'checkbox') {
          return data[name] = inputEl.prop('checked');
        }
      });
      return data;
    },
    setInputData: function(el, data, mapping) {
      var inputEl, name, value, _ref, _results;
      if (mapping == null) {
        mapping = {};
      }
      _results = [];
      for (name in data) {
        value = data[name];
        inputEl = el.find("[name=" + name + "]");
        if (inputEl.is('input') && ((_ref = inputEl.attr('type')) === 'text' || _ref === 'email' || _ref === 'password') || inputEl.is('select') || inputEl.is('textarea')) {
          _results.push(inputEl.val(mapping[name] ? mapping[name](value) : value));
        } else if (inputEl.is('input') && inputEl.attr('type') === 'checkbox') {
          _results.push(inputEl.prop('checked', !!value));
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    },
    showDialog: function(opts) {
      var backgroundEl, close, dialogEl, id, updatePosition;
      dialogEl = $(opts.html);
      close = function() {
        return backgroundEl.fadeOut(function() {
          backgroundEl.remove();
          return clearInterval(id);
        });
      };
      updatePosition = function() {
        return dialogEl.css({
          left: $('.dialogWrapper').width() / 2 - dialogEl.outerWidth() / 2,
          top: Math.max(0, $('.dialogWrapper').height() / 2 - dialogEl.outerHeight() / 2)
        });
      };
      opts.init({
        el: dialogEl,
        close: close,
        updatePosition: updatePosition
      });
      backgroundEl = $('<div class="dialogWrapper" />').appendTo('body');
      dialogEl.appendTo(backgroundEl);
      updatePosition();
      return id = setInterval(updatePosition, 100);
    },
    showModalBox: function(clientEl, opts) {
      var alreadyOpen, id, prevModalBox;
      if (opts == null) {
        opts = {};
      }
      alreadyOpen = this.modalBoxData != null;
      if (!this.modalBoxData) {
        console.log(rootFrame.chain, rootFrame.chain.length);
        this.modalBoxData = {
          linkNumber: rootFrame.chain.length,
          layer: rootLayer.addLayer(new UILayer),
          close: (function(_this) {
            return function(cb) {
              rootFrame.unlinkAt(_this.modalBoxData.linkNumber);
              return _this.modalBoxData.backgroundEl.fadeOut(function() {
                return _this.modalBoxData.layer.destruct();
              });
            };
          })(this),
          backgroundEl: $('<div class="dialogWrapper" />'),
          updatePosition: (function(_this) {
            return function() {
              if (_this.modalBoxData.modalBox.opts.autoPositioned !== false) {
                return _this.modalBoxData.modalBox.el.css({
                  left: $('.dialogWrapper').width() / 2 - _this.modalBoxData.modalBox.el.outerWidth() / 2,
                  top: Math.max(0, $('.dialogWrapper').height() / 2 - _this.modalBoxData.modalBox.el.outerHeight() / 2)
                });
              }
            };
          })(this)
        };
        this.modalBoxData.layer.addDestructFunc((function(_this) {
          return function() {
            clearInterval(id);
            return delete _this.modalBoxData;
          };
        })(this));
        this.modalBoxData.layer.addHtml($('body'), this.modalBoxData.backgroundEl);
        id = setInterval(((function(_this) {
          return function() {
            return _this.modalBoxData.updatePosition();
          };
        })(this)), 100);
      }
      prevModalBox = this.modalBoxData.modalBox;
      this.modalBoxData.modalBox = {
        opts: opts,
        el: clientEl,
        close: ((function(_this) {
          return function() {
            return _this.modalBoxData.close();
          };
        })(this)),
        layer: this.modalBoxData.layer.addLayer(new UILayer)
      };
      if (alreadyOpen) {
        prevModalBox.el.fadeOut((function(_this) {
          return function() {
            prevModalBox.layer.destruct();
            _this.modalBoxData.modalBox.layer.addHtml(_this.modalBoxData.backgroundEl, clientEl);
            return _this.modalBoxData.updatePosition();
          };
        })(this));
        this.modalBoxData.backgroundEl.removeClass('staticClient');
      } else {
        this.modalBoxData.modalBox.layer.addHtml(this.modalBoxData.backgroundEl, clientEl);
        this.modalBoxData.updatePosition();
      }
      if (opts.absolutePositioned === false) {
        this.modalBoxData.backgroundEl.addClass('staticClient');
      }
      return this.modalBoxData.modalBox;
    },
    editDialog: function(opts) {
      return function() {
        var instance;
        instance = opts.instance;
        return UIHelpers.showDialog({
          html: opts.html(),
          init: function(_arg) {
            var close, data, el, field, mask, _i, _len, _ref, _ref1;
            el = _arg.el, close = _arg.close;
            if (instance) {
              data = {};
              _ref = opts.fields;
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                field = _ref[_i];
                data[field] = instance.get(field);
              }
              UIHelpers.setInputData(el, data, opts.display);
              el.find('.delete').click(function() {
                instance["delete"]();
                return close();
              });
            }
            if (opts.mask) {
              _ref1 = opts.mask;
              for (field in _ref1) {
                mask = _ref1[field];
                el.find("[name=" + field + "]").inputmask(mask);
              }
            }
            el.find('input[type=submit]').click(function() {
              data = UIHelpers.inputData(el, opts.filter);
              if (instance) {
                instance.setProperties(data);
              } else {
                dataManager.model(opts.model).create(_.merge(data, {
                  user: g_userCont.get()
                }));
              }
              close();
              return false;
            });
            el.find('.cancel').click(close);
            return typeof opts.init === "function" ? opts.init(el) : void 0;
          }
        });
      };
    },
    editDialogBinding: function(html, model, fields, init) {
      if (init == null) {
        init = null;
      }
      return function(instance) {
        return UIHelpers.editDialog({
          html: html,
          model: model,
          fields: fields,
          instance: instance,
          init: (function(el) {
            return typeof init === "function" ? init(el, instance) : void 0;
          })
        })();
      };
    },
    openModelView: function(plate) {
      var component, el, frame, layer, modalBox;
      el = $('<div class="modalView"> <div class="header"> <a href="#" class="back" /> <div class="title" /> <a href="#" class="close" /> </div> <div class="client" /> </div>');
      el.find('.header .title').html(plate.title).css('backgroundImage', "url('app/images/" + plate.icon + "')");
      el.find('.client').html("<div class='" + plate["class"] + "'>" + plate.html + "</div>");
      el.find('.close').click(function() {
        modalBox.close();
        return false;
      });
      layer = new UILayer;
      component = new Component(layer, el.find('.client').children(':first'), plate.componentIniter);
      component.init();
      component.listen(function(signal) {
        if (signal === 'close') {
          return close();
        }
      });
      component.listen(plate.listener);
      modalBox = UIHelpers.showModalBox(el, {
        autoPositioned: false
      });
      frame = new UIFrame;
      if (typeof plate.initFrame === "function") {
        plate.initFrame(frame);
      }
      modalBox.layer.addLayer(layer);
      return frame.uiInited();
    }
  };
});

//# sourceMappingURL=UIHelpers.js.map
