// Generated by CoffeeScript 1.8.0
define(['xyzp/DataManager', 'xyzp/WebSocketTransport', 'xyzp/ObjectListAggregate', 'xyzp/XArray', 'xyzp/XValue', 'xyzp/CounterCall', 'app/DivvyDose', 'app/env'], function(DataManager, WebSocketTransport, ObjectListAggregate, XArray, XValue, CounterCall, DivvyDose, env) {
  return function() {
    var appApiServer, dbmsServer, getDevice, getSession, webSocketServer, _ref;
    Date.prototype.stdTimezoneOffset = function() {
      var jan, jul;
      jan = new Date(this.getFullYear(), 0, 1);
      jul = new Date(this.getFullYear(), 6, 1);
      return Math.max(jan.getTimezoneOffset(), jul.getTimezoneOffset());
    };
    Date.prototype.dst = function() {
      return this.getTimezoneOffset() < this.stdTimezoneOffset();
    };
    if (IS_MOBILE) {
      env = 'prod';
    }
    getDevice = function(cb) {
      var _device;
      _device = {
        token: window.g_deviceToken,
        platform: device.platform.toLowerCase()
      };
      if (_device.platform === 'ios') {
        return IDFVPlugin.getIdentifier(function(result) {
          _device.id = result;
          return cb(_device);
        });
      } else {
        _device.id = device.uuid;
        return cb(_device);
      }
    };
    getSession = function(cb) {
      if (IS_MOBILE) {
        return cb(JSON.parse(localStorage.getItem('session')));
      } else {
        return $.ajax("" + appApiServer + "/session.php", {
          xhrFields: {
            withCredentials: true
          },
          success: cb,
          error: function() {
            return console.log('error', arguments);
          }
        });
      }
    };
    _ref = (function() {
      switch (env) {
        case 'dev':
          return ['ws://127.0.0.1:8080', 'http://dbms.divvydose.dev', 'http://server.divvydose.dev/app/v1'];
        case 'remote-dev':
          return ['wss://dbms-dev.divvydose.com:8080', 'https://dbms-dev.divvydose.com', 'https://server-dev.divvydose.com/app/v1'];
        case 'prod':
          return ['wss://dbms.divvydose.com:8080', 'https://dbms.divvydose.com', 'https://server.divvydose.com/app/v1'];
      }
    })(), webSocketServer = _ref[0], dbmsServer = _ref[1], appApiServer = _ref[2];
    window.g_conf = {
      appApiServer: appApiServer,
      env: env
    };
    window.g_userId = null;
    window.g_userCont = new XValue(false).retain();
    window.g_signedInUserCont = new XValue(false).retain();
    g_userCont.observe(function() {
      var user;
      if (user = g_userCont.get()) {
        window.g_userId = user.id;
        user.set('timezone', new Date().stdTimezoneOffset());
        $('body').removeClass('singedOut').addClass('signedIn');
        return Raven.setUserContext({
          clientId: typeof dataManager !== "undefined" && dataManager !== null ? dataManager.clientId : void 0,
          userId: g_userId
        });
      } else {
        window.g_userId = null;
        $('body').addClass('signedOut').removeClass('signedIn');
        return Raven.setUserContext({
          clientId: typeof dataManager !== "undefined" && dataManager !== null ? dataManager.clientId : void 0
        });
      }
    });
    return {
      failedToConnect: function() {
        return $('body').append('<div id="notConnected"> <div><h3>Uh oh! Something\'s wrong...</h3>We were unable to establish a connection with our servers. If you have an active Internet connection, <a href="#" onclick="document.location.reload(); return false">please try reloading the page</a>. If that does not resolve the issue, <a target="_blank" href="https://www.divvydose.com/contact-us.html">contact customer support</a>, or try back again later. Sorry for the inconvenience!</div> </div>');
      },
      init: function(cb) {
        return getSession(function(response) {
          var userId;
          userId = response != null ? response.userId : void 0;
          if (userId) {
            g_userCont.set(dataManager.model('User').instance(userId));
            g_signedInUserCont.set(dataManager.model('User').instance(userId));
            woopra.identify({
              email: g_userCont.get().get('email')
            });
          } else {
            g_userCont.set(null);
          }
          return cb();
        });
      },
      dataManager: function(opts, cb) {
        return getSession(function(response) {
          var transport, _device;
          if (response) {
            window.g_token = response.token;
            transport = new WebSocketTransport(webSocketServer);
            _device = IS_MOBILE ? {
              token: window.g_deviceToken,
              id: device.uuid,
              platform: device.platform.toLowerCase()
            } : void 0;
            return cb(new DataManager('2', 'v1', 3, 'divvydose', '/user', dbmsServer, transport, {
              env: env,
              onClientId: function(clientId) {
                console.log(clientId);
                Raven.setUserContext({
                  clientId: clientId,
                  userId: g_userId
                });
                if (IS_MOBILE) {
                  console.log(_device);
                  if (!_device.token) {
                    if (window.g_deviceToken) {
                      _device.token = window.g_deviceToken;
                      return this.setClientParam('device', _device);
                    } else {
                      return window.__onGetDeviceToken = (function(_this) {
                        return function() {
                          _device.token = window.g_deviceToken;
                          return _this.setClientParam('device', _device);
                        };
                      })(this);
                    }
                  } else {
                    return this.setClientParam('device', _device);
                  }
                }
              },
              token: response.token,
              offline: opts.offline,
              client: {
                type: IS_MOBILE ? 'mobile' : 'web',
                timezone: new Date().stdTimezoneOffset(),
                dev: env === 'dev' ? true : void 0,
                device: _device,
                app: 'divvydose'
              },
              schemaMods: {
                models: {
                  Supplement: {
                    form: {
                      display: 'fullName'
                    },
                    attributes: {
                      fullName: {
                        type: 'computed',
                        get: function() {
                          if (this.get('name') === this.get('primaryName')) {
                            return this.get('name');
                          } else {
                            return "" + (this.get('name')) + " (" + (this.get('primaryName')) + ")";
                          }
                        }
                      }
                    }
                  },
                  SupplementStrength: {
                    form: {
                      display: 'name'
                    }
                  },
                  Prescription: {
                    attributes: {
                      nameWithoutFormat: {
                        type: 'computed',
                        get: function() {
                          if (this.get('name')) {
                            return DivvyDose.prescriptionNameWithoutFormat(this.get('name'));
                          }
                        }
                      },
                      format: {
                        type: 'computed',
                        get: function() {
                          return this.get('name').substr(this.get('nameWithoutFormat').length + 1);
                        }
                      }
                    },
                    scopes: {
                      regular: {
                        test: function(prescription) {
                          return prescription.get('packaging') === 'In A Packet';
                        }
                      },
                      asNeeded: {
                        test: function(prescription) {
                          return prescription.get('packaging') === 'Separate Bottle';
                        }
                      }
                    }
                  },
                  PrescriptionDose: {
                    attributes: {
                      quantityNumber: {
                        type: 'computed',
                        get: function() {
                          return parseInt(this.get('quantity'));
                        }
                      }
                    }
                  },
                  User: {
                    form: {
                      display: 'fullName'
                    },
                    relationships: {
                      prescriptions: {
                        scopes: {
                          regular: function(prescription) {
                            return prescription.get('packaging') === 'In A Packet';
                          },
                          asNeeded: function(prescription) {
                            return prescription.get('packaging') === 'Separate Bottle';
                          }
                        }
                      },
                      addresses: {
                        scopes: {
                          nonCurrent: function(address) {
                            return !address.get('isCurrent');
                          }
                        }
                      },
                      caregivers: {
                        onAdd: function(caregiver) {}
                      }
                    },
                    attributes: {
                      formattedPhoneNumber: {
                        type: 'computed',
                        get: function() {
                          var phoneNumber;
                          if (phoneNumber = this.get('phoneNumber')) {
                            return "" + (phoneNumber.substr(0, 3)) + "." + (phoneNumber.substr(3, 3)) + "." + (phoneNumber.substr(6));
                          }
                        }
                      },
                      current: {
                        type: 'computed',
                        get: function() {
                          return this === g_userCont.get();
                        }
                      },
                      fullName: {
                        type: 'computed',
                        get: function() {
                          return "" + (this.get('firstName')) + " " + (this.get('lastName'));
                        }
                      },
                      currentDivvyPack: {
                        type: 'computed',
                        get: function() {
                          var date, divvyPack, startDate, _ref1;
                          date = new Date().toLocalMysqlDateFormat();
                          if (this.get('divvyPacks')) {
                            _ref1 = this.get('divvyPacks');
                            for (startDate in _ref1) {
                              divvyPack = _ref1[startDate];
                              if (date >= startDate && date <= divvyPack.packets[divvyPack.packets.length - 1].time.substr(0, 10)) {
                                return divvyPack;
                              }
                            }
                          }
                        }
                      },
                      resolvedPicture: {
                        type: 'computed',
                        get: function() {
                          var _ref1;
                          return (_ref1 = this.get('picture')) != null ? _ref1 : 'app/images/profilePicturePlaceholder@2x.png';
                        }
                      }
                    }
                  },
                  Product: {
                    storage: {
                      localStorage: (IS_MOBILE ? 'productsDb' : void 0),
                      file: (IS_MOBILE ? 'app/products.json' : void 0),
                      remote: "" + dbmsServer + "/v1/core/main.php?db=divvydose&resource=/products"
                    },
                    attributes: {
                      inCart: {
                        type: 'computed',
                        get: function() {
                          if (g_userCont.get()) {
                            return g_userCont.get().get('shoppingCartItems').exists({
                              product: this
                            });
                          }
                        }
                      },
                      icon: {
                        type: 'computed',
                        get: function() {
                          if (this.get('type') === 'pack') {
                            return 'bioPod';
                          } else if (this.get('type') === 'item') {
                            if (this.get('size') === 'BOTTLE') {
                              return 'bottle';
                            } else if (this.get('size') === 'TUBE') {
                              return 'tube';
                            } else {
                              switch (this.get('format')) {
                                case 'CHEW':
                                  return 'chew';
                                case 'CHEWS':
                                  return 'chew';
                                case 'DROP':
                                  return 'drops';
                                case 'EYE DROP':
                                  return 'drops';
                                case 'PILL':
                                  return 'capsule';
                                case 'CAPSULE':
                                  return 'capsule';
                                case 'SPRAY':
                                  return 'spray';
                                case 'SUPPOSITORY':
                                  return 'suppository';
                                case 'TABLET':
                                  return 'tablet';
                              }
                            }
                          }
                        }
                      },
                      listingName: {
                        type: 'computed',
                        get: function() {
                          var dosePart, name;
                          if (this.get('type') === 'pack') {
                            return "<picture style='background-image: url(app/images/" + (this.get('icon')) + ".png)' /><span class='name'>" + (this.get('name')) + "</span>";
                          } else {
                            name = "<picture style='background-image: url(app/images/" + (this.get('icon')) + ".png)' /><span class='name'>" + (this.get('name')) + " (" + (this.get('primaryName')) + ")</span>";
                            dosePart = [];
                            if (this.get('dose')) {
                              dosePart.push(this.get('dose'));
                              if (this.get('size')) {
                                dosePart.push(this.get('size'));
                              }
                            }
                            if (dosePart.length) {
                              name += " <span class='dose'>" + (dosePart.join(' &mdash; ')) + "</span>";
                            }
                            return name;
                          }
                        }
                      },
                      unitPrice: {
                        type: 'computed',
                        parameters: true,
                        get: function(packaging) {
                          var parts, price;
                          if (this.get('type') === 'pack') {
                            return "$" + (this.get('computedPrice')) + " per day";
                          } else {
                            price = this.get('computedPrice', packaging);
                            parts = price.toString().split('.');
                            if (parts[1] == null) {
                              parts[1] = '';
                            }
                            price = "" + parts[0] + "." + (parts[1].substr(0, 2).padRight(2, 0));
                            return "<span class='value'>$" + price + "</span>/" + (packaging === 'Bottle' ? "bottle (" + (this.get('size')) + " " + (this.get('format').toLowerCase()) + "s)" : this.get('format').toLowerCase());
                          }
                        }
                      },
                      computedPrice: {
                        type: 'computed',
                        parameters: true,
                        get: function(packaging) {
                          var price;
                          return parseFloat(this.get('type') === 'pack' ? this.get('price') : price = packaging === 'Bottle' ? this.get('options') === 'U' ? this.get('price') * this.get('size') : this.get('price') : this.get('price'));
                        }
                      },
                      titleName: {
                        type: 'computed',
                        get: function() {
                          if (this.get('type') === 'pack') {
                            return "<span class='name'>" + (this.get('name')) + "</span>";
                          } else {
                            return "<span class='name'>" + (this.get('name')) + " (" + (this.get('primaryName')) + ")</span>";
                          }
                        }
                      }
                    }
                  },
                  ShoppingCartItem: {
                    attributes: {
                      unitPrice: {
                        type: 'computed',
                        get: function() {
                          return this.get('product').get('unitPrice', this.get('options').packaging);
                        }
                      },
                      computedPrice: {
                        type: 'computed',
                        get: function() {
                          return this.get('product').get('computedPrice', this.get('options').packaging);
                        }
                      },
                      dailyPrice: {
                        type: 'computed',
                        get: function() {
                          return DivvyDose.dailyProductPrice(this.get('product'), this.get('options'));
                        }
                      },
                      monthlyPrice: {
                        type: 'computed',
                        get: function() {
                          return DivvyDose.monthlyProductPrice(this.get('product'), this.get('options'));
                        }
                      }
                    }
                  },
                  MedicineLogEntry: {
                    attributes: {
                      event: {
                        forms: {
                          display: function() {
                            if (this.get('event') === 'taken') {
                              return 'Taken';
                            } else {
                              return 'Not Taken';
                            }
                          }
                        }
                      },
                      eventDisplay: {
                        type: 'computed',
                        get: function() {
                          if (this.get('event') === 'taken') {
                            return 'Taken';
                          } else {
                            return 'Not Taken';
                          }
                        }
                      }
                    }
                  },
                  Address: {
                    attributes: {
                      isCurrent: {
                        type: 'computed',
                        get: function() {
                          return this.get('user') && this === this.get('user').get('currentAddress');
                        },
                        set: function(v) {
                          if (v) {
                            if (!this.get('isCurrent')) {
                              return this.get('user').set('currentAddress', this);
                            }
                          } else {
                            if (this.get('isCurrent')) {
                              return this.get('user').set('currentAddress', null);
                            }
                          }
                        }
                      }
                    }
                  },
                  Insurance: {
                    attributes: {
                      isCurrent: {
                        type: 'computed',
                        get: function() {
                          return this.get('user') && this === this.get('user').get('currentInsurance');
                        },
                        set: function(v) {
                          if (v) {
                            if (!this.get('isCurrent')) {
                              return this.get('user').set('currentInsurance', this);
                            }
                          } else {
                            if (this.get('isCurrent')) {
                              return this.get('user').set('currentInsurance', null);
                            }
                          }
                        }
                      }
                    }
                  },
                  PaymentMethod: {
                    attributes: {
                      numberDisplay: {
                        type: 'computed',
                        get: function() {
                          var i, placeholders, str, _i;
                          if (this.get('number')) {
                            placeholders = this.get('number').length - 4;
                            str = '';
                            for (i = _i = 0; 0 <= placeholders ? _i < placeholders : _i > placeholders; i = 0 <= placeholders ? ++_i : --_i) {
                              str += '*';
                            }
                            str += this.get('number').substr(placeholders);
                            return str;
                          } else {
                            return '';
                          }
                        }
                      },
                      isCurrent: {
                        type: 'computed',
                        get: function() {
                          return this.get('user') && this === this.get('user').get('currentPaymentMethod');
                        },
                        set: function(v) {
                          if (v) {
                            if (!this.get('isCurrent')) {
                              return this.get('user').set('currentPaymentMethod', this);
                            }
                          } else {
                            if (this.get('isCurrent')) {
                              return this.get('user').set('currentPaymentMethod', null);
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }));
          } else {
            return cb();
          }
        });
      }
    };
  };
});

//# sourceMappingURL=config.js.map
