// Generated by CoffeeScript 1.8.0
define(['xyzp/XValue', 'xyzp/ComputedValue', 'xyzp/UILayer', 'app/DivvyDose'], function(XValue, ComputedValue, UILayer, DivvyDose) {
  return function(productObj) {
    return function() {
      var getData, layer, number, packetTimes, t, time, times, viewEl, _i, _len, _ref, _ref1, _ref2;
      viewEl = this.el;
      window.productLayer = layer = this.layer;
      getData = function() {
        var data, packetTimes;
        data = {};
        if (productObj.get('type') === 'pack') {
          data = {
            quantity: layer.value('quantity').get()
          };
        } else {
          data = {
            packaging: layer.value('packaging').get()
          };
          if (data.packaging === 'divvyPACK') {
            data.frequency = layer.value('frequency').get();
            if (data.frequency === 'on specific days') {
              data.specificDays = {
                sunday: !!layer.value('onSunday').get(),
                monday: !!layer.value('onMonday').get(),
                tuesday: !!layer.value('onTuesday').get(),
                wednesday: !!layer.value('onWednesday').get(),
                thursday: !!layer.value('onThursday').get(),
                friday: !!layer.value('onFriday').get(),
                saturday: !!layer.value('onSaturday').get()
              };
            }
            packetTimes = [];
            layer.value('packetTimes').each(function(packetTime) {
              return packetTimes.push({
                time: packetTime.time.get(),
                quantity: packetTime.quantity.get()
              });
            });
            data.packetTimes = packetTimes;
          } else if (data.packaging === 'Bottle') {
            data.autoRefill = !!layer.value('autoRefill').get();
          }
        }
        return data;
      };
      layer.value('frequency').set('every day');
      switch (productObj.get('type')) {
        case 'pack':
          layer.value('quantity').set(1);
          break;
        case 'item':
          if ((_ref = productObj.get('options')) === 'P' || _ref === 'U') {
            layer.value('packaging').set('divvyPACK');
            if (productObj.get('sig') !== '') {
              _ref1 = productObj.get('sig').split(' '), number = _ref1[0], time = _ref1[1];
              number = parseInt(number[1]);
              times = {
                QD: ['8:00AM'],
                BID: ['8:00AM', '8:00PM'],
                QHS: ['10:00PM'],
                TID: ['8:00AM', '12:00AM', '8:00PM']
              };
              packetTimes = [];
              _ref2 = times[time];
              for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
                t = _ref2[_i];
                packetTimes.push({
                  time: new XValue(t).retain(),
                  quantity: new XValue(number).retain()
                });
              }
              layer.list('packetTimes').setArray(packetTimes);
            } else {
              layer.list('packetTimes').setArray([
                {
                  time: new XValue('8:00AM').retain(),
                  quantity: new XValue(1).retain()
                }
              ]);
            }
          } else if (productObj.get('options') === 'B') {
            layer.value('packaging').set('Bottle');
          }
      }
      layer.value('autoRefill').set(true);
      layer.withValue(layer.value('packaging'), function(packaging) {
        viewEl.find('.packaging .selected').removeClass('selected');
        return viewEl.find(".packaging [data-value='" + packaging + "']").addClass('selected');
      });
      viewEl.find('picture').css('backgroundImage', "url(app/images/" + (productObj.get('icon')) + ".png)");
      layer.addLayerProvider('showMore', function(layer, _arg) {
        var el, longText, shortText;
        el = _arg.el, longText = _arg.longText, shortText = _arg.shortText;
        layer["if"]((function() {
          return shortText.get() && longText.get();
        }), function(l) {
          var shortTextLayer, showMoreEl, valueEl;
          valueEl = $('<span />');
          shortTextLayer = l.addLayer(new UILayer);
          showMoreEl = $('<a href="#">Show More</a>').click(function() {
            shortTextLayer.destruct();
            l.withValue(longText, function(longText) {
              return valueEl.html(longText);
            });
            return false;
          });
          l.addHtml(el, valueEl);
          shortTextLayer.addHtml(el, showMoreEl);
          return shortTextLayer.withValue(shortText, function(shortText) {
            return valueEl.html(shortText);
          });
        });
        return layer["if"]((function() {
          return !shortText.get() || !longText.get();
        }), function(l) {
          var text, valueEl;
          valueEl = $('<span />');
          text = shortText.get() ? shortText : longText;
          l.addHtml(el, valueEl);
          return l.withValue(text, function(text) {
            return valueEl.html(text);
          });
        });
      });
      layer.bind(viewEl, {
        product: productObj,
        addMedicationTotal: (new ComputedValue(function() {
          var quantity;
          return '$' + parseFloat((function() {
            switch (productObj.get('type')) {
              case 'pack':
                return productObj.get('price') * layer.value('quantity').get();
              case 'item':
                switch (layer.value('packaging').get()) {
                  case 'divvyPACK':
                    quantity = 0;
                    layer.value('packetTimes').each(function(packetTime) {
                      return quantity += parseInt(packetTime.quantity.get());
                    });
                    return quantity * productObj.get('price');
                  case 'Bottle':
                    return (productObj.get('computedPrice', layer.value('packaging').get())) / 28;
                }
            }
          })()).format(2) + '/day';
        })).retain()
      }, {
        '%packetTimes': {
          "delete": function(el, _arg) {
            var packetTime;
            packetTime = _arg[0];
            return layer.list('packetTimes').remove(packetTime);
          },
          quantityOptions: function() {
            return [
              {
                count: 1,
                label: "1 " + (productObj.get('format'))
              }, {
                count: 2,
                label: "2 " + (productObj.get('format'))
              }, {
                count: 3,
                label: "3 " + (productObj.get('format'))
              }, {
                count: 4,
                label: "4 " + (productObj.get('format'))
              }, {
                count: 5,
                label: "5 " + (productObj.get('format'))
              }, {
                count: 6,
                label: "6 " + (productObj.get('format'))
              }, {
                count: 7,
                label: "7 " + (productObj.get('format'))
              }, {
                count: 8,
                label: "8 " + (productObj.get('format'))
              }
            ];
          }
        },
        addPacketTime: function() {
          return layer.list('packetTimes').push({
            time: new XValue('8:00AM'),
            quantity: new XValue(1)
          });
        },
        quantityOptions: function() {
          return ["28 " + (productObj.get('format')), "56 " + (productObj.get('format')), "84 " + (productObj.get('format')), "112 " + (productObj.get('format'))];
        },
        addToCart: function() {
          var data;
          data = getData();
          dataManager.model('ShoppingCartItem').create({
            user: g_userCont.get(),
            product: productObj,
            options: data
          });
          if (!rootFrame.isMobile()) {
            return setTimeout((function() {
              return DivvyDose.productAddedToCartMessage();
            }), 0);
          }
        },
        checkout: (function(_this) {
          return function() {
            return DivvyDose.orderProducts([
              {
                product: productObj,
                options: getData()
              }
            ]);
          };
        })(this)
      });
      if (productObj.get('options') === 'U') {
        return viewEl.find('.packaging .option').click(function() {
          return layer.value('packaging').set($(this).attr('data-value'));
        });
      } else {
        return viewEl.find('.packaging').addClass('disabled');
      }
    };
  };
});

//# sourceMappingURL=productComponent.js.map
