// Generated by CoffeeScript 1.8.0
define(['xyzp/FilteredArray'], function(FilteredArray) {
  return function() {
    var component, layer, viewEl;
    viewEl = this.el;
    layer = this.layer;
    layer.value('addMedication');
    layer.addElement(viewEl.find('.search'), 'addMedication');
    layer.addElementBinding('addMedication', 'addMedication');
    viewEl.find('.search').keydown((function(_this) {
      return function(e) {
        var addMedication, supplement;
        if (e.keyCode === 13) {
          supplement = (addMedication = layer.layer('addMedication')) ? addMedication.selectedSupplement() : void 0;
          if (supplement) {
            _this.signal('itemSelected', supplement);
          }
        }
        return true;
      };
    })(this));
    layer.addLayerValueBinding('addMedication', (function(el) {
      return viewEl.find('.search').after(el);
    }), [
      function(value) {
        if (value) {
          return 'addMedication';
        }
      }
    ]);
    component = this;
    layer.addLayerProvider('addMedication', function(layer) {
      var filteredProducts, listInterface, pattern;
      pattern = function() {
        return new RegExp("\\b(" + (layer.parent.value('addMedication').get().replace(/\\/g, '\\\\')) + ")", 'i');
      };
      layer.value('selected').set(0);
      filteredProducts = new FilteredArray(dataManager.model('Product'), function(product) {
        if (product.get('type') === 'pack') {
          return product.get('name').match(pattern());
        } else {
          if (product.get('name').match(pattern()) || product.get('primaryName').match(pattern())) {
            return true;
          } else if (product.get('keywords')) {
            if (product.get('keywords').match(pattern())) {
              return true;
            }
          } else {
            return false;
          }
        }
      });
      listInterface = null;
      layer.selectedSupplement = function() {
        return filteredProducts.get(layer.value('selected').get());
      };
      layer.bindEvent(viewEl.find('.search'), 'keydown', function(e) {
        var _ref, _ref1;
        switch (e.keyCode) {
          case 38:
            layer.value('selected').set(((((_ref = layer.value('selected').get()) != null ? _ref : 0) - 1) + filteredProducts.length()) % filteredProducts.length());
            return false;
          case 40:
            layer.value('selected').set(((((_ref1 = layer.value('selected').get()) != null ? _ref1 : 0) + 1) + filteredProducts.length()) % filteredProducts.length());
            return false;
          default:
            return true;
        }
      });
      layer.remove = function() {
        this.destruct();
        return this.el.remove();
      };
      return layer.insert = function(insert) {
        this.el = $('<div class="searchResults"><h2>Search Results</h2><ul><li class="productListing"></li></ul></div>');
        layer.bindList(filteredProducts, this.el, 'li', function(el, data, _arg) {
          var elLayer, index;
          index = _arg.index, elLayer = _arg.layer;
          el.click(function() {
            return component.signal('itemSelected', data);
          });
          elLayer.withValue(layer.value('selected'), function(selected) {
            if (selected === index) {
              return el.addClass('selected');
            } else {
              return el.removeClass('selected');
            }
          });
          el.html(data.get('listingName'));
          return el;
        });
        return insert(this.el);
      };
    });
    layer.bind(this.el, {
      recommendations: (function(_this) {
        return function() {
          return _this.signal('recommendations');
        };
      })(this),
      topSelling: (function(_this) {
        return function() {
          return _this.signal('topSelling');
        };
      })(this),
      categories: (function(_this) {
        return function() {
          return _this.signal('categories');
        };
      })(this)
    });
    return this.el.find('.search').get(0).focus();
  };
});

//# sourceMappingURL=rootComponent.js.map
