// Generated by CoffeeScript 1.8.0
var __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

define(['xyzp/UILayer', 'app/UIFrame', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'xyzp/FormattedValue', 'xyzp/ObjectListAggregate', 'app/Component', 'app/MobileNav', 'app/Breakpoints', 'app/UIHelpers'], function(UILayer, UIFrame, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool, FormattedValue, ObjectListAggregate, Component, MobileNav) {
  var Breakpoints, UIHelpers, initMobile;
  Breakpoints = require('app/Breakpoints');
  UIHelpers = require('app/UIHelpers');
  document.addEventListener('animationstart', function(event) {
    var el;
    if (event.animationName === 'inserted') {
      el = $(event.target);
      if (el.is('select.hasLabel')) {
        if (event.target.selectedIndex === 0) {
          $(event.target).addClass('label');
        } else {
          $(event.target).removeClass('label');
        }
        return $(event.target).change(function() {
          if (this.selectedIndex === 0 && ($(this).val() === '' || $(this).val() === null)) {
            return $(this).addClass('label');
          } else {
            return $(this).removeClass('label');
          }
        });
      } else if (el.is('a[target="_blank"]')) {
        if (IS_MOBILE) {
          return el.click(function() {
            window.open($(this).attr('href'), '_system');
            return false;
          });
        }
      }
    }
  });
  initMobile = function() {
    var timerId, userChanged;
    woopra.track('openedDivvyApp');
    window.getSchedule = function() {
      var divvyPack, dose, times, _i, _len, _ref;
      if (g_signedInUserCont.get()) {
        divvyPack = g_signedInUserCont.get().get('currentDivvyPack');
        if (divvyPack) {
          times = {};
          _ref = divvyPack.packets;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            dose = _ref[_i];
            times[dose.time] = true;
          }
          return _.keys(times).sort();
        } else {
          return [];
        }
      } else {
        return [];
      }
    };
    window.scheduleNotification = function(at, time, cb) {
      console.log('scheduleNotification', at, time);
      return cordova.plugins.notification.local.schedule({
        id: at.getTime(),
        at: at,
        text: "Time for your " + (Date.create(time).format('{12hr}:{mm}{TT}')) + " divvyPACK ;)",
        title: g_signedInUserCont.get().get('fullName'),
        data: time
      }, cb);
    };
    window.scheduleLocalNotifications = function() {
      if (IS_MOBILE) {
        return cordova.plugins.notification.local.cancelAll(function() {
          var i, s, times;
          times = DivvyDose.nextTimes(64);
          i = 0;
          s = function() {
            var time;
            if (i < times.length) {
              time = times[i++];
              if (!dataManager.model('MedicineLogEntry').findOne({
                time: time.toLocalMysqlFormat()
              })) {
                return scheduleNotification(time, time.toLocalMysqlFormat(), s);
              }
            }
          };
          return s();
        });
      }
    };
    onPushNotification(function(event) {
      var notification, snd, _ref;
      window.notificationEvent = event;
      notification = null;
      if ((_ref = device.platform) === 'android' || _ref === 'Android') {
        if (event.event === 'message') {
          notification = {
            foreground: event.foreground,
            message: event.message,
            time: event.payload.time,
            type: event.payload.type
          };
        }
      } else {
        notification = {
          foreground: event.foreground === '1',
          message: event.body,
          time: event.time,
          type: event.type
        };
      }
      console.log(notification);
      if (notification) {
        if (notification.foreground) {
          if (notification.message) {
            if (notification.type === 'reminder') {
              showConfirmBox({
                text: notification.message,
                action: function(action) {
                  return DivvyDose.log(notification.time, action === 'Taken' ? 'taken' : 'notTaken');
                }
              });
            } else {
              navigator.notification.alert(notification.message, (function() {}), 'divvyDOSE');
            }
          }
          if (notification.sound) {
            snd = new Media(notification.sound);
            snd.play();
          }
          if (notification.badge) {
            return plugins.pushNotification.setApplicationIconBadgeNumber((function() {}), (function() {}), notification.badge);
          }
        } else {
          showDoseConfirmation();
          DivvyDose.log(notification.time, 'taken');
          return scheduleLocalNotifications();
        }
      }
    });
    onLocalNotification(function(event, notification) {
      console.log(event, notification);
      setTimeout(scheduleLocalNotifications, 1000);
      window.notification = notification;
      if (event === 'trigger') {
        return showConfirmBox({
          text: notification.text,
          action: function(action) {
            return DivvyDose.log(notification.data, action === 'Taken' ? 'taken' : 'notTaken');
          }
        });
      } else if (event === 'click') {
        showDoseConfirmation();
        return DivvyDose.log(notification.data, 'taken');
      }
    });
    window.updateClientSchedule = function() {
      console.log('update schedule', getSchedule());
      return dataManager.setClientParam('schedule', getSchedule());
    };
    timerId = null;
    window.callUpdateClientSchedule = function() {
      clearTimeout(timerId);
      return setTimeout((function() {
        updateClientSchedule();
        return scheduleLocalNotifications();
      }), 0);
    };
    window.observePool = new ObservePool().retain();
    userChanged = function() {
      observePool.allStopObserving();
      if (g_userCont.get()) {
        observePool.observe(g_userCont.get().prop('divvyPacks'), callUpdateClientSchedule);
        return callUpdateClientSchedule();
      }
    };
    return userChanged();
  };
  window.g_mobileNav = new MobileNav;
  return function() {
    var GET, backButtonCbs, backButtonLayer, breakpoints, mainTemplate, pages, updateMenu;
    GET = (function(a) {
      var b, i, p;
      if (a === '') {
        return {};
      }
      b = {};
      i = 0;
      while (i < a.length) {
        p = a[i].split('=', 2);
        if (p.length === 1) {
          b[p[0]] = '';
        } else {
          b[p[0]] = decodeURIComponent(p[1].replace(/\+/g, ' '));
        }
        ++i;
      }
      return b;
    })(window.location.search.substr(1).split('&'));
    window.showDoseConfirmation = function() {
      return window._showDoseConfirmation = true;
    };
    if (IS_MOBILE) {
      initMobile();
    }
    pages = ['dashboard', 'medications', 'billing', 'calendar', 'history', 'shipping', 'account', 'caregivers', 'contact', 'charts', 'divvymarket'];
    backButtonLayer = null;
    backButtonCbs = [];
    window.pushBackButton = function(cb) {
      var el;
      if (backButtonCbs.length === 0) {
        backButtonLayer = rootLayer.addLayer(new UILayer);
        backButtonLayer.addDestructFunc(function() {
          return backButtonCbs = [];
        });
        backButtonLayer.addClass($('body'), 'backButton');
        el = $('<div class="backButton" />');
        backButtonLayer.addHtml($('.headerWrapper'), el);
        backButtonLayer.bindEvent(el, 'click', function() {
          backButtonCbs.pop()();
          if (!backButtonCbs.length) {
            return backButtonLayer.destruct();
          }
        });
      }
      return backButtonCbs.push(cb);
    };
    window.breakpoints = breakpoints = new Breakpoints;
    breakpoints.addBreakpoints('main', {
      614: {
        name: 'mobile',
        init: function(layer) {
          var menuLayer;
          layer.addHtml($('.headerWrapper'), '<a href="#" class="menu" />');
          menuLayer = null;
          return $('.headerWrapper .menu').click(function() {
            var menuEl, p, _fn, _i, _len;
            if (menuLayer) {
              menuLayer.destruct();
            } else {
              menuLayer = new UILayer;
              menuLayer.on('destruct', function() {
                return menuLayer = null;
              });
              menuLayer.addClass($('.headerWrapper .menu'), 'open');
              layer.addLayer(menuLayer);
              menuEl = $('<div class="menu" />');
              menuLayer.addHtml($('body'), menuEl);
              menuEl.append($('header .nav').children().clone());
              _fn = function(p) {
                menuLayer["if"]((function() {
                  return rootLayer.value('page').get() === p;
                }), function(l) {
                  return l.addClass(menuEl.find('.' + p), 'active');
                });
                return menuEl.find('.' + p).click(function() {
                  rootLayer.value('page').set(p);
                  menuLayer.destruct();
                  return false;
                });
              };
              for (_i = 0, _len = pages.length; _i < _len; _i++) {
                p = pages[_i];
                _fn(p);
              }
            }
            return false;
          });
        }
      }
    });
    breakpoints.onBreakpointChanged = function(currentBreakpoint, previousBreakpoint) {
      if (currentBreakpoint === 614 || previousBreakpoint === 614) {
        return rebuildUI();
      }
    };
    window.showConfirmBox = function(opts) {
      var contEl, _ref;
      if (opts == null) {
        opts = {};
      }
      contEl = $("<div class=\"dialogBoxWrapper\"><div class=\"dialogBox\">\n	<p>" + ((_ref = opts.text) != null ? _ref : 'asdf') + "</p>\n	<div class=\"actions\">\n		<button>Taken</button>\n		<button>Not Taken</button>\n	</div>\n</div></div>");
      contEl.find('.actions button').click(function() {
        opts.action($(this).html());
        return contEl.fadeOut(function() {
          return contEl.remove();
        });
      });
      return contEl.appendTo('body');
    };
    updateMenu = function() {
      var el, hidden, i, last, moreEl, moreMenuEl, navItemEls, _i, _j, _len, _ref;
      if ($('body').hasClass('signedIn')) {
        moreEl = $('header .nav li.more');
        navItemEls = $('header .nav li:not(.more)');
        navItemEls.show();
        moreMenuEl = $('header .topBar .moreMenu');
        last = $(navItemEls[navItemEls.length - 1]);
        hidden = [];
        if (last.offset().left + last.width() > $(window).width() - 10) {
          moreEl.show();
          for (i = _i = _ref = navItemEls.length - 1; _ref <= 0 ? _i <= 0 : _i >= 0; i = _ref <= 0 ? ++_i : --_i) {
            if (moreEl.offset().left + moreEl.width() > $(window).width() - 10) {
              $(navItemEls[i]).hide();
              hidden.unshift(navItemEls[i]);
            } else {
              break;
            }
          }
        } else {
          moreEl.hide();
        }
        moreMenuEl.html('');
        for (_j = 0, _len = hidden.length; _j < _len; _j++) {
          el = hidden[_j];
          moreMenuEl.append("<a href='#' data-page='" + ($(el).attr('data-page')) + "'>" + ($(el).find('a').html()) + "</a>");
        }
        moreMenuEl.find('a').click(function() {
          rootLayer.value('page').set($(this).attr('data-page'));
          $('header').removeClass('showMoreMenu');
          return false;
        });
        return moreMenuEl.css({
          left: moreEl.offset().left + moreEl.width() - moreMenuEl.outerWidth() - $('header .topBar').offset().left + 10,
          top: moreEl.offset().top + moreEl.height() - 10 - $('header .topBar').offset().top
        });
      }
    };
    window.rootFrame = new UIFrame;
    rootFrame.isMobile = function() {
      return $('body').hasClass('breakpoint-614');
    };
    rootFrame.setupUI(function(_arg) {
      var context, id, params;
      context = _arg.context, id = _arg.id, params = _arg.params;
      if (__indexOf.call(pages, id) >= 0) {
        this.slot('page');
        rootLayer.value('page').set(id);
        true;
      } else if (id === 'shoppingCart') {
        DivvyDose.openShoppingCart();
        true;
      }
      return false;
    });
    window.rebuildUI = function() {
      var chain, doShift, frame;
      chain = _.clone(rootFrame.chain);
      rootFrame.chain = [];
      rootFrame.destroyUI();
      rootFrame.initUI();
      frame = rootFrame;
      doShift = function(frame, linkNumber) {
        if (chain[linkNumber]) {
          return frame.shift(chain[linkNumber].id, chain[linkNumber].params, linkNumber, function(f) {
            return doShift(f, linkNumber + 1);
          });
        } else {
          rootFrame.chain = chain;
          return frame.reenter();
        }
      };
      return doShift(rootFrame, 0);
    };
    rootFrame.onDestroyUI(function() {
      return rootLayer.destruct();
    });
    rootFrame.onInitUI(function() {
      var resizeTimer;
      window.rootLayer = new UILayer;
      rootLayer.el = $('body');
      rootLayer.addHtml(rootLayer.el, mainTemplate);
      rootLayer.value('page');
      resizeTimer = null;
      rootLayer.bindEvent($(window), 'resize', function() {
        clearTimeout(resizeTimer);
        return resizeTimer = setTimeout((function() {
          breakpoints.update();
          if (breakpoints.currentBreakpoint !== 614) {
            return updateMenu();
          }
        }), 50);
      });
      rootLayer.globalScope = {
        signedInUser: g_signedInUserCont,
        setUser: function(user) {
          g_userCont.set(user);
          return rootLayer.value('showUserDropdown').set(false);
        },
        setPage: function(page) {
          return rootLayer.value('page').set(page);
        },
        id: function(instance, name) {
          return "" + instance.id + "_" + name;
        }
      };
      rootLayer.addValueFormatter(function(value, _arg) {
        var context, type;
        context = _arg.context, type = _arg.type;
        if (context === 'editing') {
          if ((value == null) || _.isNaN(value)) {
            return '';
          }
        } else {
          if ((value == null) || _.isNaN(value) || value === '') {
            return '';
          }
        }
        if (type === 'duration') {
          if (value) {
            if (value < 0) {
              return 'negative ' + juration.stringify(-value);
            } else {
              return juration.stringify(value);
            }
          } else if (context !== 'editing') {
            return 'nothing';
          }
        } else if (type === 'date') {
          return value.format('{Mon} {ord}, {year}');
        }
      });
      rootLayer.addLayerProvider('value', function(layer, params) {
        layer.el = params.el;
        layer.addClass(layer.el, 'attribute');
        layer.value('editing').set(false);
        layer.addCss(layer.el, {
          position: 'relative'
        });
        return layer["switch"]('editing', [
          false, function(l) {
            l.bindValue(layer.el, params.value);
            return l.bindEvent(layer.el, 'click', function(e) {
              return layer.value('editing').set(true);
            });
          }, true, function(l) {
            var inputEl, list;
            inputEl = l.addHtml(layer.el, '<input type="text">');
            inputEl.attr('placeholder', params.title);
            inputEl.val(layer.formatValue(params.value.get(), {
              context: 'editing',
              type: util.type(params.value)
            }));
            inputEl.get(0).select();
            if (params.value.meta('type') instanceof Model) {
              layer.el.find('input').keydown(function(e) {
                if (e.keyCode === 27) {
                  return layer.value('editing').set(false);
                }
              });
              list = params.value.meta('type');
              l.value('inputValue').set(params.value.form('display').get());
              setTimeout(((function(_this) {
                return function() {
                  return inputEl.get(0).select();
                };
              })(this)), 0);
              l.bindValue(inputEl, l.value('inputValue'));
              return l["if"]((function() {
                return l.value('inputValue').get();
              }), function(l2) {
                var filteredList, listEl, pattern;
                pattern = function() {
                  return new RegExp("\\b(" + (l.value('inputValue').get().replace(/\\/g, '\\\\')) + ")", 'i');
                };
                filteredList = new FilteredArray(list, function(instance) {
                  if (instance.form('display').get()) {
                    return instance.form('display').get().match(pattern());
                  }
                });
                layer.observe(l.value('inputValue'), function() {
                  return filteredList.update();
                });
                listEl = $("<ul class=\"autoSuggest\" bind-list=\"list\">\n	<li bind-value=\"inputValue\" />\n	<li bind />\n</ul>");
                l2.value('selected').set(1);
                l2.bind(listEl, {
                  list: filteredList,
                  inputValue: l.value('inputValue')
                }, {
                  'list.init': function(el, _arg, _arg1) {
                    var index, instance, l3;
                    instance = _arg[0];
                    l3 = _arg1.layer, index = _arg1.index;
                    l3.withValue(l2.value('selected'), function(selected) {
                      if (selected - 1 === index) {
                        return el.addClass('selected');
                      } else {
                        return el.removeClass('selected');
                      }
                    });
                    return l3.withValue(instance.form('display'), function(display) {
                      return el.html(display.replace(pattern(), "<b>$1</b>"));
                    });
                  }
                });
                l2.withValue(l2.value('selected'), function(selected) {
                  if (selected === 0) {
                    return listEl.find('li:first').addClass('selected');
                  } else {
                    return listEl.find('li:first').removeClass('selected');
                  }
                });
                l2.addHtml(layer.el, listEl);
                listEl.css({
                  position: 'absolute',
                  left: 0,
                  zIndex: 1
                });
                return l2.bindEvent(inputEl, 'keydown', function(e) {
                  var length, selected, _ref, _ref1;
                  length = filteredList.length() + 1;
                  switch (e.keyCode) {
                    case 38:
                      l2.value('selected').set(((((_ref = l2.value('selected').get()) != null ? _ref : 0) - 1) + length) % length);
                      return false;
                    case 40:
                      l2.value('selected').set(((((_ref1 = l2.value('selected').get()) != null ? _ref1 : 0) + 1) + length) % length);
                      return false;
                    case 13:
                      selected = l2.value('selected').get();
                      if (selected === 0 || !filteredList.get(selected - 1)) {
                        params.value.set(list.call('byDisplay', l2.value('inputValue').get()));
                      } else {
                        params.value.set(filteredList.get(selected - 1));
                      }
                      layer.value('editing').set(false);
                      return false;
                    default:
                      return true;
                  }
                });
              });
            } else {
              return layer.el.find('input').keydown(function(e) {
                if (e.keyCode === 27) {
                  return layer.value('editing').set(false);
                } else if (e.keyCode === 13) {
                  params.value.set(inputEl.val());
                  return layer.value('editing').set(false);
                }
              });
            }
          }
        ]);
      });
      if (typeof _showDoseConfirmation === "undefined" || _showDoseConfirmation === null) {
        rootLayer.el.find('.doseConfirmationWrapper').hide();
      } else {
        delete window._showDoseConfirmation;
      }
      window.showDoseConfirmation = function() {
        return rootLayer.el.find('.doseConfirmationWrapper').show();
      };
      rootLayer.el.find('.doseConfirmationWrapper').click(function() {
        rootLayer.el.find('.doseConfirmationWrapper').fadeOut(350);
        return false;
      });
      breakpoints.update(true);
      rootLayer.bind(rootLayer.el, {
        flashMessage: new XValue(GET.resetpassword ? 'Password was successfully reset.' : void 0),
        rootLayer: function() {
          return rootLayer;
        },
        toggleUserDropdown: function() {
          return rootLayer.value('showUserDropdown').set(!rootLayer.value('showUserDropdown').get());
        },
        user: g_userCont,
        signedInUser: g_signedInUserCont,
        signedOutInit: function() {
          return breakpoints.update();
        },
        exitCaregiverMode: function() {
          return g_userCont.set(g_signedInUserCont.get());
        },
        shoppingCart: function() {
          return rootFrame.navigate('shoppingCart');
        },
        main: function() {
          var firstPage, p, page, params, _i, _len;
          firstPage = true;
          page = function(name) {
            return [
              name, function(l) {
                var frame, pageEl;
                breakpoints.removeBreakpoints('page');
                frame = rootFrame.createSubFrame();
                pageEl = $('<main />');
                if (!firstPage) {
                  pageEl.hide();
                }
                l.el = pageEl;
                l.addHtml($('.mainWrapper'), pageEl);
                l.addClass($('html'), "" + name + "-page");
                l.addClass($(".nav ." + name), 'active');
                l.addFrame(frame);
                return require(["app/pages/" + name], function(page) {
                  var onDone;
                  onDone = function() {
                    breakpoints.update(true);
                    updateMenu();
                    if (firstPage) {
                      firstPage = false;
                    } else {
                      pageEl.fadeIn(200);
                    }
                    return frame.uiInited();
                  };
                  pageEl.removeData('bindVisited');
                  if (_.isFunction(page)) {
                    page(frame, l, onDone);
                  } else {
                    if (page.breakpoints) {
                      breakpoints.addBreakpoints('page', page.breakpoints);
                    }
                    page.init(frame, l, onDone);
                  }
                  return window.pageLayer = l;
                });
              }
            ];
          };
          params = [];
          for (_i = 0, _len = pages.length; _i < _len; _i++) {
            p = pages[_i];
            params = params.concat(page(p));
          }
          return rootLayer["if"]((function() {
            return g_userCont.get();
          }), function(layer) {
            var _fn, _j, _len1;
            _fn = function(p) {
              return $('.nav .' + p).click(function() {
                rootFrame.navigate(p);
                $('header').removeClass('showMoreMenu');
                return false;
              });
            };
            for (_j = 0, _len1 = pages.length; _j < _len1; _j++) {
              p = pages[_j];
              _fn(p);
            }
            layer["switch"]('page', params);
            return layer.withValue(rootLayer.value('page'), function(page) {
              return woopra.track('appPageView', {
                page: page
              });
            });
          });
        },
        signIn: function() {
          var data;
          data = UIHelpers.inputData($('#signIn'));
          return $.ajax((IS_MOBILE ? "" + g_conf.appApiServer + "/signIn.php?mobile=1" : "" + g_conf.appApiServer + "/signIn.php"), {
            method: 'POST',
            data: data,
            xhrFields: {
              withCredentials: true
            },
            success: function(response) {
              var url;
              console.log(response);
              if (response !== 0) {
                if (IS_MOBILE) {
                  localStorage.setItem('session', JSON.stringify(response));
                  return document.location.reload();
                } else {
                  url = document.location.href.match(/^([^?]*)/)[1];
                  if (url === document.location.href) {
                    return document.location.reload();
                  } else {
                    return document.location.href = url;
                  }
                }
              } else {
                return alert('failed to sign in');
              }
            }
          });
        }
      }, {
        logOut: function() {
          if (IS_MOBILE) {
            return cordova.plugins.notification.local.cancelAll(function() {
              dataManager.offlineDb.clear();
              localStorage.removeItem('session');
              return dataManager.terminateClient(function() {
                return document.location.reload();
              });
            });
          } else {
            return $.ajax("" + g_conf.appApiServer + "/signOut.php", {
              xhrFields: {
                withCredentials: true
              },
              success: function(response) {
                return document.location.reload();
              }
            });
          }
        },
        '#User.signIn': function(el, _arg) {
          var g_userId, user;
          user = _arg[0];
          g_userId = user.id;
          return g_userCont.set(user);
        }
      });
      $('header .nav li.more').click(function() {
        $('header').toggleClass('showMoreMenu');
        return false;
      });
      rootLayer.el.find('.verifyEmail a').click(function() {
        return $.ajax("" + g_conf.appApiServer + "/resendVerificationEmail.php?token=" + g_token, {
          xhrFields: {
            withCredentials: true
          },
          success: function(response) {
            return rootLayer.el.find('.verifyEmail a').html('Resent');
          }
        });
      });
      return this.uiInited();
    });
    mainTemplate = null;
    return $.get(base + 'app/templates/main.html', function(_mainTemplate) {
      mainTemplate = _mainTemplate;
      rootFrame.initUI();
      return rootFrame.navigate('dashboard');
    });
  };
});

//# sourceMappingURL=init.js.map
