// Generated by CoffeeScript 1.8.0
define(['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'app/UIHelpers'], function(UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool) {
  var UIHelpers;
  UIHelpers = require('app/UIHelpers');
  return {
    breakpoints: {
      614: {
        init: function() {
          $('article.outstandingBalance').appendTo('main');
          $('article.paymentHistory').appendTo('main');
          $('article.paymentMethods').appendTo('main');
          $('article.insurance').appendTo('main');
          return $('.right').remove();
        }
      },
      "else": {
        init: function() {
          var right;
          right = $('<div class="right" />');
          $('article.paymentHistory').appendTo('main');
          $('article.outstandingBalance').appendTo(right);
          $('article.paymentMethods').appendTo(right);
          $('article.insurance').appendTo(right);
          $('.right').remove();
          return right.appendTo('main');
        }
      }
    },
    init: function(pageFrame, pageLayer, done) {
      return $.get(base + 'app/templates/pages/billing.html', function(template) {
        pageLayer.el.append(template);
        pageLayer["if"]((function() {
          return g_userCont.get().get('outstandingBalance');
        }), function(layer) {
          return layer.addClass($('main'), 'hasOutstandingBalance');
        });
        pageLayer.bind(pageLayer.el, {
          user: g_userCont
        });
        pageLayer.globalScope = {
          editInsuranceDialog: UIHelpers.editDialogBinding((function() {
            return pageLayer.tmpls.editInsurance;
          }), 'Insurance', ['idNumber', 'groupNumber', 'rxBin', 'isCurrent']),
          editPaymentMethodDialog: UIHelpers.editDialogBinding((function() {
            return pageLayer.tmpls.editPaymentMethod;
          }), 'PaymentMethod', ['firstName', 'lastName', 'number', 'type', 'cvc', 'expMonth', 'expYear', 'street1', 'street2', 'zip', 'city', 'state', 'isCurrent'], function(el, instance) {
            if (instance.get('isCurrent')) {
              el.find('[name=isCurrent]').prop('disabled', true);
              return el.find('a.delete').remove();
            }
          }),
          addPaymentMethodDialog: function() {
            return UIHelpers.showDialog({
              html: pageLayer.tmpls.addPaymentMethod,
              init: function(_arg) {
                var close, el;
                el = _arg.el, close = _arg.close;
                if (!g_userCont.get().get('paymentMethods').length()) {
                  el.find('[name=isCurrent]').prop('disabled', true).prop('checked', true);
                }
                el.find('.cancel').click(close);
                return el.submit(function() {
                  UIHelpers.form.validate(el, {
                    firstName: 'notEmpty',
                    lastName: 'notEmpty',
                    type: 'notEmpty',
                    cvc: 'notEmpty',
                    expMonth: {
                      field: 'expirationDate',
                      validate: 'notEmpty'
                    },
                    expYear: {
                      field: 'expirationDate',
                      validate: 'notEmpty'
                    },
                    street1: 'notEmpty',
                    zip: 'notEmpty',
                    city: 'notEmpty',
                    state: 'notEmpty',
                    number: function(val, el) {
                      if (!el.validateCreditCard().valid) {
                        return 'The credit card number you entered is not valid.';
                      }
                    }
                  }, function(isValid) {
                    if (isValid) {
                      return $.ajax("" + g_conf.appApiServer + "/addPaymentMethod.php", {
                        method: 'post',
                        data: UIHelpers.inputData(el),
                        xhrFields: {
                          withCredentials: true
                        },
                        success: function(response) {
                          var e, errors, field, _ref;
                          if (response === true) {
                            UIHelpers.form.setErrors(el, {});
                            return close();
                          } else if (response.errors) {
                            errors = {};
                            _ref = response.errors;
                            for (field in _ref) {
                              e = _ref[field];
                              errors[field] = e.human;
                            }
                            return UIHelpers.form.setErrors(el, errors);
                          }
                        }
                      });
                    }
                  });
                  return false;
                });
              }
            });
          }
        };
        return done();
      });
    }
  };
});

//# sourceMappingURL=billing.js.map
