// Generated by CoffeeScript 1.8.0
define(['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool'], function(UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool) {
  return function(pageFrame, pageLayer, done) {
    return $.get(base + 'app/templates/pages/calendar.html', function(template) {
      var calendarEntries, packets, today, updateCalendar;
      today = new Date();
      pageLayer.el.append(template);
      pageLayer.bind(pageLayer.el, {
        user: g_userCont
      }, {});
      calendarEntries = [];
      if (g_userCont.get().get('currentDivvyPack')) {
        packets = g_userCont.get().get('currentDivvyPack').packets;
        calendarEntries.push({
          begin: Date.create(packets[0].time),
          end: Date.create(packets[packets.length - 1].time),
          beginFunc: function(el) {
            el.addClass('divvypack-begin');
            el.append('<div class="divvypack-begin" />');
            return el.append('<div class="item"><span>Current divvyPACK</span></div>');
          },
          middleFunc: function(el) {
            el.addClass('divvypack-middle');
            return el.append('<div class="divvypack-middle" />');
          },
          endFunc: function(el) {
            el.addClass('divvypack-end');
            return el.append('<div class="divvypack-end" />');
          }
        });
      }
      if (g_userCont.get().get('lastShipment')) {
        calendarEntries.push({
          date: g_userCont.get().get('lastShipment'),
          func: function(el) {
            el.addClass('shipment');
            if (today.is(g_userCont.get().get('lastShipment')) || today.isBetween(g_userCont.get().get('lastShipment'), g_userCont.get().get('nextShipment'))) {
              return el.append('<a class="item" target="_blank" href="' + g_userCont.get().get('lastShipmentTrackingUrl') + '"><span>Shipment Sent</span></a>');
            } else {
              return el.append('<div class="item"><span>Shipment Sent</span></div>');
            }
          }
        });
      }
      if (g_userCont.get().get('nextShipment')) {
        calendarEntries.push({
          date: g_userCont.get().get('nextShipment'),
          func: function(el) {
            el.addClass('shipment');
            if (today.is(g_userCont.get().get('nextShipment')) || today.isAfter(g_userCont.get().get('nextShipment'))) {
              return el.append('<a target="_blank" href="' + g_userCont.get().get('lastShipmentTrackingUrl') + '" class="item"><span>Next Shipment</span></a>');
            } else {
              return el.append('<div class="item"><span>Next Shipment</span></div>');
            }
          }
        });
      }
      updateCalendar = function(date) {
        var calendarEl, dateEl, dateStr, entry, i, month, monthDate, _i, _j, _len, _results;
        monthDate = date.clone();
        pageLayer.el.find('.calendar').remove();
        date = date.startOf('month');
        date.subtract(date.day(), 'days');
        month = monthDate.month();
        calendarEl = $("<div class=\"calendar\">\n	<div class=\"header\">\n		<a href=\"#\" class=\"prev\">prev</a>\n		<a href=\"#\" class=\"next\">next</a>\n		<span class=\"month\">" + (monthDate.format('MMMM, YYYY')) + "</span>\n	</div>\n\n	<div class=\"day\">Sun</div>\n	<div class=\"day\">Mon</div>\n	<div class=\"day\">Tue</div>\n	<div class=\"day\">Wed</div>\n	<div class=\"day\">Thu</div>\n	<div class=\"day\">Fri</div>\n	<div class=\"day\">Sat</div>\n	<div class=\"dates\" />\n</div>");
        calendarEl.find('.prev').click(function() {
          updateCalendar(monthDate.subtract(1, 'month'));
          return false;
        });
        calendarEl.find('.next').click(function() {
          updateCalendar(monthDate.add(1, 'month'));
          return false;
        });
        calendarEl.appendTo(pageLayer.el);
        _results = [];
        for (i = _i = 0; _i < 35; i = ++_i) {
          dateEl = $("<div class='date'><span class='number'>" + (date.date()) + "</span></div>");
          if (date.month() !== month) {
            dateEl.addClass('otherMonth');
          }
          dateStr = date.format('YYYY-MM-DD');
          if (dateStr === moment(today).format('YYYY-MM-DD')) {
            dateEl.addClass('today');
          }
          calendarEl.find('.dates').append(dateEl);
          for (_j = 0, _len = calendarEntries.length; _j < _len; _j++) {
            entry = calendarEntries[_j];
            if (entry.date) {
              if (moment(entry.date).format('YYYY-MM-DD') === dateStr) {
                entry.func(dateEl, date);
              }
            } else {
              if (dateStr > moment(entry.begin).format('YYYY-MM-DD') && dateStr < moment(entry.end).format('YYYY-MM-DD')) {
                entry.middleFunc(dateEl, date);
              } else if (dateStr === moment(entry.begin).format('YYYY-MM-DD')) {
                entry.beginFunc(dateEl, date);
              } else if (dateStr === moment(entry.end).format('YYYY-MM-DD')) {
                entry.endFunc(dateEl, date);
              }
            }
          }
          _results.push(date.add(1, 'day'));
        }
        return _results;
      };
      updateCalendar(moment(today));
      return done();
    });
  };
});

//# sourceMappingURL=calendar.js.map
