// Generated by CoffeeScript 1.8.0
var __slice = [].slice;

define(['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'app/DivvyDose'], function(UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool, DivvyDose) {
  return {
    init: function(pageFrame, pageLayer, done) {
      var dateAt, dateRange, header, inc, start, _totalDoses, _totalTaken;
      window.packetContainsMedication = function(divvyPack, packet, medication) {
        var dose, _i, _len, _ref;
        _ref = packet.doses;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          dose = _ref[_i];
          if (DivvyDose.prescriptionNameWithoutFormat(divvyPack.prescriptions[dose.rxNumber].name) === medication.get('nameWithoutFormat')) {
            return true;
          }
        }
        return false;
      };
      _totalDoses = {};
      window.totalDoses = function(medication, start, end) {
        var count, divvyPack, divvyPacks, k, packet, r, startDate, _i, _len, _ref;
        if (g_userCont.get().get('demo')) {
          k = start + end + medication.get('id');
          if (_totalDoses[k]) {
            return _totalDoses[k];
          } else {
            r = Math.random();
            return _totalDoses[k] = r < .1 ? 0 : 2;
          }
        } else {
          count = 0;
          if (divvyPacks = g_userCont.get().get('divvyPacks')) {
            for (startDate in divvyPacks) {
              divvyPack = divvyPacks[startDate];
              _ref = divvyPack.packets;
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                packet = _ref[_i];
                if (Date.create(packet.time).isBetween(start, end)) {
                  if (packetContainsMedication(divvyPack, packet, medication)) {
                    count++;
                  }
                }
              }
            }
          }
          return count;
        }
      };
      _totalTaken = {};
      window.totalTaken = function(prescription, start, end) {
        var count, k, r;
        if (g_userCont.get().get('demo')) {
          k = start + end + prescription.get('id');
          if (_totalTaken[k]) {
            return _totalTaken[k];
          } else {
            r = Math.random();
            return _totalTaken[k] = r < .2 ? 0 : r < .5 ? Math.min(_totalDoses[k], 1) : Math.min(_totalDoses[k], 2);
          }
        } else {
          count = 0;
          g_userCont.get().get('medicineLogEntries').find({
            event: 'taken'
          }).each(function(logEntry) {
            if (Date.create(logEntry.get('time')).isBetween(start, end)) {
              if (logEntry.get('doses').exists({
                prescription: prescription
              })) {
                return count++;
              }
            }
          });
          return count;
        }
      };
      inc = function(date, i) {
        switch (timeScale.get()) {
          case 'days':
            return date.addDays(i);
          case 'weeks':
            return date.addWeeks(i);
          case 'months':
            return date.addMonths(i);
          case 'years':
            return date.addYears(i);
        }
      };
      dateAt = function(i) {
        return inc(start.get().clone(), i);
      };
      header = function(i) {
        switch (timeScale.get()) {
          case 'days':
            return dateAt(i).format('{Dow}');
          case 'weeks':
            return dateAt(i).format('<span class="month">{Mon}</span><span class="day">{d}</span>');
          case 'months':
            return dateAt(i).format('{Mon}');
          case 'years':
            return dateAt(i).format('{year}');
        }
      };
      dateRange = function(i) {
        var begin, end, now;
        begin = dateAt(i);
        end = inc(begin.clone(), 1);
        now = Date.create();
        if (end.isAfter(now)) {
          end = now;
        }
        return [begin, end];
      };
      window.timeScale = new XValue().retain();
      start = new XValue().retain();
      timeScale.observe(function() {
        return start.set((function() {
          switch (timeScale.get()) {
            case 'days':
              return Date.create().beginningOfDay();
            case 'weeks':
              return Date.create().beginningOfWeek();
            case 'months':
              return Date.create().beginningOfMonth();
            case 'years':
              return Date.create().beginningOfYear();
          }
        })());
      });
      timeScale.set('weeks');
      return $.get(base + 'app/templates/pages/charts.html', function(template) {
        pageLayer.el.append(template);
        pageLayer.bind(pageLayer.el, {
          user: g_userCont,
          timeScale: timeScale
        }, {
          prev: function() {
            return start.set(inc(start.get().clone(), -1));
          },
          next: function() {
            return start.set(inc(start.get().clone(), 1));
          },
          setTimeScale: function(ts) {
            return timeScale.set(ts);
          },
          header: function(el) {
            return header(el.index());
          },
          'user.prescriptions:regular': {
            init: function(el, _arg, _arg1) {
              var layer, medication;
              medication = _arg[0];
              layer = _arg1.layer;
              return el.find('.name').click(function() {
                var nameEl, pos;
                console.log(medication.get('name'));
                nameEl = $("<div class='fullName'>" + (medication.get('name')) + " <a href='#' class='close' /></div>");
                nameEl.click(function() {
                  nameEl.remove();
                  return false;
                });
                layer.addHtml($('body'), nameEl);
                pos = $(this).offset();
                return nameEl.css({
                  top: pos.top + $(this).outerHeight() / 2 - nameEl.outerHeight() / 2,
                  left: pos.left - 10
                });
              });
            }
          },
          'user.prescriptions:regular.state': function(medication, el) {
            var index, range, td, tt;
            index = el.index() - 1;
            range = dateRange(index);
            td = totalDoses.apply(null, [medication].concat(__slice.call(range)));
            tt = totalTaken.apply(null, [medication].concat(__slice.call(range)));
            if (td && tt === td) {
              return 'full';
            } else if (tt) {
              return 'partial';
            } else {
              return 'none';
            }
          }
        });
        return done();
      });
    }
  };
});

//# sourceMappingURL=charts.js.map
