// Generated by CoffeeScript 1.8.0
var __slice = [].slice;

define(['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool'], function(UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool) {
  return {
    init: function(pageFrame, pageLayer, done) {
      return $.get(base + 'app/templates/pages/medications.html', function(template) {
        var Component;
        pageLayer.bindEvent($(window), 'scroll', function() {
          if ($(window).scrollTop() > $('main').offset().top) {
            return $('main').addClass('floatingMedication');
          } else {
            return $('main').removeClass('floatingMedication');
          }
        });
        pageLayer.el.append(template);
        Component = (function() {
          Component.get = function(name, params, cb) {
            var component;
            component = new Component(this.components[name]);
            return component.init(params, function() {
              return cb(component);
            });
          };

          Component.components = {
            List: {
              init: function(_arg, cb) {
                var controller, layer, selectedMedication;
                layer = _arg.layer, controller = _arg.controller, selectedMedication = _arg.selectedMedication;
                return $.get(base + 'app/templates/pages/medications/list.html', (function(_this) {
                  return function(template) {
                    var initMedication;
                    _this.el = $('<div />');
                    _this.layer = layer.addLayer(new UILayer);
                    _this.el.append(template);
                    initMedication = function(el, _arg1, _arg2) {
                      var layer, supplement;
                      supplement = _arg1[0];
                      layer = _arg2.layer;
                      el.click(function() {
                        return controller.navigationalShift2(layer, 'medication', supplement);
                      });
                      layer["if"]((function() {
                        return selectedMedication.get() === supplement;
                      }), function(layer) {
                        return layer.addClass(el, 'active');
                      });
                      return layer.withValue(supplement.prop('image'), function(image) {
                        return el.find('img').attr('src', image);
                      });
                    };
                    _this.layer.bind(_this.el, {
                      user: g_userCont
                    }, {
                      'user.prescriptions:regular': {
                        init: initMedication
                      },
                      'user.prescriptions:asNeeded': {
                        init: initMedication
                      }
                    });
                    return cb();
                  };
                })(this));
              }
            },
            View: {
              init: function(_arg, cb) {
                var controller, layer, selectedMedication;
                layer = _arg.layer, controller = _arg.controller, selectedMedication = _arg.selectedMedication;
                return $.get(base + 'app/templates/pages/medications/view.html', (function(_this) {
                  return function(template) {
                    _this.el = $('<div />');
                    _this.layer = layer.addLayer(new UILayer);
                    _this.el.append(template);
                    _this.layer.bind(_this.el, {
                      prescription: selectedMedication,
                      user: g_userCont,
                      pause: function() {
                        selectedMedication.get().set('state', 'paused');
                        return console.log(selectedMedication);
                      },
                      resume: function() {
                        return selectedMedication.get().set('state', 'resumed');
                      }
                    });
                    return cb();
                  };
                })(this));
              }
            }
          };

          function Component(methods) {
            var func, name;
            for (name in methods) {
              func = methods[name];
              this[name] = func;
            }
          }

          return Component;

        })();
        pageLayer.value('selectedMedication').set(false);
        return {
          web: {
            init: function(cb) {
              var selectedMedicationLayer;
              Component.get('List', {
                controller: this,
                selectedMedication: pageLayer.value('selectedMedication')
              }, (function(_this) {
                return function(component) {
                  pageLayer.el.append("<div class=\"list\" />\n<div if=\"pageLayer.value('selectedMedication').get()\" class=\"selectedMedication\" />");
                  pageLayer.bind(pageLayer.el);
                  pageLayer.el.find('.list').append(component.el);
                  pageLayer.addLayer(component.layer);
                  return cb();
                };
              })(this));
              selectedMedicationLayer = null;
              return pageLayer.withValue(pageLayer.value('selectedMedication'), function(selectedMedication) {
                if (selectedMedication) {
                  return Component.get('View', {
                    controller: this,
                    selectedMedication: pageLayer.value('selectedMedication')
                  }, (function(_this) {
                    return function(component) {
                      if (selectedMedicationLayer) {
                        selectedMedicationLayer.destruct();
                        selectedMedicationLayer = null;
                      }
                      selectedMedicationLayer = pageLayer.addLayer(new UILayer);
                      selectedMedicationLayer.addHtml(pageLayer.el.find('.selectedMedication'), component.el);
                      return pageLayer.el.addClass('medicationSelected');
                    };
                  })(this));
                } else {
                  pageLayer.el.removeClass('medicationSelected');
                  if (selectedMedicationLayer) {
                    selectedMedicationLayer.destruct();
                    return selectedMedicationLayer = null;
                  }
                }
              });
            }
          },
          mobile: {
            layer: pageLayer,
            init: function(cb) {
              var selectedMedicationLayer;
              Component.get('List', {
                layer: pageLayer,
                controller: this,
                selectedMedication: pageLayer.value('selectedMedication')
              }, (function(_this) {
                return function(component) {
                  pageLayer.el.append("<div class=\"list\" />\n<div if=\"pageLayer.value('selectedMedication').get()\" class=\"selectedMedication\" />");
                  pageLayer.bind(pageLayer.el);
                  pageLayer.el.find('.list').append(component.el);
                  return cb();
                };
              })(this));
              selectedMedicationLayer = null;
              return pageLayer.withValue(pageLayer.value('selectedMedication'), function(selectedMedication) {
                if (selectedMedication) {
                  pushBackButton(function() {
                    return pageLayer.value('selectedMedication').set(false);
                  });
                  if (selectedMedicationLayer) {
                    selectedMedicationLayer.destruct();
                    selectedMedicationLayer = null;
                  }
                  selectedMedicationLayer = pageLayer.addLayer(new UILayer);
                  return Component.get('View', {
                    layer: selectedMedicationLayer,
                    controller: this,
                    selectedMedication: pageLayer.value('selectedMedication')
                  }, (function(_this) {
                    return function(component) {
                      selectedMedicationLayer.addHtml(pageLayer.el.find('.selectedMedication'), component.el);
                      return pageLayer.el.addClass('medicationSelected');
                    };
                  })(this));
                } else {
                  pageLayer.el.removeClass('medicationSelected');
                  if (selectedMedicationLayer) {
                    selectedMedicationLayer.destruct();
                    return selectedMedicationLayer = null;
                  }
                }
              });
            },
            navigationalShift2: function() {
              var eq, i, layer, navigationLayer, param, params, type, _i, _len, _ref;
              layer = arguments[0], type = arguments[1], params = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
              if (this.navigation == null) {
                this.navigation = {};
              }
              if (this.navigation[type]) {
                eq = true;
                for (i = _i = 0, _len = params.length; _i < _len; i = ++_i) {
                  param = params[i];
                  if (this.navigation[type].params[i] !== param) {
                    eq = false;
                    break;
                  }
                }
                console.log(eq);
                this.navigation[type].layer.destruct();
                if (eq) {
                  return;
                }
              }
              this.navigation[type] = {
                params: params
              };
              this.navigation[type].layer = navigationLayer = layer.addLayer(new UILayer);
              navigationLayer.addDestructFunc((function(_this) {
                return function() {
                  if (_this.navigation[type].layer === navigationLayer) {
                    return delete _this.navigation[type];
                  }
                };
              })(this));
              return (_ref = {
                medication: function(supplement) {
                  return navigationLayer.setValue(pageLayer.value('selectedMedication'), supplement);
                }
              })[type].apply(_ref, params);
            },
            navigationalShift: function() {
              var layer, params, type, _ref;
              layer = arguments[0], type = arguments[1], params = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
              return (_ref = {
                medication: function(supplement) {
                  if (pageLayer.value('selectedMedication').get() === supplement) {
                    return pageLayer.value('selectedMedication').set(false);
                  } else {
                    return pageLayer.value('selectedMedication').set(supplement);
                  }
                }
              })[type].apply(_ref, params);
            },
            navigationalShift: function() {
              var layer, params, type, _ref;
              layer = arguments[0], type = arguments[1], params = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
              return (_ref = {
                medication: function(supplement) {
                  if (pageLayer.value('selectedMedication').get() === supplement) {
                    return pageLayer.value('selectedMedication').set(false);
                  } else {
                    return pageLayer.value('selectedMedication').set(supplement);
                  }
                }
              })[type].apply(_ref, params);
            }
          }
        }.mobile.init(done);
      });
    }
  };
});

//# sourceMappingURL=medications.js.map
