// Generated by CoffeeScript 1.8.0
var initMobile, registerPushNotifications, resetState, templateFile;

Raven.setExtraContextProp('version', '1.0.0');

templateFile = function(name) {
  return "text!../../app/templates/" + name + ".html";
};

window.OFFLINE = false;

window.OPTS = {
  offline: false
};

initMobile = null;

window.IS_MOBILE = typeof cordova !== 'undefined';

if (IS_MOBILE) {
  resetState = function() {
    var _ref, _ref1;
    localStorage.clear();
    if (typeof cordova !== "undefined" && cordova !== null ? (_ref = cordova.plugins) != null ? (_ref1 = _ref.notification) != null ? _ref1.local : void 0 : void 0 : void 0) {
      return cordova.plugins.notification.local.cancelAll(function() {
        return location.reload();
      });
    } else {
      return location.reload();
    }
  };
  Raven.setExtraContextProp('mobile', true);
  initMobile = function(cb) {
    var connectTimer, goOffline, goOnline, _ref;
    $('html').addClass(navigator.platform.toLowerCase().replace(' ', '-'));
    navigator.splashscreen.hide();
    $(function() {
      $('#status .reload').click(function() {
        document.location.reload();
        return false;
      });
      return $('#status .reset').click(function() {
        if (confirm('Are you sure?')) {
          dataManager.reset();
          setTimeout((function() {
            return document.location.reload();
          }), 1000);
        }
        return false;
      });
    });
    OPTS.offline = true;
    window.OFFLINE = false;
    connectTimer = null;
    goOffline = function() {
      if (connectTimer) {
        clearTimeout(connectTimer);
        connectTimer = null;
      }
      if (!window.OFFLINE) {
        console.log('offline');
        g_online.set(false);
        window.OFFLINE = true;
        if (typeof dataManager !== "undefined" && dataManager !== null) {
          return dataManager.transport.ws.close();
        }
      }
    };
    goOnline = function() {
      if (window.OFFLINE) {
        console.log('online');
        window.OFFLINE = false;
        g_online.set(true);
        if (typeof dataManager !== "undefined" && dataManager !== null) {
          return connectTimer = setTimeout((function() {
            dataManager.connect();
            return connectTimer = null;
          }), 1000);
        }
      }
    };
    document.addEventListener('offline', goOffline, false);
    document.addEventListener('online', goOnline, false);
    setInterval((function() {
      var _ref;
      if ((_ref = navigator.connection.type) === Connection.UNKNOWN || _ref === Connection.NONE) {
        return goOffline();
      } else {
        return goOnline();
      }
    }), 1000);
    return g_online.set(!((_ref = navigator.connection.type) === Connection.UNKNOWN || _ref === Connection.NONE));
  };
  registerPushNotifications = function() {
    console.log('registering push notification...');
    if (device.platform.toLowerCase() === 'android') {
      return plugins.pushNotification.register(function(result) {
        return console.log('success', result);
      }, function(result) {
        return console.log('failure', result);
      }, {
        senderID: '622634218825',
        ecb: '__onPushNotification'
      });
    } else {
      return plugins.pushNotification.register(function(token) {
        console.log('Token: ' + token);
        window.g_deviceToken = token;
        if (typeof window.__onGetDeviceToken === "function") {
          window.__onGetDeviceToken();
        }
        return typeof cb === "function" ? cb() : void 0;
      }, function(error) {
        console.log('Error: ' + error);
        return typeof cb === "function" ? cb() : void 0;
      }, {
        'badge': 'true',
        'sound': 'true',
        'alert': 'true',
        'ecb': '__onPushNotification'
      });
    }
  };
  document.addEventListener('deviceready', function() {
    var handled;
    window.onPushNotification = function(cb) {
      window._pushNotificationCb = cb;
      if (typeof _pushNotification !== "undefined" && _pushNotification !== null) {
        cb(_pushNotification);
        return delete window._pushNotification;
      }
    };
    window.onLocalNotification = function(cb) {
      window._localNotificationCb = cb;
      if (typeof _localNotification !== "undefined" && _localNotification !== null) {
        cb.apply(null, _localNotification);
        return delete window._localNotification;
      }
    };
    handled = {};
    cordova.plugins.notification.local.on('click', function(notification) {
      if (device.platform.toLowerCase() === 'android') {
        handled[notification.id] = true;
      }
      console.log(['click', notification]);
      window.lastLocalNotification = ['click', notification];
      if (typeof _localNotificationCb !== "undefined" && _localNotificationCb !== null) {
        return _localNotificationCb('click', notification);
      } else {
        return window._localNotification = ['click', notification];
      }
    });
    cordova.plugins.notification.local.on('trigger', function(notification) {
      console.log(window.lastLocalNotification = ['trigger', notification]);
      if (device.platform.toLowerCase() === 'android') {
        return setTimeout((function() {
          if (!handled[notification.id]) {
            if (typeof _localNotificationCb !== "undefined" && _localNotificationCb !== null) {
              return _localNotificationCb('trigger', notification);
            } else {
              return window._localNotification = ['trigger', notification];
            }
          } else {
            return delete handled[notification.id];
          }
        }), 100);
      } else {
        if (typeof _localNotificationCb !== "undefined" && _localNotificationCb !== null) {
          return _localNotificationCb('trigger', notification);
        } else {
          return window._localNotification = ['trigger', notification];
        }
      }
    });
    window.__onPushNotification = function(notification) {
      window.lastPushNotification = window.pushNotification = notification;
      if (device.platform.toLowerCase() === 'android' && notification.event === 'registered') {
        window.g_deviceToken = notification.regid;
        if (typeof window.__onGetDeviceToken === "function") {
          window.__onGetDeviceToken();
        }
        return typeof cb === "function" ? cb() : void 0;
      } else {
        if (typeof _pushNotificationCb !== "undefined" && _pushNotificationCb !== null) {
          return window._pushNotificationCb(notification);
        } else {
          return window._pushNotification = notification;
        }
      }
    };
    return registerPushNotifications();
  });
  document.addEventListener('resume', function() {
    if (typeof g_deviceToken === "undefined" || g_deviceToken === null) {
      return registerPushNotifications();
    }
  });
}

define(['xyzp/init'], function() {
  return require(['app/init', 'app/config', 'xyzp/XValue'], function(initApp, config, XValue) {
    window.g_online = new XValue;
    window.start = function() {
      var done;
      $('html').addClass('loading');
      done = function() {
        $('html').removeClass('loading');
        return initApp();
      };
      if (!IS_MOBILE) {
        g_online.set(true);
      }
      config = config();
      if (OPTS.offline) {
        $('html').addClass('supportsOfflineMode');
      }
      return config.dataManager({
        offline: OPTS.offline
      }, function(dataManager) {
        if (dataManager) {
          window.dataManager = dataManager;
          dataManager.offline.observe(function() {
            if (dataManager.offline.get()) {
              $('html').addClass('offline');
              return $('html').removeClass('online');
            } else {
              $('html').removeClass('offline');
              return $('html').addClass('online');
            }
          });
          dataManager.connected.observe(function() {
            if (dataManager.connected.get()) {
              return $('html').addClass('connected');
            } else {
              return $('html').removeClass('connected');
            }
          });
          dataManager.status.observe(function() {
            return $('#status .status').html(dataManager.status.get());
          });
          console.log('init...!');
          return dataManager.init(function(success, error) {
            if (success) {
              console.log('starting init!');
              if (config.init) {
                config.init(done);
              } else {
                done();
              }
              return window.BOOTSTRAP_OK = true;
            } else {
              if (error === 'outdatedSchemaNoConnection') {
                if (IS_MOBILE) {
                  $('html').removeClass('loading');
                  document.addEventListener('online', function() {
                    return document.location.reload();
                  });
                  return alert('Update required. The application must have access to the Internet before you may continue to use it.');
                }
              } else {
                $('html').removeClass('loading');
                return typeof config.failedToConnect === "function" ? config.failedToConnect() : void 0;
              }
            }
          });
        } else {
          console.log('starting init (no data manager)!');
          if (config.init) {
            config.init(done);
          } else {
            done();
          }
          return window.BOOTSTRAP_OK = true;
        }
      });
    };
    if (IS_MOBILE) {
      return document.addEventListener('deviceready', function() {
        console.log('device ready', device);
        initMobile();
        return start();
      });
    } else {
      return start();
    }
  });
});

//# sourceMappingURL=main.js.map
