// Generated by CoffeeScript 1.8.0
var Breakpoints, UILayer;

UILayer = (function() {
  function UILayer(name) {
    this.name = name;
  }

  UILayer.prototype.destruct = function(removeFromParent) {
    var func, layer, _i, _j, _len, _len1, _ref, _ref1, _results;
    if (removeFromParent == null) {
      removeFromParent = true;
    }
    if (this.parent && removeFromParent) {
      this.parent.removeLayer(this);
    }
    if (this.layers) {
      _ref = this.layers;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        layer = _ref[_i];
        layer.destruct(false);
      }
    }
    if (this.destructFuncs) {
      _ref1 = this.destructFuncs;
      _results = [];
      for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
        func = _ref1[_j];
        _results.push(func());
      }
      return _results;
    }
  };

  UILayer.prototype.addElement = function(el, name) {
    if (this.elements == null) {
      this.elements = {};
    }
    return this.elements[name] = el;
  };

  UILayer.prototype.addElementBinding = function(elementName, valueName) {
    var el, value;
    el = this.elements[elementName];
    value = this.value(valueName);
    el.val(value.get());
    value.observe(function() {
      if (el.val() !== value.get()) {
        return el.val(value.get());
      }
    });
    if (el.attr('type') === 'text') {
      return el.keyup(function() {
        if (value.get() !== el.val()) {
          value.set(el.val());
        }
        return true;
      });
    }
  };

  UILayer.prototype.addLayer = function(layer) {
    if (this.layers == null) {
      this.layers = [];
    }
    this.layers.push(layer);
    layer.parent = this;
    layer.debug = this.debug;
    layer.globalScope = this.globalScope;
    if (layer.name) {
      if (this.layersByName == null) {
        this.layersByName = {};
      }
      this.layersByName[layer.name] = layer;
    }
    return layer;
  };

  UILayer.prototype.removeLayer = function(layer) {
    _.pull(this.layers, layer);
    if (layer.name) {
      return delete this.layersByName[layer.name];
    }
  };

  UILayer.prototype.layer = function(name) {
    if (this.layersByName[name]) {
      this.layersByName[name];
    }
    return this.tmpls[id] = html;
  };

  UILayer.prototype.newLayers = function(layers) {
    var params, _i, _len, _results;
    _results = [];
    for (_i = 0, _len = layers.length; _i < _len; _i++) {
      params = layers[_i];
      _results.push(this["new"](params));
    }
    return _results;
  };

  UILayer.prototype.addHtml = function(el, html) {
    var newEl;
    newEl = $(html);
    el.append(newEl);
    this.addDestructFunc(function() {
      return newEl.remove();
    });
    return newEl;
  };

  UILayer.prototype.addClass = function(el, className) {
    el.addClass(className);
    return this.addDestructFunc(function() {
      return el.removeClass(className);
    });
  };

  UILayer.prototype.addCss = function(el, css) {
    var attr, prevValues, value;
    prevValues = {};
    for (attr in css) {
      value = css[attr];
      if (el.get(0).style[attr]) {
        prevValues[attr] = el.get(0).style[attr];
      } else {
        prevValues[attr] = '';
      }
    }
    el.css(css);
    return this.addDestructFunc(function() {
      return el.css(prevValues);
    });
  };

  return UILayer;

})();

Breakpoints = (function() {
  function Breakpoints() {
    this.list = [];
    this.breakpointsByName = {};
    this.breakpoints = {};
  }

  Breakpoints.prototype.addBreakpoints = function(name, breakpoints) {
    this.list.push(breakpoints);
    this.breakpointsByName[name] = breakpoints;
    return this.resolveBreakpoints();
  };

  Breakpoints.prototype.removeBreakpoints = function(name) {
    _.pull(this.list, this.breakpointsByName[name]);
    delete this.breakpointsByName[name];
    return this.resolveBreakpoints();
  };

  Breakpoints.prototype.resolveBreakpoints = function() {
    var breakpoint, breakpoints, resolvedBreakpoints, width, _i, _len, _ref;
    resolvedBreakpoints = {};
    _ref = this.list;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      breakpoints = _ref[_i];
      for (width in breakpoints) {
        breakpoint = breakpoints[width];
        if (resolvedBreakpoints[width] == null) {
          resolvedBreakpoints[width] = [];
        }
        resolvedBreakpoints[width].push(breakpoint);
      }
    }
    return this.breakpoints = resolvedBreakpoints;
  };

  Breakpoints.prototype.update = function(force) {
    var bp, breakpoint, width, widths, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _results;
    if (force == null) {
      force = false;
    }
    $('body').addClass('breakpointed');
    widths = _.map(_.without(_.keys(this.breakpoints), 'else'), function(v) {
      return parseInt(v);
    }).sort(function(a, b) {
      return a - b;
    });
    breakpoint = 'else';
    for (_i = 0, _len = widths.length; _i < _len; _i++) {
      width = widths[_i];
      if ($(window).width() < width) {
        breakpoint = width;
        break;
      }
    }
    if (this.currentBreakpoint !== breakpoint || force) {
      $('body').removeClass("breakpoint-" + this.currentBreakpoint);
      $('body').addClass("breakpoint-" + breakpoint);
      if (this.breakpointLayer) {
        this.breakpointLayer.destruct();
      }
      this.breakpointLayer = new UILayer;
      this.currentBreakpoint = breakpoint;
      if (this.breakpoints[breakpoint]) {
        _ref = this.breakpoints[breakpoint];
        for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
          bp = _ref[_j];
          if (typeof bp.init === "function") {
            bp.init(this.breakpointLayer);
          }
        }
      }
    }
    if (this.breakpoints[breakpoint]) {
      _ref1 = this.breakpoints[breakpoint];
      _results = [];
      for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
        bp = _ref1[_k];
        _results.push(typeof bp.resize === "function" ? bp.resize($(window).width()) : void 0);
      }
      return _results;
    }
  };

  return Breakpoints;

})();

//# sourceMappingURL=ui.js.map
