// Generated by CoffeeScript 1.8.0
define(function() {
  var DataChanges;
  return DataChanges = (function() {
    function DataChanges(_cb) {
      this._cb = _cb;
      this._changes = {};
      this._enabled = true;
    }

    DataChanges.prototype.disable = function() {
      return this._enabled = false;
    };

    DataChanges.prototype.enable = function() {
      return this._enabled = true;
    };

    DataChanges.prototype.createInstance = function(level, model, id, values) {
      var i, _base, _base1, _i;
      if (!this._enabled) {
        return;
      }
      for (i = _i = 0; 0 <= level ? _i <= level : _i >= level; i = 0 <= level ? ++_i : --_i) {
        if ((_base = this._changes)[i] == null) {
          _base[i] = {};
        }
        if ((_base1 = this._changes[i])[model] == null) {
          _base1[model] = {};
        }
        this._changes[i][model][id] = values;
      }
      return this._callCb();
    };

    DataChanges.prototype.deleteInstance = function(level, model, id) {
      var i, _base, _base1, _i;
      if (!this._enabled) {
        return;
      }
      for (i = _i = 0; 0 <= level ? _i <= level : _i >= level; i = 0 <= level ? ++_i : --_i) {
        if ((_base = this._changes)[i] == null) {
          _base[i] = {};
        }
        if ((_base1 = this._changes[i])[model] == null) {
          _base1[model] = {};
        }
        this._changes[i][model][id] = 'delete';
      }
      return this._callCb();
    };

    DataChanges.prototype.setInstanceProperty = function(level, model, id, attrName, value) {
      var i, _base, _base1, _base2, _i;
      if (!this._enabled) {
        return;
      }
      for (i = _i = 0; 0 <= level ? _i <= level : _i >= level; i = 0 <= level ? ++_i : --_i) {
        if ((_base = this._changes)[i] == null) {
          _base[i] = {};
        }
        if ((_base1 = this._changes[i])[model] == null) {
          _base1[model] = {};
        }
        if ((_base2 = this._changes[i][model])[id] == null) {
          _base2[id] = {};
        }
        this._changes[i][model][id][attrName] = value;
      }
      return this._callCb();
    };

    DataChanges.prototype.addToInstanceRelationship = function(level, model, id, relName, instanceId) {
      var i, _base, _base1, _base2, _base3, _i;
      if (!this._enabled) {
        return;
      }
      for (i = _i = 0; 0 <= level ? _i <= level : _i >= level; i = 0 <= level ? ++_i : --_i) {
        if ((_base = this._changes)[i] == null) {
          _base[i] = {};
        }
        if ((_base1 = this._changes[i])[model] == null) {
          _base1[model] = {};
        }
        if ((_base2 = this._changes[i][model])[id] == null) {
          _base2[id] = {};
        }
        if (dataManager.isTemporaryId(id)) {
          if ((_base3 = this._changes[i][model][id])[relName] == null) {
            _base3[relName] = [];
          }
          this._changes[i][model][id][relName].push(instanceId);
        } else {
          if (this._changes[i][model][id][relName + '(add)']) {
            this._changes[i][model][id][relName + '(add)'].push(instanceId);
          } else {
            this._changes[i][model][id][relName + '(add)'] = ['add', instanceId];
          }
        }
      }
      return this._callCb();
    };

    DataChanges.prototype.removeFromInstanceRelationship = function(level, model, id, relName, instanceId) {
      var i, _base, _base1, _base2, _i;
      if (!this._enabled) {
        return;
      }
      for (i = _i = 0; 0 <= level ? _i <= level : _i >= level; i = 0 <= level ? ++_i : --_i) {
        if ((_base = this._changes)[i] == null) {
          _base[i] = {};
        }
        if ((_base1 = this._changes[i])[model] == null) {
          _base1[model] = {};
        }
        if ((_base2 = this._changes[i][model])[id] == null) {
          _base2[id] = {};
        }
        if (this._changes[i][model][id][relName + '(remove)']) {
          this._changes[i][model][id][relName + '(remove)'].push(instanceId);
        } else {
          this._changes[i][model][id][relName + '(remove)'] = ['remove', instanceId];
        }
      }
      return this._callCb();
    };

    DataChanges.prototype._callCb = function() {
      var done;
      if (!this._waiting) {
        clearTimeout(this._timerId);
        done = (function(_this) {
          return function() {
            delete _this._waiting;
            if (_this._newChanges) {
              delete _this._newChanges;
              return _this._callCb();
            }
          };
        })(this);
        return this._timerId = setTimeout(((function(_this) {
          return function() {
            _this._waiting = true;
            return _this._cb(_this._changes, done);
          };
        })(this)), 0);
      } else {
        return this._newChanges = true;
      }
    };

    DataChanges.prototype.clear = function() {
      return this._changes = {};
    };

    return DataChanges;

  })();
});

//# sourceMappingURL=DataChanges.js.map
