// Generated by CoffeeScript 1.8.0
define(['xyzp/OfflineDB', 'xyzp/util', 'xyzp/FilteredArray', 'xyzp/ComputedValue', 'xyzp/Model', 'xyzp/ModelProperty', 'xyzp/ModelAttribute', 'xyzp/HasOneRelationship', 'xyzp/HasManyRelationship', 'xyzp/ModelInstance', 'xyzp/PagedList', 'xyzp/SortedArray', 'xyzp/CounterCall', 'xyzp/DataChanges'], function(OfflineDb, util, FilteredArray, ComputedValue, Model, ModelProperty, ModelAttribute, HasOneRelationship, HasManyRelationship, ModelInstance, PagedList, SortedArray, CounterCall, DataChanges) {
  var DataManager, debugWindow;
  debugWindow = function(content) {
    var w;
    w = window.open();
    return w.document.body.innerHTML = content;
  };
  xyz.XArray.derive.paged = function(array, pageCount) {
    return new PagedList(array, pageCount);
  };
  util.objectList.derivations = {
    sorted: function(array, prop, order) {
      return new SortedArray(array, function(a, b) {
        return util.compare(a.get(prop), b.get(prop), order);
      });
    }
  };
  _.extend(ModelProperty, {
    createAttribute: function(instance, propertyName, params) {
      var schema;
      schema = instance._model._schema.attributes[propertyName];
      if (schema.attr) {
        return schema.attr.apply(instance, params);
      } else {
        return new ModelAttribute(instance, propertyName, schema, params);
      }
    },
    createRelationship: function(instance, propertyName, params) {
      var schema;
      schema = instance._model._schema.relationships[propertyName];
      switch (schema.type) {
        case 'One':
          return new HasOneRelationship(instance, propertyName, schema, params);
        case 'Many':
          return new HasManyRelationship(instance, propertyName, schema, params);
        case 'scope':
          return new FilteredArray(instance.get(schema.relationship), schema.test);
      }
    }
  });
  return DataManager = (function() {
    DataManager.prototype._parseJson = function(json) {
      var e;
      try {
        return JSON.parse(json);
      } catch (_error) {
        e = _error;
        if (this.opts.env === 'dev') {
          debugWindow(json);
        }
        throw e;
      }
    };

    function DataManager(clientVersion, version, schemaVersion, dbName, mainResource, server, transport, opts) {
      this.clientVersion = clientVersion;
      this.version = version;
      this.schemaVersion = schemaVersion;
      this.dbName = dbName;
      this.mainResource = mainResource;
      this.server = server;
      this.transport = transport;
      this.opts = opts != null ? opts : {};
      this._models = {};
      this._resources = {};
      this._nextTemporaryId = 0;
      this._temporaryIdObjects = {};
      this.offline = new xyz.XValue().retain();
      this.status = new xyz.XValue().retain();
      this.connected = new xyz.XValue(false).retain();
      this._now = new xyz.XValue(new Date).retain();
      setInterval(((function(_this) {
        return function() {
          return _this._now.set(new Date());
        };
      })(this)), 1000);
      this.today = new xyz.XValue(new Date).retain();
      setInterval(((function(_this) {
        return function() {
          var now;
          now = new Date();
          if (_this.today.get().toLocalMysqlDateFormat() !== now.toLocalMysqlDateFormat()) {
            return _this.today.set(now);
          }
        };
      })(this)), 1000 * 60);
      this.transport.onUpdate = (function(_this) {
        return function(update) {
          _this.applyChanges(update.data);
          return _this.transport.sendMessage(['U', [update.id]], function(error) {
            if (error) {
              return _this._onError(error);
            }
          });
        };
      })(this);
      this.transport.onOpen = (function(_this) {
        return function() {
          _this._isConnected = true;
          return _this.connected.set(true);
        };
      })(this);
      this.transport.onClose = (function(_this) {
        return function() {
          _this.connected.set(false);
          if (_this._wantsConnection) {
            if (_this.opts.offline) {
              _this._setOffline(true);
              if (!OFFLINE) {
                return setTimeout((function() {
                  return _this.connect();
                }), 1000);
              }
            } else {
              if (!_this._isConnected) {

              } else {
                _this._isConnected = false;
                return _this.reload = true;
              }
            }
          }
        };
      })(this);
      this.transport.onSendStart = (function(_this) {
        return function() {
          return _this.status.set('sending');
        };
      })(this);
      this.transport.onSendFinished = (function(_this) {
        return function() {
          _this.status.set('finished');
          return setTimeout((function() {
            if (_this.status.get() === 'finished') {
              return _this.status.set('');
            }
          }), 3000);
        };
      })(this);
      if (this.opts.offline) {
        this.offlineDb = new OfflineDb;
      }
      this._changes = new DataChanges((function(_this) {
        return function(changes, done) {
          var doneCounter;
          console.log(changes);
          doneCounter = new CounterCall(done);
          if (_this.offlineDb) {
            doneCounter.inc();
            _this.offlineDb.write(changes[0], function() {
              return doneCounter.call();
            });
          }
          if (_this._offline) {
            if (_this.offlineDb) {
              _this.offlineDb.storeChanges(_this.dbName, _this._changes._changes);
            }
          } else {
            if (!_this._pendingUpdate && changes[1]) {
              _this._sendUpdate(changes[1]);
              _this._changes.clear();
              if (_this.offlineDb) {
                _this.offlineDb.clearChanges(_this.dbName);
              }
            }
          }
          return doneCounter.end();
        };
      })(this));
    }

    DataManager.prototype._setOffline = function(offline) {
      this._offline = offline;
      return this.offline.set(offline);
    };

    DataManager.prototype.now = function() {
      return this._now.get();
    };

    DataManager.prototype.transaction = function(block) {
      xyz.MutationEvents.pause();
      block();
      return xyz.MutationEvents.resume();
    };

    DataManager.prototype._connect = function(sync, cb) {
      var model, name, _ref, _ref1;
      _ref = this._models;
      for (name in _ref) {
        model = _ref[name];
        if ((_ref1 = model._schema.storage) != null ? _ref1.remote : void 0) {
          model.updateFromRemote();
        }
      }
      this._wantsConnection = true;
      console.log('connecting...');
      return this.transport.init(this.version, this.clientId, this.dbName, this.schema.version, (function(_this) {
        return function(success) {
          if (success) {
            if (typeof cb === "function") {
              cb('init');
            }
            console.log('done connecting');
            if (sync) {
              return _this._pull(function() {
                return _this._push(function() {
                  return typeof cb === "function" ? cb('done') : void 0;
                });
              });
            }
          } else {
            return typeof cb === "function" ? cb('offline') : void 0;
          }
        };
      })(this));
    };

    DataManager.prototype.connect = function(cb) {
      if (this.offlineDb && this._offline) {
        return this._connect(true, (function(_this) {
          return function(state) {
            if (state === 'init') {
              return _this._setOffline(false);
            } else if (state === 'done') {
              return typeof cb === "function" ? cb() : void 0;
            }
          };
        })(this));
      }
    };

    DataManager.prototype._push = function(cb) {
      var changes, _ref;
      if (this._pendingUpdate) {
        return this._sendChanges(this._pendingUpdate, (function(_this) {
          return function(response) {
            delete _this._pendingUpdate;
            if (_this.offlineDb) {
              _this.offlineDb.clearPendingUpdate();
            }
            return _this._push(cb);
          };
        })(this));
      } else {
        changes = (_ref = this._changes._changes) != null ? _ref[1] : void 0;
        this._changes.clear();
        if (changes) {
          return this._sendUpdate(changes, (function(_this) {
            return function() {
              if (_this.offlineDb) {
                _this.offlineDb.clearChanges(_this.dbName);
              }
              return typeof cb === "function" ? cb() : void 0;
            };
          })(this));
        } else {
          return typeof cb === "function" ? cb() : void 0;
        }
      }
    };

    DataManager.prototype._sendUpdate = function(changes, cb) {
      if (!_.isEmpty(changes)) {
        if (this._pendingUpdate) {
          throw new Error();
        }
        this._pendingUpdate = {
          id: Math.random(),
          data: changes
        };
        if (this.offlineDb) {
          this.offlineDb.storePendingUpdate(this._pendingUpdate);
        }
        return this._sendChanges(this._pendingUpdate, (function(_this) {
          return function(response) {
            delete _this._pendingUpdate;
            if (_this.offlineDb) {
              _this.offlineDb.clearPendingUpdate();
            }
            return typeof cb === "function" ? cb() : void 0;
          };
        })(this));
      } else {
        return typeof cb === "function" ? cb() : void 0;
      }
    };

    DataManager.prototype._sendChanges = function(changes, cb) {
      console.log(changes);
      if (!_.isEmpty(changes)) {
        return this.transport.sendMessage(['u', JSON.stringify(changes)], (function(_this) {
          return function(error, response) {
            var newId, object, temporaryId, _ref;
            if (error) {
              _this._onError(error);
            } else {
              response = _this._parseJson(response);
              if (response.mapping) {
                _ref = response.mapping;
                for (temporaryId in _ref) {
                  newId = _ref[temporaryId];
                  object = _this._temporaryIdObjects[temporaryId];
                  if (object instanceof ModelInstance) {
                    if (_this.offlineDb) {
                      _this.offlineDb.changeId(object._model._name, object.id, newId);
                    }
                    object.id = newId;
                    object._model._instancesById[newId] = object;
                    delete object._model._instancesById[temporaryId];
                  }
                }
              }
            }
            return cb();
          };
        })(this));
      } else {
        return cb();
      }
    };

    DataManager.prototype._init = function(cb) {
      var count, done, model, modelName, modelSchema, _ref, _ref1;
      _ref = this.schema.models;
      for (modelName in _ref) {
        modelSchema = _ref[modelName];
        this._models[modelName] = new Model(this, modelName, modelSchema);
      }
      count = 0;
      done = false;
      _ref1 = this._models;
      for (modelName in _ref1) {
        model = _ref1[modelName];
        ++count;
        model.init(function() {
          count--;
          if (done && !count) {
            return cb();
          }
        });
      }
      done = true;
      if (!count) {
        return cb();
      }
    };

    DataManager.prototype.isTemporaryId = function(id) {
      return id[0] === '$';
    };

    DataManager.prototype.nextTemporaryId = function() {
      return '$' + this._nextTemporaryId++;
    };

    DataManager.prototype._setObjectForTemporaryId = function(temporaryId, object) {
      return this._temporaryIdObjects[temporaryId] = object;
    };

    DataManager.prototype.model = function(modelName) {
      return this._models[modelName];
    };

    DataManager.prototype.applyChanges = function(changes, writeToOffline) {
      var changeKey, id, instance, instanceData, model, modelChanges, modelData, modelName, resourceChanges, subChanges, _ref;
      if (writeToOffline == null) {
        writeToOffline = true;
      }
      xyz.MutationEvents.pause();
      console.log('applyingChanges', changes);
      modelChanges = {};
      resourceChanges = {};
      for (changeKey in changes) {
        subChanges = changes[changeKey];
        if (changeKey[0] === '/') {
          resourceChanges[changeKey] = subChanges;
        } else {
          modelChanges[changeKey] = subChanges;
        }
      }
      for (modelName in modelChanges) {
        modelData = modelChanges[modelName];
        model = this._models[modelName];
        for (id in modelData) {
          instanceData = modelData[id];
          if (instanceData !== 'delete' && !model._hasInstance(id)) {
            model._addInstance(id, {}, false);
          }
        }
      }
      for (modelName in modelChanges) {
        modelData = modelChanges[modelName];
        model = this._models[modelName];
        for (id in modelData) {
          instanceData = modelData[id];
          instance = model.instance(id);
          if (instanceData === 'delete' && !instance) {
            continue;
          }
          instance.applyChanges(instanceData);
        }
      }
      _ref = this._models;
      for (modelName in _ref) {
        model = _ref[modelName];
        model._commitInstances();
      }
      if (this.offlineDb && writeToOffline) {
        this.offlineDb.write(changes);
      }
      return xyz.MutationEvents.resume();
    };

    DataManager.prototype._addResource = function(resource) {
      this.applyChanges(resource.data);
      if (resource.type === 'model') {
        return this.model(resource.model).instance(resource.id);
      }
    };

    DataManager.prototype._onError = function(error) {
      alert('There was an error communicating with the server. The application will now reload.');
      this.reset();
      return document.location.reload();
    };

    DataManager.prototype.resource = function(resourcePath, cb) {
      if (this._resources[resourcePath]) {
        return cb(this._resources[resourcePath]);
      } else {
        return this.transport.sendMessage(['g', resourcePath], (function(_this) {
          return function(error, resource) {
            if (error) {
              _this._onError(error);
              return cb();
            } else {
              return cb(_this._resources[resourcePath] = _this._addResource(_this._parseJson(resource)));
            }
          };
        })(this));
      }
    };

    DataManager.prototype._initClientId = function(cb) {
      var client;
      client = {
        opts: {
          terminateOnDisconnect: this.opts.offline ? 0 : 1
        },
        token: this.opts.token
      };
      if (this.opts.client) {
        _.merge(client, this.opts.client);
      }
      return $.get("" + this.server + "/" + this.version + "/core/registerClient.php", {
        client: JSON.stringify(client)
      }, (function(_this) {
        return function(response) {
          _this.clientId = response.id;
          if (_this.opts.onClientId) {
            _this.opts.onClientId.call(_this, _this.clientId);
          }
          console.log('new client', _this.clientId);
          return cb();
        };
      })(this), 'json');
    };

    DataManager.prototype._initSchema = function(cb) {
      return $.get("" + this.server + "/" + this.version + "/core/main.php", {
        schema: 1,
        db: this.dbName,
        schemaVersion: this.schemaVersion
      }, ((function(_this) {
        return function(schema) {
          _this._setSchema(schema);
          return cb();
        };
      })(this)), 'json').error((function(_this) {
        return function(response, type, responseText) {
          console.error('Failed to get schema');
          if (_this.opts.env === 'dev') {
            return debugWindow(response.responseText);
          }
        };
      })(this));
    };

    DataManager.prototype._setSchema = function(schema) {
      this.schema = _.clone(schema);
      if (this.opts.schemaMods) {
        return _.merge(this.schema, this.opts.schemaMods);
      }
    };

    DataManager.prototype._pull = function(cb) {
      console.log('pulling');
      return this.transport.sendMessage(['q'], (function(_this) {
        return function(error, updates) {
          var ids, update, _i, _len;
          if (error) {
            _this._onError(error);
          } else {
            console.log('pulled updates', updates);
            updates = _this._parseJson(updates);
            if (updates) {
              ids = [];
              for (_i = 0, _len = updates.length; _i < _len; _i++) {
                update = updates[_i];
                ids.push(update.id);
                _this.applyChanges(update.data);
              }
              _this.transport.sendMessage(['U', ids], function(error) {
                if (error) {
                  return _this._onError(error);
                }
              });
            }
          }
          return cb();
        };
      })(this));
    };

    DataManager.prototype.reset = function() {
      if (this.offlineDb) {
        return this.offlineDb.clear();
      }
    };

    DataManager.prototype.clearToken = function(cb) {
      return this.setClientParam('token', null, cb);
    };

    DataManager.prototype.setClientParam = function(key, value, cb) {
      return this.transport.sendMessage(['c', key, JSON.stringify(value)], (function(_this) {
        return function(error, response) {
          if (error) {
            _this._onError(error);
          }
          return typeof cb === "function" ? cb(response) : void 0;
        };
      })(this));
    };

    DataManager.prototype.terminateClient = function(cb) {
      return $.get("" + this.server + "/" + this.version + "/core/terminateClient.php", {
        clientId: this.clientId
      }, cb);
    };

    DataManager.prototype.init = function(cb) {
      if (this.offlineDb && this.offlineDb.available()) {
        return this.offlineDb.read(this.clientVersion, this.dbName, (function(_this) {
          return function(data) {
            var getRel, id, instance, model, modelData, modelSchema, name, rel, _ref, _ref1, _ref2, _ref3, _ref4;
            if (data.schema.version !== _this.schemaVersion) {
              console.log('schema out of date');
              _this._changes._changes = (_ref = data.changes) != null ? _ref : {};
              _this._pendingUpdate = data.pendingUpdate;
              return _this.transport.init(_this.version, data.clientId, _this.dbName, data.schema.version, function(success) {
                if (success) {
                  console.log('pushing');
                  return _this._push(function() {
                    _this.offlineDb.clear();
                    return _this.init(cb);
                  });
                } else {
                  return typeof cb === "function" ? cb(false, 'outdatedSchemaNoConnection') : void 0;
                }
              });
            } else {
              _this.clientId = data.clientId;
              _this._setSchema(data.schema);
              _this._changes._changes = (_ref1 = data.changes) != null ? _ref1 : {};
              _this._pendingUpdate = data.pendingUpdate;
              console.log(data);
              getRel = function(model, id, name, instance) {
                var instanceData, instanceId, rel, relSchema, _ref2, _ref3;
                relSchema = _this.schema.models[model].relationships[name];
                if (((_ref2 = _this.schema.models[relSchema.model].relationships[relSchema.inverseRelationship]) != null ? _ref2.type : void 0) === 'One') {
                  rel = [];
                  _ref3 = data.data[relSchema.model];
                  for (instanceId in _ref3) {
                    instanceData = _ref3[instanceId];
                    if (instanceData[relSchema.inverseRelationship] === id) {
                      rel.push(instanceId);
                    }
                  }
                  return rel;
                } else {
                  return _.filter(instance[name], function(id) {
                    var _ref4;
                    return (_ref4 = data.data[relSchema.model]) != null ? _ref4[id] : void 0;
                  });
                }
              };
              _ref2 = data.data;
              for (model in _ref2) {
                modelData = _ref2[model];
                modelSchema = _this.schema.models[model];
                if (modelSchema.relationships) {
                  for (id in modelData) {
                    instance = modelData[id];
                    _ref3 = modelSchema.relationships;
                    for (name in _ref3) {
                      rel = _ref3[name];
                      switch (rel.type) {
                        case 'Many':
                          instance[name] = getRel(model, id, name, instance);
                          break;
                        case 'One':
                          if (!((_ref4 = data.data[rel.model]) != null ? _ref4[instance[name]] : void 0)) {
                            delete instance[name];
                          }
                      }
                    }
                  }
                }
              }
              return _this._init(function() {
                _this._changes.disable();
                _this.applyChanges(data.data, false);
                _this._changes.enable();
                if (!_this._offline) {
                  _this._connect(true);
                }
                if (typeof cb === "function") {
                  cb(true);
                }
                if (_this.opts.onClientId) {
                  return _this.opts.onClientId.call(_this, _this.clientId);
                }
              });
            }
          };
        })(this));
      } else {
        return this._initClientId((function(_this) {
          return function() {
            return _this._initSchema(function() {
              return _this._init(function() {
                if (_this.offlineDb) {
                  _this.offlineDb.create(_this.clientVersion, _this.clientId, _this.dbName, _this.schema);
                }
                return _this._connect(false, function(state) {
                  if (state !== 'offline') {
                    return _this.resource(_this.mainResource, function() {
                      return typeof cb === "function" ? cb(true) : void 0;
                    });
                  } else {
                    return typeof cb === "function" ? cb(false) : void 0;
                  }
                });
              });
            });
          };
        })(this));
      }
    };

    return DataManager;

  })();
});

//# sourceMappingURL=DataManager.js.map
