// Generated by CoffeeScript 1.8.0
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['xyzp/XObject'], function(XObject) {
  var ListInterface;
  return ListInterface = (function(_super) {
    __extends(ListInterface, _super);

    ListInterface.id = 1;

    ListInterface.prototype.setDataSource = function(dataSource) {
      var _ref;
      if (dataSource != null ? dataSource.observe : void 0) {
        if ((_ref = this.dataSource) != null) {
          _ref.stopObserving(this._observer);
        }
        this.set(dataSource);
        this.dataSource = dataSource;
        return dataSource.observe(this._observer = (function(_this) {
          return function(mutation) {
            switch (mutation.type) {
              case 'insertion':
                return _this.insert(mutation.value, mutation.position);
              case 'deletion':
                return _this["delete"](mutation.position);
              case 'movement':
                return _this.move(mutation.from, mutation.to);
              case 'setArray':
                return _this.set(_this.dataSource);
              case 'reset':
                return _this.set(_this.dataSource);
            }
          };
        })(this));
      } else {
        this.set(dataSource);
        return this.dataSource = dataSource;
      }
    };

    ListInterface.prototype._dataSourceLength = function() {
      if (_.isArray(this.dataSource)) {
        return this.dataSource.length;
      } else {
        return this.dataSource.length();
      }
    };

    ListInterface.prototype.destruct = function() {
      var _ref, _ref1;
      if ((_ref = this.dataSource) != null ? _ref.observe : void 0) {
        if ((_ref1 = this.dataSource) != null) {
          _ref1.stopObserving(this._observer);
        }
      }
      return ListInterface.__super__.destruct.apply(this, arguments);
    };

    function ListInterface(el, selector, mapping) {
      this.el = el;
      this.mapping = mapping;
      ListInterface.__super__.constructor.apply(this, arguments);
      this.id = ListInterface.id++;
      if (_.isString(selector)) {
        this.template = $(el.find(selector).get(0));
      } else {
        this.template = selector;
      }
      if (this.template.length === 0) {
        throw new Error("Failed to find template '" + selector + "'");
      }
      this.prevSibling = this.template.prev();
      this.nextSibling = this.template.next();
      this.parent = this.template.parent();
      if (this.parent.length === 0) {
        throw new Error("BAD");
      }
      this.els = [];
      this.deleteCbs = [];
      this.template.detach();
    }

    ListInterface.prototype.get = function(position) {
      var _ref;
      return (_ref = this.els[position]) != null ? _ref.el : void 0;
    };

    ListInterface.prototype.clear = function() {
      var el, _i, _len, _ref;
      _ref = this.els;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        el = _ref[_i];
        el.el.remove();
        el.onDelete();
      }
      this.els = [];
      return typeof this.onLengthChanged === "function" ? this.onLengthChanged() : void 0;
    };

    ListInterface.prototype.set = function(data) {
      this.clear();
      data.forEach((function(_this) {
        return function(item, i) {
          return _this.insert(item, i, false);
        };
      })(this));
      return typeof this.onMutation === "function" ? this.onMutation() : void 0;
    };

    ListInterface.prototype["delete"] = function(i) {
      var el, start;
      el = this.els[i];
      this.els.splice(i, 1);
      if (this.onDelete) {
        this.onDelete(el.el, function() {
          return el.el.remove();
        });
      } else {
        el.el.remove();
      }
      el.onDelete();
      if (this.count && this.fromEnd && this.els.length) {
        start = Math.max(0, this._dataSourceLength() - this.count);
        if (i >= start) {
          this.els[start].el.show();
        }
      }
      if (typeof this.onLengthChanged === "function") {
        this.onLengthChanged();
      }
      return typeof this.onMutation === "function" ? this.onMutation() : void 0;
    };

    ListInterface.prototype.insert = function(data, pos, signalMutation) {
      var deleteCb, el, elEntry, next, start, _ref;
      if (signalMutation == null) {
        signalMutation = true;
      }
      deleteCb = null;
      el = this.mapping(this.template.clone(), data, {
        pos: pos,
        onDelete: function(cb) {
          return deleteCb = cb;
        }
      });
      elEntry = {
        data: data,
        el: el,
        onDelete: function() {
          return typeof deleteCb === "function" ? deleteCb() : void 0;
        }
      };
      next = (_ref = this.els[pos]) != null ? _ref.el : void 0;
      if (next) {
        if (next.get(0)) {
          next.before(el);
        } else {
          parent.append(el);
        }
      } else {
        if (this.nextSibling.get(0)) {
          this.nextSibling.before(el);
        } else {
          this.parent.append(el);
        }
      }
      if (pos === 0) {
        this.els.unshift(elEntry);
      } else if (pos === this.els.length) {
        this.els.push(elEntry);
      } else {
        this.els.splice(pos, 0, elEntry);
      }
      if (this.count && this.fromEnd) {
        start = this._dataSourceLength() - this.count;
        if (pos < start) {
          el.hide();
        } else {
          if (this.els[start - 1]) {
            this.els[start - 1].el.hide();
          }
        }
      }
      if (typeof this.onInsert === "function") {
        this.onInsert(el);
      }
      if (typeof this.onLengthChanged === "function") {
        this.onLengthChanged();
      }
      if (signalMutation) {
        return typeof this.onMutation === "function" ? this.onMutation() : void 0;
      }
    };

    ListInterface.prototype.push = function(data) {
      return this.insert(data, this.els.length);
    };

    ListInterface.prototype.move = function(from, to) {
      var el, elEntry;
      el = this.els[from].el;
      if (from > to) {
        el.detach().insertBefore(this.els[to].el);
      } else {
        el.detach().insertAfter(this.els[to].el);
      }
      elEntry = this.els.splice(from, 1)[0];
      this.els.splice(to, 0, elEntry);
      if (typeof this.onMove === "function") {
        this.onMove(from, to);
      }
      return typeof this.onMutation === "function" ? this.onMutation() : void 0;
    };

    ListInterface.prototype.length = function() {
      return this.els.length;
    };

    return ListInterface;

  })(XObject);
});

//# sourceMappingURL=ListInterface.js.map
