// Generated by CoffeeScript 1.8.0
var __slice = [].slice;

define(['xyzp/XArray', 'xyzp/XValue', 'xyzp/Observable', 'xyzp/OfflineDB', 'xyzp/util', 'xyzp/FilteredArray', 'xyzp/ComputedValue', 'xyzp/XObject', 'xyzp/ModelInstance', 'xyzp/HasOneRelationship', 'xyzp/HasManyRelationship', 'xyzp/SortedArray'], function(XArray, XValue, Observable, OfflineDb, util, FilteredArray, ComputedValue, XObject, ModelInstance, HasOneRelationship, HasManyRelationship, SortedArray) {
  var Model;
  Model = (function() {
    function Model(_dataManager, _name, _schema) {
      this._dataManager = _dataManager;
      this._name = _name;
      this._schema = _schema;
      this._instances = new XArray;
      this._instancesById = {};
      this._addedInstances = [];
    }

    Model.prototype.init = function(done) {
      var attribute, data, id, instance, name, scope, _i, _len, _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      if (this._schema.scopes) {
        this._scopes = {};
        _ref = this._schema.scopes;
        for (name in _ref) {
          scope = _ref[name];
          if (!scope.parameters) {
            this._scopes[name] = util.objectList(new FilteredArray(this._instances, scope.test).retain());
          }
        }
      }
      if (this._schema.modelAttributes) {
        this._attributes = {};
        _ref1 = this._schema.modelAttributes;
        for (name in _ref1) {
          attribute = _ref1[name];
          if (!attribute.parameters) {
            (function(_this) {
              return (function(attribute) {
                if (attribute.prop) {
                  return _this._attributes[name] = attribute.prop.call(_this).retain();
                } else {
                  return _this._attributes[name] = new ComputedValue(function() {
                    return attribute.get.call(_this);
                  }).retain();
                }
              });
            })(this)(attribute);
          }
        }
      }
      if ((_ref2 = this._schema.storage) != null ? _ref2.localStorage : void 0) {
        data = localStorage.getItem(this._schema.storage.localStorage);
        if (data) {
          data = JSON.parse(data);
          if (data) {
            this.currentTimetstamp = data.timestamp;
            _ref3 = data.data;
            for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
              instance = _ref3[_i];
              id = instance.id;
              delete instance.id;
              this._addInstance(id, instance);
            }
            done();
            return;
          }
        }
      }
      if ((_ref4 = this._schema.storage) != null ? _ref4.file : void 0) {
        return $.get((_ref5 = this._schema.storage) != null ? _ref5.file : void 0, ((function(_this) {
          return function(response) {
            var _j, _len1, _ref6;
            _this.currentTimetstamp = response.timestamp;
            _ref6 = response.data;
            for (_j = 0, _len1 = _ref6.length; _j < _len1; _j++) {
              instance = _ref6[_j];
              id = instance.id;
              delete instance.id;
              _this._addInstance(id, instance);
            }
            return done();
          };
        })(this)), 'json');
      } else {
        return done();
      }
    };

    Model.prototype.scope = function() {
      var name, params, scope, _ref;
      name = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (scope = (_ref = this._schema.scopes) != null ? _ref[name] : void 0) {
        if (this._scopes[name]) {
          return this._scopes[name];
        } else {
          return util.objectList(new FilteredArray(this._instances, function(instance) {
            return scope.test.apply(scope, [instance].concat(__slice.call(params)));
          }));
        }
      }
    };

    Model.prototype.derive = function() {
      var name, params, scope;
      name = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (scope = this.scope.apply(this, [name].concat(__slice.call(params)))) {
        return scope;
      } else {
        switch (name) {
          case 'sorted':
            return new SortedArray(this._instances, function(a, b) {
              return util.compare(a.get(params[0]), b.get(params[0]), params[1]);
            });
          default:
            return this;
        }
      }
    };

    Model.prototype._hasInstance = function(id) {
      return this._instancesById[id];
    };

    Model.prototype._addInstance = function(id, props, init) {
      var instance;
      instance = this._instancesById[id] = new ModelInstance(this, id, props, init);
      this._addedInstances.push(instance);
      return instance;
    };

    Model.prototype._commitInstances = function() {
      var instance, _i, _len, _ref;
      _ref = this._addedInstances;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        instance = _ref[_i];
        this._instances.push(instance);
        instance.init();
      }
      return this._addedInstances = [];
    };

    Model.prototype.create = function(values) {
      var instance;
      if (values == null) {
        values = {};
      }
      instance = this._addInstance(this._dataManager.nextTemporaryId(), values, true);
      this._dataManager._changes.createInstance(1, this._name, instance.id, instance._syncValues());
      this._dataManager._setObjectForTemporaryId(instance.id, instance);
      this._commitInstances();
      return instance;
    };

    Model.prototype["delete"] = function(instance) {
      this._delete(instance);
      return this._dataManager._changes.deleteInstance(1, this._name, instance.id);
    };

    Model.prototype._delete = function(instance) {
      var inverseRelation, modelName, modelSchema, name, prop, relName, relSchema, _i, _len, _ref, _ref1, _ref2, _ref3;
      _ref = instance._properties;
      for (name in _ref) {
        prop = _ref[name];
        if (prop instanceof HasOneRelationship) {
          if (prop._schema.inverseRelationship) {
            inverseRelation = prop._inverseRelation();
            if (inverseRelation instanceof HasManyRelationship) {
              inverseRelation._remove(instance);
            } else if (inverseRelation instanceof HasOneRelationship) {
              inverseRelation._set(null);
            }
          }
        } else if (prop instanceof HasManyRelationship) {
          if (prop._schema.inverseRelationship) {
            prop.each(function(relInstance) {
              inverseRelation = prop._inverseRelation(relInstance);
              if (inverseRelation instanceof HasManyRelationship) {
                return inverseRelation.remove(instance, false);
              } else if (inverseRelation instanceof HasOneRelationship) {
                return inverseRelation._set(null);
              }
            });
          }
        }
      }
      _ref1 = this._dataManager.schema.models;
      for (modelName in _ref1) {
        modelSchema = _ref1[modelName];
        if (modelSchema.relationships) {
          _ref2 = modelSchema.relationships;
          for (relName in _ref2) {
            relSchema = _ref2[relName];
            if (relSchema.model === this._name && relSchema.type === 'One' && !relSchema.inverseRelationship) {
              _ref3 = this._dataManager.model(modelName).find(function(inst) {
                return inst.get(relName) === instance;
              });
              for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
                instance = _ref3[_i];
                instance.set(relName, null);
              }
            }
          }
        }
      }
      this._instances.remove(instance);
      delete this._instancesById[instance.id];
      return instance.destruct();
    };

    Model.prototype.instance = function(id) {
      return this._instancesById[id];
    };

    Model.prototype.contains = function(instance) {
      return true;
    };

    Model.prototype.findOne = function(predicate) {
      var values;
      if (_.isPlainObject(predicate)) {
        values = predicate;
        predicate = function(instance) {
          var name, value;
          for (name in values) {
            value = values[name];
            if (instance.get(name) !== value) {
              return false;
            }
          }
          return true;
        };
      }
      return this._instances.findOne(predicate);
    };

    Model.prototype.find = function(predicate) {
      var values;
      if (_.isPlainObject(predicate)) {
        values = predicate;
        predicate = function(instance) {
          var name, value;
          for (name in values) {
            value = values[name];
            if (instance.get(name) !== value) {
              return false;
            }
          }
          return true;
        };
      }
      return this._instances.find(predicate);
    };

    Model.prototype.call = function() {
      var func, method, params, _ref;
      method = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (func = (_ref = this._schema.modelMethods) != null ? _ref[method] : void 0) {
        return func.apply(this, params);
      } else if (method === 'create') {
        return this.create.apply(this, params);
      } else {
        throw new Error("no method " + method);
      }
    };

    Model.prototype.hasMethod = function(method) {
      var _ref;
      return ((_ref = this._schema.modelMethods) != null ? _ref[method] : void 0) || _.isFunction(this[method]);
    };

    Model.prototype.attr = function() {
      var attribute, name, params, _ref;
      name = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (!_.isNaN(parseInt(name))) {
        return this.get(name);
      } else {
        if (this._attributes[name]) {
          return this._attributes[name].get();
        } else if (attribute = (_ref = this._schema.modelAttributes) != null ? _ref[name] : void 0) {
          if (attribute.prop) {
            return attribute.prop.apply(this, params).get();
          } else {
            return attribute.get.apply(this, params);
          }
        }
      }
    };

    Model.prototype.attrCont = function() {
      var attribute, name, params, r, _ref, _ref1, _ref2, _ref3;
      name = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (!_.isNaN(parseInt(name))) {
        return new XValue(this.get(name));
      } else {
        r = (_ref = (_ref1 = this._attributes) != null ? _ref1[name] : void 0) != null ? _ref : (_ref2 = this._scopes) != null ? _ref2[name] : void 0;
        if (!r) {
          attribute = (_ref3 = this._schema.modelAttributes) != null ? _ref3[name] : void 0;
          if (attribute) {
            if (attribute.prop) {
              return attribute.prop.apply(this, params);
            } else {
              return new ComputedValue((function(_this) {
                return function() {
                  return attribute.get.apply(_this, params);
                };
              })(this));
            }
          }
        } else {
          return r;
        }
      }
    };

    Model.prototype.updateFromRemote = function() {
      return $.get(this._schema.storage.remote, {
        timestamp: this.currentTimetstamp
      }, ((function(_this) {
        return function(response) {
          if (response !== 'null') {
            localStorage.setItem(_this._schema.storage.localStorage, response);
            response = JSON.parse(response);
            _this.currentTimetstamp = response.timestamp;
            return _this.sync(response.data);
          }
        };
      })(this)), 'text');
    };

    Model.prototype.sync = function(data) {
      var id, instance, instances, record, toDelete, _i, _j, _len, _len1, _results;
      instances = {};
      for (_i = 0, _len = data.length; _i < _len; _i++) {
        record = data[_i];
        id = record.id;
        delete record.id;
        instances[id] = true;
        if (instance = this.instance(id)) {
          instance.setProperties(record);
        } else {
          this._addInstance(id, record);
        }
      }
      toDelete = [];
      this._instances.each((function(_this) {
        return function(instance) {
          if (!instances[instance.get('id')]) {
            return toDelete.push(instance.get('id'));
          }
        };
      })(this));
      _results = [];
      for (_j = 0, _len1 = toDelete.length; _j < _len1; _j++) {
        id = toDelete[_j];
        _results.push(this.instance(id)["delete"]());
      }
      return _results;
    };

    return Model;

  })();
  util.observableProxy(Model, '_instances');
  util.arrayProxy(Model, '_instances');
  return Model;
});

//# sourceMappingURL=Model.js.map
