// Generated by CoffeeScript 1.8.0
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['xyzp/ModelProperty', 'xyzp/ComputedValue', 'xyzp/Observable'], function(ModelProperty, ComputedValue, Observable) {
  var ModelAttribute;
  ModelAttribute = (function(_super) {
    __extends(ModelAttribute, _super);

    ModelAttribute.prototype.__valueContainer = true;

    function ModelAttribute() {
      ModelAttribute.__super__.constructor.apply(this, arguments);
      if (this._schema.init) {
        this._schema.init.call(this);
      }
    }

    ModelAttribute.prototype.init = function() {
      if (this._schema.type === 'computed') {
        if (this._schema.get) {
          this._computedValue = new ComputedValue(((function(_this) {
            return function() {
              return _this._schema.get.apply(_this._instance, _this._params);
            };
          })(this)), this._name);
        } else if (this._schema.prop) {
          this._computedValue = this._schema.prop.apply(this._instance, this._params);
        }
        this.addObject(this._computedValue);
        return this._computedValue.observe((function(_this) {
          return function(mutation) {
            return _this._fireMutation(mutation);
          };
        })(this));
      }
    };

    ModelAttribute.prototype.destruct = function() {
      if (this._schema.destruct) {
        this._schema.destruct();
      }
      return ModelAttribute.__super__.destruct.apply(this, arguments);
    };

    ModelAttribute.prototype._changed = function() {
      return this._fireMutation({
        type: 'set',
        value: this.get()
      });
    };

    ModelAttribute.prototype._set = function(value, from) {
      var arr, e;
      switch (this._schema.type) {
        case 'datetime':
          if (_.isString(value)) {
            if (from === 'applyChanges' && value.match(/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$/)) {
              arr = value.split(/[- :]/);
              value = new Date(Date.UTC(arr[0], arr[1] - 1, arr[2], arr[3], arr[4], arr[5]));
              if (!value.isValid()) {
                value = null;
              }
            } else {
              if (value) {
                value = Date.create(value);
              } else {
                value = null;
              }
            }
          }
          break;
        case 'date':
          if (_.isString(value)) {
            if (from === 'applyChanges' && value.match(/^\d{4}-\d{2}-\d{2}$/)) {
              arr = value.split(/[- :]/);
              value = new Date(arr[0], arr[1] - 1, arr[2]);
              if (!value.isValid()) {
                value = null;
              }
            } else {
              if (value) {
                value = Date.create(value);
              } else {
                value = null;
              }
            }
          }
          break;
        case 'int':
          value = parseInt(value);
          break;
        case 'bool':
          value = !!value;
          break;
        case 'float':
          value = parseFloat(value);
          break;
        case 'computed':
          if (this._schema.set) {
            value = this._schema.set.call(this._instance, value);
          } else {
            return;
          }
          break;
        case 'duration':
          if (_.isString(value)) {
            try {
              value = juration.parse(value);
            } catch (_error) {
              e = _error;
              value = 0;
            }
          }
      }
      if (this._schema.type === 'object' || this._value !== value) {
        this._value = value;
        this._changed();
        return true;
      } else {
        return false;
      }
    };

    ModelAttribute.prototype.get = function() {
      return xyz.ValueCapture.capture(this, (function(_this) {
        return function() {
          switch (_this._schema.type) {
            case 'computed':
              if (_this._computedValue) {
                return _this._computedValue.get();
              }
              break;
            default:
              return ModelAttribute.__super__.get.apply(_this, arguments);
          }
        };
      })(this));
    };

    ModelAttribute.prototype.value = function(context) {
      if (context === 'sync') {
        return this._syncValue();
      } else {
        return this.get();
      }
    };

    ModelAttribute.prototype.form = function(type) {
      if (type === 'display') {
        if (this._schema.type === 'duration') {
          return new ComputedValue((function(_this) {
            return function() {
              return juration.stringify(_this.get());
            };
          })(this));
        }
      } else if (type === 'dollarFormat') {
        return new ComputedValue((function(_this) {
          return function() {
            if (_this.get()) {
              return '$' + _this.get().format(2);
            } else {
              return '(none)';
            }
          };
        })(this));
      } else if (type === 'dateFormat') {
        return new ComputedValue((function(_this) {
          return function() {
            var _ref;
            return (_ref = _this.get()) != null ? _ref.format('{Mon} {ord}, {year}') : void 0;
          };
        })(this));
      }
      return this;
    };

    ModelAttribute.prototype.derive = function(type) {
      return this.form(type);
    };

    ModelAttribute.prototype.meta = function(query) {
      if (query === 'type' && this._schema.type === 'computed') {
        return this._schema.dataType;
      } else {
        return this._schema[query];
      }
    };

    ModelAttribute.prototype._syncValue = function() {
      if (this._schema.type === 'datetime') {
        if (this._value) {
          return this._value.toMysqlFormat();
        } else {
          return null;
        }
      } else if (this._schema.type === 'date') {
        if (this._value) {
          return this._value.toMysqlDateFormat();
        } else {
          return null;
        }
      } else if (this._schema.type === 'bool') {
        if (this._value) {
          return 1;
        } else {
          return 0;
        }
      } else {
        return ModelAttribute.__super__._syncValue.apply(this, arguments);
      }
    };

    return ModelAttribute;

  })(ModelProperty);
  _.extend(ModelAttribute.prototype, Observable.prototype);
  return ModelAttribute;
});

//# sourceMappingURL=ModelAttribute.js.map
