// Generated by CoffeeScript 1.8.0
var __slice = [].slice;

define(['xyzp/ModelProperty', 'xyzp/XValue'], function(ModelProperty, XValue) {
  var ModelInstance;
  return ModelInstance = (function() {
    ModelInstance.prototype.__value = true;

    function ModelInstance(_model, id, props, init) {
      var attrName, attrSchema, name, relName, relSchema, value, _ref, _ref1, _ref2, _ref3, _ref4;
      this._model = _model;
      this.id = id;
      xyz.MutationEvents.pause();
      this._properties = {};
      if (!this._isLocal()) {
        if (((_ref = this._model._schema.id) != null ? _ref.type : void 0) === 'int') {
          this.id = parseInt(this.id);
        }
      }
      _ref1 = this._model._schema.attributes;
      for (attrName in _ref1) {
        attrSchema = _ref1[attrName];
        if (attrSchema.parameters || attrSchema.type === 'computed') {
          continue;
        }
        this._properties[attrName] = ModelProperty.create(this, attrName).retain();
      }
      _ref2 = this._model._schema.relationships;
      for (relName in _ref2) {
        relSchema = _ref2[relName];
        if (relSchema.type !== 'scope') {
          this._properties[relName] = ModelProperty.create(this, relName).retain();
        }
      }
      _ref3 = this._model._schema.relationships;
      for (relName in _ref3) {
        relSchema = _ref3[relName];
        if (relSchema.type === 'scope' && !relSchema.parameters) {
          this._properties[relName] = ModelProperty.create(this, relName).retain();
        }
      }
      for (name in props) {
        value = props[name];
        if (this._properties[name]) {
          this._properties[name]._set(value);
        }
      }
      _ref4 = this._model._schema.attributes;
      for (attrName in _ref4) {
        attrSchema = _ref4[attrName];
        if (!attrSchema.parameters && attrSchema.type === 'computed') {
          this._properties[attrName] = ModelProperty.create(this, attrName).retain();
          if (props[attrName] != null) {
            this._properties[attrName].set(props[attrName]);
          }
        }
      }
      if (init) {
        this.init();
      }
      xyz.MutationEvents.resume();
    }

    ModelInstance.prototype.init = function() {
      var name, prop, _ref, _results;
      _ref = this._properties;
      _results = [];
      for (name in _ref) {
        prop = _ref[name];
        _results.push(typeof prop.init === "function" ? prop.init() : void 0);
      }
      return _results;
    };

    ModelInstance.prototype.properties = function() {
      return _.keys(this._properties);
    };

    ModelInstance.prototype.destruct = function() {
      var prop, propName, _ref, _results;
      _ref = this._properties;
      _results = [];
      for (propName in _ref) {
        prop = _ref[propName];
        _results.push(prop.destruct());
      }
      return _results;
    };

    ModelInstance.prototype._isLocal = function() {
      return this._model._dataManager.isTemporaryId(this.id);
    };

    ModelInstance.prototype.hasProp = function(name) {
      var _ref, _ref1;
      return ((_ref = this._model._schema.attributes) != null ? _ref[name] : void 0) || ((_ref1 = this._model._schema.properties) != null ? _ref1[name] : void 0);
    };

    ModelInstance.prototype.prop = function() {
      var name, params, prop, schema;
      name = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (name === 'id') {
        return new XValue(this.id);
      } else if (this._properties[name]) {
        return this._properties[name];
      } else {
        schema = this._model._schema.attributes[name];
        if (schema && schema.type === 'computed' && schema.parameters) {
          prop = ModelProperty.create(this, name, params);
          if (typeof prop.init === "function") {
            prop.init();
          }
          return prop;
        } else {
          throw new Error("no property `" + name + "`");
        }
      }
    };

    ModelInstance.prototype.get = function() {
      var params, property;
      property = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      return this.prop.apply(this, [property].concat(__slice.call(params))).value();
    };

    ModelInstance.prototype._set = function(property, value, from) {
      if (from == null) {
        from = null;
      }
      return this._properties[property]._set(value, from);
    };

    ModelInstance.prototype.set = function(property, value) {
      return this.prop(property).set(value);
    };

    ModelInstance.prototype.setProperties = function(properties) {
      var name, value, _results;
      _results = [];
      for (name in properties) {
        value = properties[name];
        if (this.hasProp(name)) {
          _results.push(this.set(name, value));
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    ModelInstance.prototype._recordChange = function(type, property, value) {};

    ModelInstance.prototype.applyChanges = function(changes) {
      var propertyChange, propertyPath, _results;
      if (changes === 'delete') {
        return this._model._delete(this);
      } else {
        _results = [];
        for (propertyPath in changes) {
          propertyChange = changes[propertyPath];
          if (propertyPath[0] === '@') {
            continue;
          }
          _results.push(this._set(propertyPath, propertyChange, 'applyChanges'));
        }
        return _results;
      }
    };

    ModelInstance.prototype["delete"] = function() {
      return this._model["delete"](this);
    };

    ModelInstance.prototype._dataManager = function() {
      return this._model._dataManager;
    };

    ModelInstance.prototype.value = function(context) {
      var valueFunc, _ref;
      if (valueFunc = (_ref = this._model._schema.value) != null ? _ref[context] : void 0) {
        return valueFunc.call(this);
      } else {
        return this;
      }
    };

    ModelInstance.prototype.form = function(context) {
      var form, _ref;
      if (form = (_ref = this._model._schema.form) != null ? _ref[context] : void 0) {
        return this.prop(form);
      } else {
        return this;
      }
    };

    ModelInstance.prototype._syncValues = function() {
      var prop, propName, values, _ref;
      values = {};
      _ref = this._properties;
      for (propName in _ref) {
        prop = _ref[propName];
        if (prop._syncValue && (prop.shouldSync && prop.shouldSync() || !prop.shouldSync)) {
          values[propName] = prop._syncValue();
        }
      }
      return values;
    };

    ModelInstance.prototype.call = function() {
      var func, method, params, _ref;
      method = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (func = (_ref = this._model._schema.methods) != null ? _ref[method] : void 0) {
        return func.apply(this, params);
      } else if (method === 'delete') {
        return this["delete"]();
      } else if (this.hasProp(method)) {
        return this.get.apply(this, [method].concat(__slice.call(params)));
      }
    };

    ModelInstance.prototype.hasMethod = function(method) {
      var _ref;
      console.log(method);
      return ((_ref = this._model._schema.methods) != null ? _ref[method] : void 0) || this.hasProp(method);
    };

    return ModelInstance;

  })();
});

//# sourceMappingURL=ModelInstance.js.map
