// Generated by CoffeeScript 1.8.0
define(function() {
  var Observable;
  return Observable = (function() {
    function Observable() {}

    Observable.prototype.observe = function(observer) {
      if (!observer) {
        throw new Error();
      }
      if (this._observers == null) {
        this._observers = [];
      }
      this._observers.push(observer);
      if (this.retain && this._observers.length === 1) {
        if (this._observeReleaseTimer) {
          clearTimeout(this._observeReleaseTimer);
          delete this._observeReleaseTimer;
        }
        this.retain();
        this.fireEvent('observeRetain');
        return this._observeRetained = true;
      }
    };

    Observable.prototype.stopObserving = function(observer) {
      var before;
      before = this._observers.length;
      if (this._observers == null) {
        this._observers = [];
      }
      _.pull(this._observers, observer);
      if (before && !this._observers.length && this.retain) {
        return this._observeReleaseTimer = setTimeout(((function(_this) {
          return function() {
            _this.release();
            _this.fireEvent('observeRelease');
            return _this._observeRetained = false;
          };
        })(this)), 0);
      }
    };

    Observable.prototype._fireMutation = function(mutation) {
      var i, observer, _i, _len, _ref, _results;
      mutation.observable = this;
      if (xyz.MutationEvents.isPaused()) {
        return xyz.MutationEvents.addMutation(this, mutation);
      } else {
        if (this._observers) {
          _ref = _.clone(this._observers);
          _results = [];
          for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
            observer = _ref[i];
            _results.push(typeof observer === "function" ? observer(mutation, i) : void 0);
          }
          return _results;
        }
      }
    };

    return Observable;

  })();
});

//# sourceMappingURL=Observable.js.map
