// Generated by CoffeeScript 1.8.0
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['xyzp/XObject', 'xyzp/XArray', 'xyzp/ObservePool', 'xyzp/util'], function(XObject, XArray, ObservePool, util) {
  var PagedList;
  PagedList = (function(_super) {
    __extends(PagedList, _super);

    function PagedList(source, pageCount) {
      this.source = source;
      this.pageCount = pageCount;
      PagedList.__super__.constructor.apply(this, arguments);
      this.pagesShown = 1;
      this.array = this.addObject(new XArray);
      this.update();
      this.observeObject(this.source, '_doUpdate');
      this.array.on('observeRetain', (function(_this) {
        return function() {
          return _this.retain();
        };
      })(this));
      this.array.on('observeRelease', (function(_this) {
        return function() {
          return _this.release();
        };
      })(this));
    }

    PagedList.prototype._doUpdate = function(mutation) {
      if (!this._willUpdate) {
        this._willUpdate = true;
        return setTimeout(((function(_this) {
          return function() {
            _this.update();
            return _this._willUpdate = false;
          };
        })(this)), 0);
      }
    };

    PagedList.prototype.update = function() {
      var i, _i, _ref, _results;
      this.array.clear();
      _results = [];
      for (i = _i = 0, _ref = Math.min(this.source.length(), this.pagesShown * this.pageCount); 0 <= _ref ? _i < _ref : _i > _ref; i = 0 <= _ref ? ++_i : --_i) {
        _results.push(this.array.push(this.source.get(i)));
      }
      return _results;
    };

    PagedList.prototype.nextPage = function() {
      var maxPage;
      maxPage = Math.ceil(this.source.length() / this.pageCount);
      this.pagesShown = Math.min(maxPage, this.pagesShown + 1);
      return this._doUpdate();
    };

    PagedList.prototype.more = function() {
      return this.nextPage();
    };

    PagedList.prototype.less = function() {
      this.pagesShown = Math.max(1, this.pagesShown - 1);
      return this._doUpdate();
    };

    PagedList.prototype.get = function(prop) {
      if (prop === 'totalLength') {
        return this.source.length();
      } else {
        return this.array.get(prop);
      }
    };

    return PagedList;

  })(XObject);
  util.observableProxy(PagedList, 'array');
  util.arrayProxy(PagedList, 'array');
  return PagedList;
});

//# sourceMappingURL=PagedList.js.map
