// Generated by CoffeeScript 1.8.0
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __slice = [].slice;

define(['xyzp/Observable', 'xyzp/XObject', 'xyzp/ObservePool', 'xyzp/util'], function(Observable, XObject, ObservePool, util) {
  var PropertyPath;
  PropertyPath = (function(_super) {
    __extends(PropertyPath, _super);

    PropertyPath.prototype.__valueContainer = true;

    function PropertyPath() {
      var object, params, path;
      object = arguments[0], path = arguments[1], params = 3 <= arguments.length ? __slice.call(arguments, 2) : [];
      this.object = object;
      this.params = params;
      PropertyPath.__super__.constructor.apply(this, arguments);
      this.parts = path.split('.');
      this.prevValue = this.get();
      this._update();
    }

    PropertyPath.prototype._doUpdate = function() {
      if (!this._willUpdate) {
        this._willUpdate = true;
        return setTimeout(((function(_this) {
          return function() {
            _this._update();
            return _this._willUpdate = false;
          };
        })(this)), 0);
      }
    };

    PropertyPath.prototype._update = function() {
      var i, obj, prop, propName, _i, _len, _ref;
      this.allStopObserving();
      obj = this.object;
      _ref = this.parts;
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        propName = _ref[i];
        if (obj) {
          if (util.isList(obj)) {
            if (i !== this.parts.length - 1) {
              obj = obj.get(propName);
            }
          } else {
            prop = obj.prop.apply(obj, [propName].concat(__slice.call(this.params)));
            if (i === this.parts.length - 1) {
              this.observeObject(prop, '_changed');
            } else {
              this.observeObject(prop, '_doUpdate');
              obj = obj.get(propName);
            }
          }
        } else {
          break;
        }
      }
      return this._changed();
    };

    PropertyPath.prototype._changed = function() {
      var value;
      value = this.get();
      if (this.prevValue !== value) {
        this.prevValue = value;
        return this._fireMutation({
          type: 'set',
          value: value
        });
      }
    };

    PropertyPath.prototype._prop = function() {
      var i, obj, propName, _i, _len, _ref;
      obj = this.object;
      _ref = this.parts;
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        propName = _ref[i];
        if (obj) {
          if (i === this.parts.length - 1) {
            return obj.prop.apply(obj, [propName].concat(__slice.call(this.params)));
          } else {
            obj = obj.get(propName);
          }
        } else {
          return void 0;
        }
      }
    };

    PropertyPath.prototype.get = function() {
      var prop;
      prop = this._prop();
      if (prop) {
        return prop.get();
      } else {
        return void 0;
      }
    };

    PropertyPath.prototype.value = function(context) {
      var prop;
      prop = this._prop();
      if (prop) {
        return prop.value(context);
      } else {
        return void 0;
      }
    };

    PropertyPath.prototype.form = function(context) {
      var prop;
      prop = this._prop();
      if (prop) {
        return prop.form(context);
      } else {
        return void 0;
      }
    };

    PropertyPath.prototype.set = function(value, context) {
      var prop;
      prop = this._prop();
      if (prop) {
        return prop.set(value, context);
      }
    };

    PropertyPath.prototype.meta = function(query) {
      var prop;
      prop = this._prop();
      if (prop) {
        return prop.meta(query);
      }
    };

    return PropertyPath;

  })(XObject);
  _.extend(PropertyPath.prototype, Observable.prototype);
  return PropertyPath;
});

//# sourceMappingURL=PropertyPath.js.map
