// Generated by CoffeeScript 1.8.0
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __slice = [].slice;

define(['xyzp/XObject', 'xyzp/XValue', 'xyzp/ObservePool', 'xyzp/util'], function(XObject, XValue, ObservePool, util) {
  var ReducedArray;
  ReducedArray = (function(_super) {
    __extends(ReducedArray, _super);

    function ReducedArray() {
      var funcs, source;
      source = arguments[0], funcs = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      this.source = source;
      ReducedArray.__super__.constructor.apply(this, arguments);
      if (funcs.length === 1) {
        this._initFunc = function(value) {
          return value;
        };
        this._reduceFunc = funcs[0];
      } else {
        this._initFunc = funcs[0], this._reduceFunc = funcs[1];
      }
      this._value = this.addObject(new XValue);
      this.observePool = this.addObject(new ObservePool);
      this.update();
      this.observeObject(this.source, '_doUpdate');
      this._value.on('observeRetain', (function(_this) {
        return function() {
          return _this.retain();
        };
      })(this));
      this._value.on('observeRelease', (function(_this) {
        return function() {
          return _this.release();
        };
      })(this));
    }

    ReducedArray.prototype._doUpdate = function() {
      if (!this._willUpdate) {
        this._willUpdate = true;
        return setTimeout(((function(_this) {
          return function() {
            _this.update();
            return _this._willUpdate = false;
          };
        })(this)), 0);
      }
    };

    ReducedArray.prototype.update = function(mutation) {
      var reducedValue;
      this.observePool.allStopObserving();
      if (this.source.length()) {
        reducedValue = this._initFunc(this.source.get(0));
        if (this.source.length() > 1) {
          this.source.each((function(_this) {
            return function(el, i) {
              var capture, captures, observable, _i, _len, _results;
              if (i === 0) {
                return;
              }
              capture = xyz.ValueCapture.start();
              reducedValue = _this._reduceFunc(reducedValue, el);
              captures = capture.stop();
              _results = [];
              for (_i = 0, _len = captures.length; _i < _len; _i++) {
                observable = captures[_i];
                _results.push(_this.observePool.observe(observable, (function() {
                  return _this._doUpdate();
                })));
              }
              return _results;
            };
          })(this));
        }
        return this._value.set(reducedValue);
      } else {
        return this._value.set(null);
      }
    };

    ReducedArray.prototype.get = function() {
      return this._value.get();
    };

    ReducedArray.prototype.form = function() {
      return this;
    };

    return ReducedArray;

  })(XObject);
  util.observableProxy(ReducedArray, '_value');
  return ReducedArray;
});

//# sourceMappingURL=ReducedArray.js.map
