// Generated by CoffeeScript 1.8.0
var __slice = [].slice,
  __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

define(['xyzp/XValue', 'xyzp/ListInterface', 'xyzp/ValueInterface', 'xyzp/PropertyPath', 'xyzp/ComputedValue', 'xyzp/util', 'xyzp/HasManyRelationship', 'xyzp/XArray', 'xyzp/ComputedList', 'xyzp/Model'], function(XValue, ListInterface, ValueInterface, PropertyPath, ComputedValue, util, HasManyRelationship, XArray, ComputedList, Model) {
  var ParseNode, PathComponent, Script, Token, TokenStream, nodeInterpreters, parseExpression, parsePath, parsePathComponent;
  Token = (function() {
    function Token(type, value) {
      this.type = type;
      this.value = value;
    }

    return Token;

  })();
  TokenStream = (function() {
    function TokenStream(tokens) {
      this.tokens = tokens;
      this.i = 0;
    }

    TokenStream.prototype.hasNext = function() {
      return this.i < this.tokens.length;
    };

    TokenStream.prototype.next = function() {
      var type, values;
      type = arguments[0], values = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (type == null) {
        type = null;
      }
      if (type) {
        if (!this.checkToken.apply(this, [type].concat(__slice.call(values)))) {
          throw new Error('invalid token');
        }
      }
      return this.tokens[this.i++];
    };

    TokenStream.prototype.nextValue = function() {
      var type, values;
      type = arguments[0], values = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (type == null) {
        type = null;
      }
      return this.next.apply(this, [type].concat(__slice.call(values))).value;
    };

    TokenStream.prototype.check = function() {
      var types, _ref;
      types = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      return this.hasNext() && (_ref = this.tokens[this.i].type, __indexOf.call(types, _ref) >= 0);
    };

    TokenStream.prototype.checkToken = function() {
      var type, values, _ref, _ref1;
      type = arguments[0], values = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      if (!_.isArray(type)) {
        type = [type];
      }
      return this.hasNext() && (_ref = this.tokens[this.i].type, __indexOf.call(type, _ref) >= 0) && (!values.length || (_ref1 = this.tokens[this.i].value, __indexOf.call(values, _ref1) >= 0));
    };

    return TokenStream;

  })();
  window.tokenize = function(input) {
    var pattern, tokenMappings, tokenMatch, tokenMatches, tokenPattern, tokenType, tokenTypes, tokens, _i, _len, _ref;
    tokenTypes = {
      number: /\d(\.\d+)?/,
      sigil: '->|//|[@#:$%.&^]',
      string: /'(?:\\'|[^'])*'|"(?:\\"|[^"])*"/,
      operator: '<=|>=|!=|==|&&|\\|\\||[!+\\-=*/<>]',
      parenthesis: '[()]',
      comma: ',',
      identifier: /[A-z][A-z0-9]*/
    };
    tokenMappings = {
      string: function(value) {
        return value.substring(1, value.length - 1).replace(/\\/g, '\\').replace(/\'/g, '\'').replace(/\"/g, '"');
      }
    };
    pattern = (function() {
      var _results;
      _results = [];
      for (tokenType in tokenTypes) {
        tokenPattern = tokenTypes[tokenType];
        _results.push('(?:' + (tokenPattern instanceof RegExp ? tokenPattern.source : tokenPattern) + ')');
      }
      return _results;
    })();
    pattern = pattern.join('|');
    pattern = new RegExp(pattern, 'g');
    tokenMatches = input.match(pattern);
    tokens = [];
    for (_i = 0, _len = tokenMatches.length; _i < _len; _i++) {
      tokenMatch = tokenMatches[_i];
      for (tokenType in tokenTypes) {
        tokenPattern = tokenTypes[tokenType];
        if (new RegExp("^" + (new RegExp(tokenPattern).source) + "$").exec(tokenMatch)) {
          tokens.push(new Token(tokenType, (_ref = typeof tokenMappings[tokenType] === "function" ? tokenMappings[tokenType](tokenMatch) : void 0) != null ? _ref : tokenMatch));
          break;
        }
      }
    }
    return tokens;
  };
  ParseNode = (function() {
    function ParseNode(type, contents) {
      this.type = type;
      this.contents = contents;
    }

    ParseNode.fromToken = function(nodeFactory, token) {
      return nodeFactory.createNode(ParseNode, token.type, token.value);
    };

    return ParseNode;

  })();
  PathComponent = (function() {
    function PathComponent(identifier, type, params) {
      this.identifier = identifier;
      this.type = type;
      this.params = params;
    }

    return PathComponent;

  })();
  parsePathComponent = function(nodeFactory, stream, i, config) {
    var identifier, param, params, sigil;
    if (config == null) {
      config = {};
    }
    if (i === 0) {
      if (stream.check('sigil')) {
        return new PathComponent(stream.nextValue.apply(stream, ['sigil'].concat(__slice.call(config.baseSigils))), 'base');
      } else {
        identifier = stream.nextValue(['identifier', 'number']);
        if (stream.checkToken('parenthesis', '(')) {
          stream.next();
          params = [];
          while (param = parseExpression(nodeFactory, stream, config)) {
            params.push(param);
            if (stream.check('comma')) {
              stream.next();
            } else if (stream.check('parenthesis', ')')) {
              break;
            }
          }
          stream.next('parenthesis', ')');
          return new PathComponent(identifier, 'method', params);
        } else {
          return new PathComponent(identifier, 'prop');
        }
      }
    } else {
      if (stream.checkToken('sigil', '.', ':', '->')) {
        sigil = stream.nextValue('sigil', '.', ':', '->');
        identifier = stream.nextValue(['identifier', 'number']);
        if (sigil === '.' || sigil === ':') {
          if (stream.checkToken('parenthesis', '(')) {
            stream.next();
            params = [];
            while (param = parseExpression(nodeFactory, stream, config)) {
              params.push(param);
              if (stream.check('comma')) {
                stream.next();
              } else if (stream.check('parenthesis', ')')) {
                break;
              }
            }
            stream.next('parenthesis', ')');
            if (sigil === '.') {
              return new PathComponent(identifier, 'method', params);
            } else if (sigil === ':') {
              return new PathComponent(identifier, 'transform', params);
            }
          } else {
            if (sigil === '.') {
              return new PathComponent(identifier, 'prop');
            } else if (sigil === ':') {
              return new PathComponent(identifier, 'transform');
            }
          }
        } else {
          return new PathComponent(identifier, 'metaQuery');
        }
      } else if (i === 1 && stream.check('identifier')) {
        identifier = stream.nextValue(['identifier', 'number']);
        if (stream.checkToken('parenthesis', '(')) {
          stream.next();
          params = [];
          while (param = parseExpression(nodeFactory, stream, config)) {
            params.push(param);
            if (stream.check('comma')) {
              stream.next();
            } else if (stream.check('parenthesis', ')')) {
              break;
            }
          }
          stream.next('parenthesis', ')');
          return new PathComponent(identifier, 'method', params);
        } else {
          return new PathComponent(identifier, 'prop');
        }
      }
    }
  };
  parsePath = function(nodeFactory, stream, config) {
    var component, components, i;
    if (config == null) {
      config = {};
    }
    components = [];
    i = 0;
    while (true) {
      component = parsePathComponent(nodeFactory, stream, i++, config);
      if (component) {
        components.push(component);
      } else {
        return nodeFactory.createNode(ParseNode, 'path', components);
      }
    }
  };
  parseExpression = function(nodeFactory, stream, config) {
    var output;
    if (config == null) {
      config = {};
    }
    output = [];
    while (stream.hasNext()) {
      if (stream.check('number', 'string', 'operator')) {
        output.push(ParseNode.fromToken(nodeFactory, stream.next()));
      } else if (stream.check('sigil', 'identifier')) {
        output.push(parsePath(nodeFactory, stream, config));
      } else {
        break;
      }
    }
    if (output.length) {
      return nodeFactory.createNode(ParseNode, 'expression', output);
    }
  };
  nodeInterpreters = {
    expression: function(node) {
      return this.interpretNode(node.contents[0]);
    },
    path: function(node) {
      return this._executePath(node.contents);
    },
    number: function(node) {
      return parseFloat(node.contents);
    },
    string: function(node) {
      return node.contents;
    },
    operator: function(node) {
      return node.contents;
    }
  };
  return Script = (function() {
    Script.prototype.createNode = function() {
      var args, constr, n;
      constr = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      n = (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(constr, args, function(){});
      n.debug = this.debug;
      return n;
    };

    Script.prototype.interpretNode = function(node) {
      return nodeInterpreters[node.type].call(this, node);
    };

    function Script(src, params, debug) {
      this.src = src;
      this.debug = debug;
      this.bases = params.bases, this.scope = params.scope, this._value = params.value, this._valueCont = params.valueCont, this.operation = params.operation, this.defaultParams = params.defaultParams;
      this.node = parseExpression(this, new TokenStream(tokenize(src)), {
        baseSigils: _.keys(this.bases)
      });
    }

    Script.prototype.execute = function() {
      return this.interpretNode(this.node);
    };

    Script.prototype._executePath = function(path, returnEndPair, returnCont) {
      var comp, currentObject, i, obj, param, params, _i, _len, _ref, _ref1;
      if (returnEndPair == null) {
        returnEndPair = false;
      }
      if (returnCont == null) {
        returnCont = false;
      }
      if (this.debug) {
        console.log(path);
      }
      delete this.valueContainer;
      currentObject = null;
      for (i = _i = 0, _len = path.length; _i < _len; i = ++_i) {
        comp = path[i];
        if (this.debug) {
          console.log(currentObject);
        }
        if ((returnEndPair || returnCont) && i === path.length - 1) {
          if (returnEndPair) {
            return [currentObject, comp];
          } else if (returnCont) {
            return this._valueCont(currentObject, comp.identifier);
          }
        } else {
          switch (comp.type) {
            case 'base':
              currentObject = this.bases[comp.identifier];
              break;
            case 'prop':
              obj = i === 0 ? this.scope[0] : currentObject;
              if (this.debug) {
                console.log('asdf', obj);
              }
              if (this.operation === 'call' && i === path.length - 1 && !this.params) {
                params = (_ref = this.defaultParams) != null ? _ref : [];
                if (typeof obj.hasMethod === "function" ? obj.hasMethod(comp.identifier) : void 0) {
                  currentObject = obj.call.apply(obj, [comp.identifier].concat(__slice.call(params)));
                } else if (_.isFunction(obj[comp.identifier])) {
                  currentObject = obj[comp.identifier].apply(obj, params);
                }
              } else {
                this.valueContainer = this._valueCont(obj, comp.identifier);
                currentObject = this._value(obj, comp.identifier);
                if (currentObject == null) {
                  return;
                }
              }
              if (_.isFunction(currentObject)) {
                currentObject = currentObject();
              }
              break;
            case 'transform':
              params = (function() {
                var _j, _len1, _ref1, _results;
                if (comp.params) {
                  _ref1 = comp.params;
                  _results = [];
                  for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
                    param = _ref1[_j];
                    _results.push(this.interpretNode(param));
                  }
                  return _results;
                } else {
                  return [];
                }
              }).call(this);
              if (currentObject.derive) {
                currentObject = currentObject.derive.apply(currentObject, [comp.identifier].concat(__slice.call(params)));
              } else {
                this.valueContainer = (_ref1 = this.valueContainer).derive.apply(_ref1, [comp.identifier].concat(__slice.call(params)));
                currentObject = this.valueContainer.get();
              }
              break;
            case 'method':
              this.params = true;
              obj = i === 0 ? this.scope[0] : currentObject;
              params = (function() {
                var _j, _len1, _ref2, _results;
                if (comp.params) {
                  _ref2 = comp.params;
                  _results = [];
                  for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
                    param = _ref2[_j];
                    _results.push(this.interpretNode(param));
                  }
                  return _results;
                } else {
                  return [];
                }
              }).call(this);
              this.params = false;
              if (typeof obj.hasMethod === "function" ? obj.hasMethod(comp.identifier) : void 0) {
                currentObject = obj.call.apply(obj, [comp.identifier].concat(__slice.call(params)));
              } else if (_.isFunction(obj[comp.identifier])) {
                currentObject = obj[comp.identifier].apply(obj, params);
              } else {
                throw new Error();
              }
              if (this.operation !== 'call') {
                this.valueContainer = this._valueCont(obj, comp.identifier, params);
              }
              break;
            case 'metaQuery':
              currentObject = this.valueContainer.meta(comp.identifier);
          }
        }
      }
      return currentObject;
    };

    return Script;

  })();
});

//# sourceMappingURL=Script.js.map
