// Generated by CoffeeScript 1.8.0
var __slice = [].slice;

define(['xyzp/XValue', 'xyzp/ListInterface', 'xyzp/ValueInterface', 'xyzp/PropertyPath', 'xyzp/ComputedValue', 'xyzp/util', 'xyzp/HasManyRelationship', 'xyzp/XArray', 'xyzp/ComputedList', 'xyzp/Model', 'xyzp/Script'], function(XValue, ListInterface, ValueInterface, PropertyPath, ComputedValue, util, HasManyRelationship, XArray, ComputedList, Model, Script) {
  var UILayer, initsForBinding;
  initsForBinding = function(binding, inits) {
    var key, newInits, value;
    newInits = {};
    for (key in inits) {
      value = inits[key];
      if (key === binding) {
        _.extend(newInits, value);
      } else if (key.startsWith("" + binding + ".")) {
        newInits[key.substr(("" + binding + ".").length)] = value;
      }
    }
    return newInits;
  };
  return UILayer = (function() {
    UILayer.prototype.__type = 'UILayer';

    function UILayer(name) {
      this.name = name;
    }

    UILayer.prototype.on = function(eventName, listener) {
      var _base;
      if (this._eventListeners == null) {
        this._eventListeners = {};
      }
      if ((_base = this._eventListeners)[eventName] == null) {
        _base[eventName] = [];
      }
      return this._eventListeners[eventName].push(listener);
    };

    UILayer.prototype.fireEvent = function(name) {
      var listener, listeners, _i, _len, _ref, _results;
      if (listeners = (_ref = this._eventListeners) != null ? _ref[name] : void 0) {
        _results = [];
        for (_i = 0, _len = listeners.length; _i < _len; _i++) {
          listener = listeners[_i];
          _results.push(listener());
        }
        return _results;
      }
    };

    UILayer.prototype.destruct = function(removeFromParent) {
      var frame, func, layer, obj, observable, observer, _i, _j, _k, _l, _len, _len1, _len2, _len3, _ref, _ref1, _ref2, _ref3, _ref4;
      if (removeFromParent == null) {
        removeFromParent = true;
      }
      if (this.parent && removeFromParent) {
        this.parent.removeLayer(this);
      }
      if (this.frames) {
        _ref = this.frames;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          frame = _ref[_i];
          frame.destruct();
        }
      }
      if (this.objects) {
        _ref1 = this.objects;
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          obj = _ref1[_j];
          obj.release();
        }
      }
      if (this.layers) {
        while (this.layers.length) {
          layer = this.layers.shift();
          if (layer) {
            layer.destruct();
          }
        }
      }
      if (this.observers) {
        _ref2 = this.observers;
        for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
          _ref3 = _ref2[_k], observable = _ref3.observable, observer = _ref3.observer;
          observable.stopObserving(observer);
        }
      }
      if (this.destructFuncs) {
        _ref4 = this.destructFuncs;
        for (_l = 0, _len3 = _ref4.length; _l < _len3; _l++) {
          func = _ref4[_l];
          func();
        }
      }
      return this.fireEvent('destruct');
    };

    UILayer.prototype.instantiate = function() {
      var klass, obj, params;
      klass = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      obj = (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })(klass, param, function(){});
      this.addObject(obj);
      return obj;
    };

    UILayer.prototype.addFrame = function(frame) {
      if (this.frames == null) {
        this.frames = [];
      }
      return this.frames.push(frame);
    };

    UILayer.prototype.addObject = function(object) {
      object.retain();
      if (this.objects == null) {
        this.objects = [];
      }
      this.objects.push(object);
      return object;
    };

    UILayer.prototype.removeObject = function(object) {
      if (_.contains(this.object, object)) {
        _.pull(this.objects, object);
        return object.release();
      }
    };

    UILayer.prototype.addLayerProvider = function(name, func) {
      if (this.providers == null) {
        this.providers = {};
      }
      return this.providers[name] = func;
    };

    UILayer.prototype.provider = function(name) {
      var _ref, _ref1, _ref2;
      return (_ref = (_ref1 = this.providers) != null ? _ref1[name] : void 0) != null ? _ref : (_ref2 = this.parent) != null ? typeof _ref2.provider === "function" ? _ref2.provider(name) : void 0 : void 0;
    };

    UILayer.prototype.addValue = function() {};

    UILayer.prototype.value = function(name, create) {
      var ancestorValue, _ref;
      if (create == null) {
        create = true;
      }
      if (this.values == null) {
        this.values = {};
      }
      if (!this.values[name]) {
        ancestorValue = (_ref = this.parent) != null ? typeof _ref.value === "function" ? _ref.value(name, false) : void 0 : void 0;
        if (ancestorValue) {
          return ancestorValue;
        } else if (create) {
          this.values[name] = new XValue().retain();
        }
      }
      return this.values[name];
    };

    UILayer.prototype.list = function(name) {
      if (!this.values[name]) {
        this.values[name] = new XArray().retain();
        this.values[name].layer = this;
      }
      return this.values[name];
    };

    UILayer.prototype._globalProp = function(prop) {
      if (this.globalScope) {
        if (this.globalScope[prop]) {
          return this.globalScope[prop];
        } else if (this.parent) {
          return this.parent._globalProp(prop);
        }
      } else if (this.parent) {
        return this.parent._globalProp(prop);
      }
    };

    UILayer.prototype.addElement = function(el, name) {
      if (this.elements == null) {
        this.elements = {};
      }
      return this.elements[name] = el;
    };

    UILayer.prototype.addElementBinding = function(elementName, valueName) {
      var el, value;
      el = this.elements[elementName];
      value = this.value(valueName);
      el.val(value.get());
      value.observe(function() {
        if (el.val() !== value.get()) {
          return el.val(value.get());
        }
      });
      if (el.attr('type') === 'text') {
        return el.keyup(function() {
          if (value.get() !== el.val()) {
            value.set(el.val());
          }
          return true;
        });
      }
    };

    UILayer.prototype.addLayer = function(layer) {
      if (this.layers == null) {
        this.layers = [];
      }
      this.layers.push(layer);
      layer.parent = this;
      layer.debug = this.debug;
      if (layer.name) {
        if (this.layersByName == null) {
          this.layersByName = {};
        }
        this.layersByName[layer.name] = layer;
      }
      return layer;
    };

    UILayer.prototype.removeLayer = function(layer) {
      _.pull(this.layers, layer);
      if (layer.name) {
        return delete this.layersByName[layer.name];
      }
    };

    UILayer.prototype.layer = function(name) {
      if (this.layersByName[name]) {
        return this.layersByName[name];
      }
    };

    UILayer.prototype.addValueFormatter = function(valueFormatter) {
      if (this.valueFormatters == null) {
        this.valueFormatters = [];
      }
      return this.valueFormatters.push(valueFormatter);
    };

    UILayer.prototype.formatValue = function(value, opts) {
      var formattedValue, valueFormatter, _i, _len, _ref;
      if (opts == null) {
        opts = {};
      }
      if (this.valueFormatters) {
        _ref = this.valueFormatters;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          valueFormatter = _ref[_i];
          formattedValue = valueFormatter(value, opts);
          if (formattedValue != null) {
            return formattedValue;
          }
        }
      }
      if (this.parent) {
        return this.parent.formatValue(value, opts);
      } else {
        return value;
      }
    };

    UILayer.prototype.addTmpl = function(id, html) {
      if (this.tmpls == null) {
        this.tmpls = {};
      }
      return this.tmpls[id] = html;
    };

    UILayer.prototype["new"] = function(params) {
      var layer;
      layer = this.addLayer(new UILayer(params.type));
      this.provider(params.type)(layer, params);
      return layer;
    };

    UILayer.prototype.newLayers = function(layers) {
      var params, _i, _len, _results;
      _results = [];
      for (_i = 0, _len = layers.length; _i < _len; _i++) {
        params = layers[_i];
        _results.push(this["new"](params));
      }
      return _results;
    };

    UILayer.prototype.addHtml = function(el, html) {
      var newEl;
      newEl = $(html);
      el.append(newEl);
      this.addDestructFunc(function() {
        return newEl.remove();
      });
      return newEl;
    };

    UILayer.prototype.addClass = function(el, className) {
      el.addClass(className);
      return this.addDestructFunc(function() {
        return el.removeClass(className);
      });
    };

    UILayer.prototype.setProp = function(el, name, value) {
      var prevValue;
      prevValue = el.prop(name);
      el.prop(name, value);
      return this.addDestructFunc(function() {
        return el.prop(name, prevValue);
      });
    };

    UILayer.prototype.setAttr = function(el, name, value) {
      var prevValue;
      prevValue = el.attr(name);
      el.attr(name, value);
      return this.addDestructFunc(function() {
        return el.attr(name, prevValue);
      });
    };

    UILayer.prototype.setData = function(el, name, value) {
      var prevValue;
      prevValue = el.data(name);
      el.data(name, value);
      return this.addDestructFunc(function() {
        if (prevValue === void 0) {
          return el.removeData(name);
        } else {
          return el.data(name, prevValue);
        }
      });
    };

    UILayer.prototype.setValue = function(valueCont, value) {
      var prevValue;
      prevValue = valueCont.get();
      valueCont.set(value);
      return this.addDestructFunc(function() {
        return valueCont.set(prevValue);
      });
    };

    UILayer.prototype.addCss = function(el, css) {
      var attr, prevValues, value;
      prevValues = {};
      for (attr in css) {
        value = css[attr];
        if (el.get(0).style[attr]) {
          prevValues[attr] = el.get(0).style[attr];
        } else {
          prevValues[attr] = '';
        }
      }
      el.css(css);
      return this.addDestructFunc(function() {
        return el.css(prevValues);
      });
    };

    UILayer.prototype["switch"] = function(value, cases) {
      var lastCase, layer, update;
      if (_.isString(value)) {
        value = this.value(value);
      }
      lastCase = -1;
      layer = null;
      update = (function(_this) {
        return function() {
          var i, test, _i, _ref;
          for (i = _i = 0, _ref = cases.length / 2; 0 <= _ref ? _i < _ref : _i > _ref; i = 0 <= _ref ? ++_i : --_i) {
            test = cases[i * 2];
            if ((_.isFunction(test) ? test(value.get()) : value.get() === test)) {
              if (i !== lastCase) {
                lastCase = i;
                if (layer) {
                  layer.destruct();
                }
                layer = _this.addLayer(new UILayer);
                layer.undoOnDestruct = true;
                cases[i * 2 + 1](layer);
              }
              return;
            }
          }
          lastCase = -1;
          if (layer) {
            layer.destruct();
            return layer = null;
          }
        };
      })(this);
      update();
      return this.observe(value, update);
    };

    UILayer.prototype.addLayerValueBinding = function(value, insert, cases) {
      var func, lastCase, layer;
      value = this.value(value);
      lastCase = -1;
      layer = null;
      func = (function(_this) {
        return function() {
          var caseFunc, i, layerName, _i, _len, _results;
          _results = [];
          for (i = _i = 0, _len = cases.length; _i < _len; i = ++_i) {
            caseFunc = cases[i];
            layerName = caseFunc(value.get());
            if (layerName) {
              if (lastCase !== i) {
                if (layer) {
                  layer.remove();
                }
                lastCase = i;
                layer = _this["new"]({
                  type: layerName
                });
                layer.name = layerName;
                _this.addLayer(layer);
                layer.insert(insert);
              }
              break;
            } else {
              if (lastCase === i) {
                layer.remove();
                layer = null;
                _results.push(lastCase = -1);
              } else {
                _results.push(void 0);
              }
            }
          }
          return _results;
        };
      })(this);
      this.observe(value, func);
      return func();
    };

    UILayer.prototype.bindList = function(dataSource, el, selector, iter) {
      var listInterface;
      el.data('boundList', dataSource);
      listInterface = this.addObject(new ListInterface(el, selector, (function(_this) {
        return function(el, data, _arg) {
          var layer, onDelete, pos;
          onDelete = _arg.onDelete, pos = _arg.pos;
          layer = _this.addLayer(new UILayer);
          onDelete(function() {
            return layer.destruct();
          });
          return iter(el, data, {
            layer: layer,
            index: pos
          });
        };
      })(this)));
      return listInterface.setDataSource(dataSource);
    };

    UILayer.prototype.bindValue = function(el, dataSource, binding, opts) {
      var valueInterface;
      if (binding == null) {
        binding = 'html';
      }
      if (opts == null) {
        opts = {};
      }
      if (!opts.mapping) {
        opts.mapping = (function(_this) {
          return function(value) {
            return _this.formatValue(value, {
              type: util.type(dataSource)
            });
          };
        })(this);
      }
      if (el.is('select')) {
        binding = 'value';
        valueInterface = this.addObject(new ValueInterface(el, binding, opts));
        valueInterface.setDataSource(dataSource);
        return this.bindEvent(el, 'change', function() {
          if (el.find(':selected').data('boundValue') != null) {
            return dataSource.set(el.find(':selected').data('boundValue'), 'editing');
          } else {
            return dataSource.set(el.val(), 'editing');
          }
        });
      } else if (el.is('input') && binding === 'html') {
        if (el.attr('type') === 'text') {
          binding = 'value';
          opts.mapping = (function(_this) {
            return function(value) {
              return _this.formatValue(value, {
                context: 'editing',
                type: util.type(dataSource)
              });
            };
          })(this);
          valueInterface = this.addObject(new ValueInterface(el, binding, opts));
          valueInterface.setDataSource(dataSource);
          this.bindEvent(el, 'keyup', function() {
            if (dataSource.get() !== el.val()) {
              dataSource.set(el.val());
            }
            return true;
          });
          return this.bindEvent(el, 'change', function() {
            if (dataSource.get() !== el.val()) {
              return dataSource.set(el.val());
            }
          });
        } else if (el.attr('type') === 'checkbox') {
          binding = 'checked';
          delete opts.mapping;
          valueInterface = this.addObject(new ValueInterface(el, binding, opts));
          valueInterface.setDataSource(dataSource);
          return this.bindEvent(el, 'change', function() {
            if (dataSource.get() !== el.prop('checked')) {
              return dataSource.set(el.prop('checked'));
            }
          });
        }
      } else {
        valueInterface = this.addObject(new ValueInterface(el, binding, opts));
        return valueInterface.setDataSource(dataSource);
      }
    };

    UILayer.prototype.addTemplate = function(name, templateEl) {
      if (this.templates == null) {
        this.templates = {};
      }
      return this.templates[name] = templateEl;
    };

    UILayer.prototype.addController = function(name, constructor) {
      if (this.controllers == null) {
        this.controllers = {};
      }
      return this.controllers[name] = constructor;
    };

    UILayer.prototype.createController = function(name, params) {
      var constructor, _ref;
      if (params == null) {
        params = [];
      }
      if (constructor = (_ref = this.controllers) != null ? _ref[name] : void 0) {
        return (function(func, args, ctor) {
          ctor.prototype = func.prototype;
          var child = new ctor, result = func.apply(child, args);
          return Object(result) === result ? result : child;
        })(constructor, params, function(){});
      } else if (this.parent) {
        return this.parent.createController(name, params);
      }
    };

    UILayer.prototype.template = function(name) {
      var template, _ref;
      if (template = (_ref = this.templates) != null ? _ref[name] : void 0) {
        return template;
      } else if (this.parent) {
        return this.parent.template(name);
      }
    };

    UILayer._scriptValue = function(obj, prop) {
      var retObj;
      if (obj.__type === 'UILayer') {
        if (util.isList(obj.value(prop))) {
          return obj.value(prop);
        } else {
          return obj.value(prop).get();
        }
      } else if ((obj instanceof HasManyRelationship) || (obj instanceof Model)) {
        if (prop.match(/^\d*|length$/)) {
          return obj.get(prop);
        } else {
          return obj.scope(prop);
        }
      } else if (_.isFunction(obj.get)) {
        return obj.get(prop);
      } else if (_.isFunction(obj.attr)) {
        return obj.attr(prop);
      } else if (_.isFunction(obj.get)) {
        return obj.get(prop);
      } else {
        retObj = obj[prop];
        if (retObj) {
          if (util.isValueContainer(retObj)) {
            return retObj.get();
          } else {
            return retObj;
          }
        }
      }
    };

    UILayer._scriptValueCont = function(obj, prop, params) {
      var retObj;
      if (params == null) {
        params = [];
      }
      if (obj.__type === 'UILayer') {
        return obj.value(prop);
      } else if (obj instanceof HasManyRelationship || obj instanceof Model) {
        if (prop.match(/^\d*$/)) {
          return new XValue(obj.get(prop));
        } else {
          return obj.scope(prop);
        }
      } else if (_.isFunction(obj.prop)) {
        return obj.prop(prop);
      } else if (_.isFunction(obj.attrCont)) {
        return obj.attrCont(prop);
      } else if (_.isFunction(obj.prop)) {
        return obj.prop.apply(obj, [prop].concat(__slice.call(params)));
      } else if (util.isList(obj)) {
        return new XValue(obj.get(prop));
      } else {
        retObj = obj[prop];
        if (retObj) {
          if (util.isValueContainer(retObj)) {
            return retObj;
          } else {
            return new XValue(retObj);
          }
        }
      }
    };

    UILayer.prototype.debugBind = function(el, scope, inits, controller, bindings) {
      return this.bind(el, scope, inits, controller, bindings, true);
    };

    UILayer.prototype.bind = function(el, scope, inits, controller, bindings) {
      var addedLayer, attr, attrBinding, bindInit, binding, bound, childEl, classBinding, className, clickBinding, condValue, contEl, controllerName, data, ifCond, insertionPoint, layer, layerBinding, layerData, listBinding, matches, param, paramPart, paramParts, params, script, scriptArgs, templEl, template, update, valueBinding, __, _fn, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _ref2, _ref3, _results;
      if (scope == null) {
        scope = {};
      }
      if (inits == null) {
        inits = {};
      }
      if (controller == null) {
        controller = null;
      }
      if (bindings == null) {
        bindings = {};
      }
      if (el.is('tmpl')) {
        this.addTmpl(el.attr('id'), el.html());
        el.remove();
        return;
      }
      if (el.attr('tmpl') != null) {
        el.removeAttr('tmpl');
        this.addTmpl(el.attr('id'), el[0].outerHTML);
        el.remove();
        return;
      }
      if (el.data('bindVisited')) {
        return;
      }
      this.setData(el, 'bindVisited', true);
      if (el.is('template')) {
        if (el.html()) {
          this.addTemplate(el.attr('name'), el);
        } else {
          templEl = this.template(el.attr('name'));
          contEl = $('<div />').append(templEl.html());
          _ref = templEl.get(0).attributes;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            attr = _ref[_i];
            if (attr.nodeName === 'name') {
              continue;
            }
            contEl.attr(attr.nodeName, attr.value);
          }
          this.bind(contEl, scope, inits, controller, bindings);
          el.before(contEl);
        }
        el.remove();
        return;
      }
      if (!_.isArray(scope)) {
        scope = [scope];
      }
      if (!el.data('skipIf') && (ifCond = el.attr('if'))) {
        if (this.debug) {
          console.log(el);
        }
        data = scope[0];
        layer = this;
        condValue = new ComputedValue((function(_this) {
          return function() {
            return !!eval("" + ifCond);
          };
        })(this));
        insertionPoint = document.createComment("if " + ifCond);
        el.before(insertionPoint);
        template = el.clone();
        addedLayer = null;
        el.remove();
        $(insertionPoint).after(document.createComment('endif'));
        update = (function(_this) {
          return function() {
            if (condValue.get()) {
              if (!addedLayer) {
                addedLayer = _this.addLayer(new UILayer);
                addedLayer.values = _this.values;
                el = template.clone();
                el.data('skipIf', true);
                $(insertionPoint).after(el);
                return addedLayer.bind(el, scope, inits, controller, bindings);
              }
            } else if (addedLayer) {
              el.remove();
              addedLayer.destruct();
              return addedLayer = null;
            }
          };
        })(this);
        this.observe(condValue, update);
        return update();
      } else {
        if (controllerName = el.attr('bind-controller')) {
          controller = this.createController(controllerName, [
            scope, {
              layer: this,
              el: el
            }
          ]);
        }
        scriptArgs = {
          bases: {
            '$': inits,
            ':': controller,
            '%': this,
            '@': scope[0],
            '&': _.extend({
              el: el
            }, bindings),
            '//': {
              get: (function(_this) {
                return function(prop) {
                  var v;
                  v = _this._globalProp(prop);
                  if (util.isValueContainer(v)) {
                    return v.get();
                  } else {
                    return v;
                  }
                };
              })(this),
              prop: (function(_this) {
                return function(prop) {
                  var v;
                  v = _this._globalProp(prop);
                  if (util.isValueContainer(v)) {
                    return v;
                  } else {
                    return new XValue(v).retain();
                  }
                };
              })(this),
              hasMethod: (function(_this) {
                return function(prop) {
                  return _.isFunction(_this._globalProp(prop));
                };
              })(this),
              call: (function(_this) {
                return function() {
                  var args, m, prop;
                  prop = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
                  m = _this._globalProp(prop);
                  return m.apply(null, args);
                };
              })(this)
            }
          },
          scope: scope,
          value: UILayer._scriptValue,
          valueCont: UILayer._scriptValueCont,
          defaultParams: [
            el, scope, {
              layer: this
            }
          ]
        };
        if (typeof dataManager !== "undefined" && dataManager !== null) {
          scriptArgs.bases['#'] = dataManager._models;
        }
        if (bindInit = el.attr('bind-init')) {
          script = new Script(bindInit, _.extend({
            operation: 'call'
          }, scriptArgs));
          script.execute();
        }
        bound = false;
        if (listBinding = el.attr('bind-list')) {
          script = new Script(listBinding, scriptArgs, el.attr('bind-list-debug') != null);
          (function(_this) {
            return (function(script) {
              var bindEl, binding, childEl, list, nextInits, _j, _len1, _ref1, _results;
              list = _this.addObject(new ComputedList(function() {
                return script.execute();
              }));
              nextInits = initsForBinding(listBinding, inits);
              bindEl = el.find('[bind]:first');
              binding = bindEl.attr('bind');
              bindEl.removeAttr('bind');
              _this.bindList(list, el, bindEl, function(el, data, _arg) {
                var index, layer, nextBindings, nextScope;
                layer = _arg.layer, index = _arg.index;
                layer.value('_index').set(index);
                nextScope = [data].concat(scope);
                if (typeof nextInits.init === "function") {
                  nextInits.init(el, nextScope, {
                    layer: layer,
                    index: index
                  });
                }
                nextBindings = bindings;
                if (binding) {
                  nextBindings = _.clone(bindings);
                  nextBindings[binding] = data;
                }
                layer.bind(el, nextScope, nextInits, controller, nextBindings);
                return el;
              });
              _ref1 = el.children();
              _results = [];
              for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
                childEl = _ref1[_j];
                _results.push(_this.bind($(childEl), list, inits, controller, bindings));
              }
              return _results;
            });
          })(this)(script);
          bound = true;
        }
        if (valueBinding = el.attr('bind-value')) {
          script = new Script(valueBinding, scriptArgs);
          (function(_this) {
            return (function(script) {
              var value;
              value = _this.addObject(new ComputedValue(function(cont) {
                var v;
                v = script.execute();
                cont(script.valueContainer);
                return v;
              }));
              return _this.bindValue(el, value);
            });
          })(this)(script);
          bound = true;
        }
        if (attrBinding = el.attr('bind-attr')) {
          _ref1 = attrBinding.match(/^([^ ]*) +(.*)$/), __ = _ref1[0], attr = _ref1[1], binding = _ref1[2];
          script = new Script(binding, scriptArgs);
          (function(_this) {
            return (function(script) {
              var value;
              value = _this.addObject(new ComputedValue(function(cont) {
                value = script.execute();
                cont(script.valueContainer);
                return value;
              }));
              return _this.bindValue(el, value, 'attr', {
                attr: attr
              });
            });
          })(this)(script);
        }
        if (classBinding = el.attr('bind-class')) {
          script = new Script(classBinding, scriptArgs);
          (function(_this) {
            return (function(script) {
              var value;
              value = _this.addObject(new ComputedValue(function(cont) {
                value = script.execute();
                cont(script.valueContainer);
                return value;
              }));
              return _this.withValue(value, function(value, _arg) {
                var prevValue;
                prevValue = _arg.prevValue;
                el.removeClass(prevValue);
                return el.addClass(value);
              });
            });
          })(this)(script);
        }
        if (classBinding = el.attr('bind-class-cond')) {
          _ref2 = classBinding.match(/^([^ ]*) +(.*)$/), __ = _ref2[0], className = _ref2[1], binding = _ref2[2];
          script = new Script(binding, scriptArgs);
          (function(_this) {
            return (function(script) {
              var value;
              value = _this.addObject(new ComputedValue(function(cont) {
                value = script.execute();
                cont(script.valueContainer);
                return value;
              }));
              return _this.withValue(value, function(value, _arg) {
                var prevValue;
                prevValue = _arg.prevValue;
                if (value) {
                  return el.addClass(className);
                } else {
                  return el.removeClass(className);
                }
              });
            });
          })(this)(script);
        }
        if (layerBinding = el.attr('bind-layer')) {
          matches = layerBinding.match(/^(.*?)\((.*?)\)$/);
          paramParts = matches[2].split(/\s*,\s*/);
          params = {};
          _fn = (function(_this) {
            return function(script, param) {
              return params[param[0]] = _this.addObject(new ComputedValue(function(cont) {
                var value;
                value = script.execute();
                cont(script.valueContainer);
                return value;
              }));
            };
          })(this);
          for (_j = 0, _len1 = paramParts.length; _j < _len1; _j++) {
            paramPart = paramParts[_j];
            param = paramPart.split(':');
            script = new Script(param[1], scriptArgs);
            _fn(script, param);
          }
          layerData = {
            type: matches[1],
            el: el
          };
          _.extend(layerData, params);
          this["new"](layerData);
          bound = true;
        }
        if (clickBinding = el.attr('bind-click')) {
          scriptArgs = _.extend({
            operation: 'call'
          }, scriptArgs);
          script = new Script(clickBinding, scriptArgs);
          (function(_this) {
            return (function(script) {
              return _this.bindEvent(el, 'click', function() {
                script.execute();
                return false;
              });
            });
          })(this)(script);
          bound = true;
        }
        el.data('layer', this);
        el.data('bindVisited', true);
        _ref3 = el.children();
        _results = [];
        for (_k = 0, _len2 = _ref3.length; _k < _len2; _k++) {
          childEl = _ref3[_k];
          _results.push(this.bind($(childEl), scope, inits, controller, bindings));
        }
        return _results;
      }
    };

    UILayer.prototype.withValue = function(value, func, opts) {
      if (opts == null) {
        opts = {};
      }
      if (opts.format == null) {
        opts.format = true;
      }
      if (opts.format) {
        func(this.formatValue(value.get()), {});
        return this.observe(value, (function(_this) {
          return function(m) {
            return func(_this.formatValue(value.get(), {
              type: util.type(value)
            }), {
              prevValue: m.prevValue,
              type: util.type(value)
            });
          };
        })(this));
      } else {
        func(value.get(), {});
        return this.observe(value, (function(_this) {
          return function(m) {
            return func(value.get(), {
              prevValue: m.prevValue,
              type: util.type(value)
            });
          };
        })(this));
      }
    };

    UILayer.prototype.observe = function(observable, observer) {
      if (this.observers == null) {
        this.observers = [];
      }
      observable.observe(observer);
      return this.observers.push({
        observable: observable,
        observer: observer
      });
    };

    UILayer.prototype.addDestructFunc = function(func) {
      if (this.destructFuncs == null) {
        this.destructFuncs = [];
      }
      return this.destructFuncs.push(func);
    };

    UILayer.prototype.bindEvent = function(el, event, handler) {
      $(el).bind(event, handler);
      return this.addDestructFunc(function() {
        return $(el).unbind(event, handler);
      });
    };

    UILayer.prototype.ifCondSeq = function(inserter, seq) {};

    UILayer.prototype["if"] = function(condFunc, layerInit) {
      var layer, update, value;
      value = new ComputedValue(condFunc);
      layer = null;
      update = (function(_this) {
        return function() {
          if (value.get()) {
            if (!layer) {
              layer = _this.addLayer(new UILayer);
              return layerInit(layer);
            }
          } else if (layer) {
            layer.destruct();
            return layer = null;
          }
        };
      })(this);
      this.observe(value, update);
      return update();
    };

    return UILayer;

  })();
});

//# sourceMappingURL=UILayer.js.map
