// Generated by CoffeeScript 1.8.0
var __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

define(['xyzp/util', 'xyzp/XObject'], function(util, XObject) {
  var ValueInterface;
  return ValueInterface = (function(_super) {
    __extends(ValueInterface, _super);

    function ValueInterface(el, func, opts) {
      this.el = el;
      this.func = func;
      this.opts = opts != null ? opts : {};
      ValueInterface.__super__.constructor.apply(this, arguments);
      if (_.isString(this.func)) {
        switch (this.func) {
          case 'html':
            this.func = function(el, value) {
              return el.html(value);
            };
            break;
          case 'value':
            this.func = function(el, value) {
              return el.val(value);
            };
            break;
          case 'checked':
            this.func = function(el, value) {
              return el.prop('checked', value);
            };
            break;
          case 'attr':
            this.func = (function(_this) {
              return function(el, value) {
                return el.attr(_this.opts.attr, value);
              };
            })(this);
        }
      }
    }

    ValueInterface.prototype.set = function(value, mapping) {
      if (mapping == null) {
        mapping = true;
      }
      if (this.form) {
        this.stopObserving(this.form);
        delete this.form;
      }
      this.el.data('boundValue', value);
      if (value && value.form) {
        this.form = value.form('display');
        this.observeObject(this.form, (function(_this) {
          return function() {
            return _this.func(_this.el, _this.opts.mapping(_this.form.get()));
          };
        })(this));
        return this.func(this.el, this.opts.mapping(this.form.get()));
      } else {
        if (this.opts.mapping && mapping) {
          value = this.opts.mapping(value);
        }
        return this.func(this.el, value);
      }
    };

    ValueInterface.prototype.destruct = function() {
      ValueInterface.__super__.destruct.apply(this, arguments);
      this.set(null, false);
      this.el.removeData('boundValue');
      if (util.isValueContainer(this.dataSource)) {
        return this.dataSource.stopObserving(this.observer);
      }
    };

    ValueInterface.prototype.setDataSource = function(dataSource) {
      this.dataSource = dataSource;
      if (util.isScalar(dataSource)) {
        return this.set(dataSource);
      } else {
        if (util.isValueContainer(this.dataSource)) {
          this.set(this.dataSource.get());
          this.observer = (function(_this) {
            return function() {
              return _this.set(_this.dataSource.get());
            };
          })(this);
          return this.dataSource.observe(this.observer);
        } else {
          return this.set(this.dataSource);
        }
      }
    };

    return ValueInterface;

  })(XObject);
});

//# sourceMappingURL=ValueInterface.js.map
