// Generated by CoffeeScript 1.8.0
var __slice = [].slice;

define(function() {
  var WebSocketTransport;
  return WebSocketTransport = (function() {
    function WebSocketTransport(server) {
      this.server = server;
      this.messageCbs = {};
      this.messageNumber = 0;
      this.queue = [];
      this.version = 1;
    }

    WebSocketTransport.prototype.init = function(version, clientId, dbName, schemaVersion, cb) {
      this.ws = new WebSocket(this.server);
      this.ws.onclose = (function(_this) {
        return function() {
          if (typeof _this.onClose === "function") {
            _this.onClose();
          }
          if (!_this.opened) {
            return cb(false);
          }
        };
      })(this);
      this.ws.onopen = (function(_this) {
        return function() {
          _this.ws.send(_this.version);
          return _this.sendMessage(['1', version, clientId, dbName, schemaVersion], function() {
            if (typeof _this.onOpen === "function") {
              _this.onOpen();
            }
            _this.opened = true;
            cb(true);
            return _this._sendNextMessage();
          });
        };
      })(this);
      return this.ws.onmessage = (function(_this) {
        return function(message) {
          var code, mapping, number, params, responseCode, _ref, _ref1;
          message = message.data;
          _ref = message.split('\t'), code = _ref[0], params = 2 <= _ref.length ? __slice.call(_ref, 1) : [];
          console.log('receive', code, params);
          switch (code) {
            case 'r':
              number = params[0];
              responseCode = params[1];
              if (responseCode === '0') {
                (_ref1 = _this.messageCbs)[number].apply(_ref1, [null].concat(__slice.call(params.slice(2))));
              } else {
                mapping = {
                  '1': 'invalidClientId'
                };
                _this.messageCbs[number](mapping[responseCode]);
              }
              delete _this.messageCbs[number];
              _this._sending = false;
              if (typeof _this.onSendFinished === "function") {
                _this.onSendFinished();
              }
              return _this._sendNextMessage();
            case 'u':
              return _this.onUpdate(JSON.parse(params[0]));
          }
        };
      })(this);
    };

    WebSocketTransport.prototype._ready = function() {
      var _ref;
      return !this._sending && ((_ref = this.ws) != null ? _ref.readyState : void 0) === WebSocket.OPEN;
    };

    WebSocketTransport.prototype._sendNextMessage = function() {
      var num, params, _ref;
      if (this.queue.length) {
        _ref = this.queue.shift(), num = _ref.num, params = _ref.params;
        return this._sendMessage(num, params);
      }
    };

    WebSocketTransport.prototype._sendMessage = function(num, params) {
      this._sending = true;
      console.log('send', num, params);
      this.ws.send("" + num + "\t" + (params.join('\t')));
      return typeof this.onSendStart === "function" ? this.onSendStart() : void 0;
    };

    WebSocketTransport.prototype.sendMessage = function(params, cb) {
      var num;
      num = this.messageNumber++;
      this.messageCbs[num] = cb != null ? cb : function() {};
      if (this._ready()) {
        return this._sendMessage(num, params);
      } else {
        return this.queue.push({
          num: num,
          params: params
        });
      }
    };

    return WebSocketTransport;

  })();
});

//# sourceMappingURL=WebSocketTransport.js.map
