// Generated by CoffeeScript 1.8.0
define(function() {
  var XObject;
  return XObject = (function() {
    XObject.isObject = function(value) {
      return value && value.retain && value.release;
    };

    function XObject(autoRelease) {
      if (autoRelease == null) {
        autoRelease = true;
      }
      this._retainCount = 1;
      if (autoRelease) {
        this.autoRelease();
      }
    }

    XObject.prototype.on = function(eventName, listener) {
      var _base;
      if (this._eventListeners == null) {
        this._eventListeners = {};
      }
      if ((_base = this._eventListeners)[eventName] == null) {
        _base[eventName] = [];
      }
      return this._eventListeners[eventName].push(listener);
    };

    XObject.prototype.fireEvent = function(name) {
      var listener, listeners, _i, _len, _ref, _results;
      if (listeners = (_ref = this._eventListeners) != null ? _ref[name] : void 0) {
        _results = [];
        for (_i = 0, _len = listeners.length; _i < _len; _i++) {
          listener = listeners[_i];
          _results.push(listener());
        }
        return _results;
      }
    };

    XObject.prototype.observeObject = function(observable, observer) {
      var observerName;
      if (_.isString(observer)) {
        observerName = observer;
        observer = (function(_this) {
          return function(mutation) {
            return _this[observerName](mutation);
          };
        })(this);
      }
      observable.observe(observer);
      if (this.observers == null) {
        this.observers = [];
      }
      this.observers.push({
        observable: observable,
        observer: observer
      });
      if (this.debug && window.debug) {
        return console.log(observable);
      }
    };

    XObject.prototype.allStopObserving = function() {
      var observable, observer, _i, _len, _ref, _ref1;
      if (this.debug) {
        console.log('asdf', this);
      }
      if (this.observers) {
        _ref = this.observers;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          _ref1 = _ref[_i], observable = _ref1.observable, observer = _ref1.observer;
          observable.stopObserving(observer);
        }
        return delete this.observers;
      }
    };

    XObject.prototype.stopObserving = function(observable, observer) {
      var i, o, toRemove, _i, _j, _len, _ref, _ref1, _results;
      if (observer == null) {
        observer = null;
      }
      if (this.observers) {
        toRemove = [];
        _ref = this.observers;
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          o = _ref[i];
          if (o.observable === observable && (observer === null || o.observer === observer)) {
            o.observable.stopObserving(o.observer);
            toRemove.push(i);
            if (observer) {
              break;
            }
          }
        }
        _results = [];
        for (i = _j = _ref1 = toRemove.length; _ref1 <= 0 ? _j < 0 : _j > 0; i = _ref1 <= 0 ? ++_j : --_j) {
          _results.push(this.observers.splice(toRemove[i], 1));
        }
        return _results;
      }
    };

    XObject.prototype.destruct = function() {
      var object, _i, _len, _ref;
      this.destructed = true;
      this.allStopObserving();
      if (this.objects) {
        _ref = this.objects;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          object = _ref[_i];
          object.release();
        }
      }
      return this.fireEvent('destruct');
    };

    XObject.prototype.addObject = function(object) {
      if (XObject.isObject(object)) {
        if (this.objects == null) {
          this.objects = [];
        }
        this.objects.push(object);
        object.retain();
        return object;
      }
    };

    XObject.prototype.removeObject = function(object) {
      var index;
      if (XObject.isObject(object) && this.objects) {
        index = this.objects.indexOf(object);
        if (index !== -1) {
          this.objects.splice(index, 1);
          return object.release();
        }
      }
    };

    XObject.prototype.autoRelease = function() {
      setTimeout(((function(_this) {
        return function() {
          return _this.release();
        };
      })(this)), 1000);
      return this;
    };

    XObject.prototype.retain = function() {
      if (this.destructTimer) {
        clearTimeout(this.destructTimer);
        delete this.destructTimer;
      }
      if (this._retained == null) {
        this._retained = [];
      }
      this.fireEvent('retain');
      if (this._retainCount == null) {
        this._retainCount = 1;
      }
      this._retainCount++;
      return this;
    };

    XObject.prototype.release = function() {
      if (!this._retainCount || !--this._retainCount) {
        if (0) {
          clearTimeout(this.destructTimer);
          this.destructTimer = setTimeout(((function(_this) {
            return function() {
              _this.destruct();
              return delete _this.destructTimer;
            };
          })(this)), 0);
        } else {
          this.destruct();
        }
      }
      return this;
    };

    return XObject;

  })();
});

//# sourceMappingURL=XObject.js.map
