// Generated by CoffeeScript 1.8.0
var __slice = [].slice;

define(function() {
  var util;
  return util = {
    observableProxy: function(klass, observableMemberName) {
      return _.extend(klass.prototype, {
        observe: function(observer) {
          return this[observableMemberName].observe(observer);
        },
        stopObserving: function(observer) {
          return this[observableMemberName].stopObserving(observer);
        }
      });
    },
    arrayProxy: function(klass, memberName) {
      var _base, _base1;
      _.extend(klass.prototype, {
        __list: true,
        forEach: function(iter) {
          return this[memberName].forEach(iter);
        },
        each: function(iter) {
          return xyz.ValueCapture.capture(this, (function(_this) {
            return function() {
              return _this[memberName].each(iter);
            };
          })(this));
        },
        length: function() {
          return xyz.ValueCapture.capture(this, (function(_this) {
            return function() {
              return _this[memberName].length();
            };
          })(this));
        },
        contains: function(value) {
          return this[memberName].contains(value);
        },
        value: function() {
          return this;
        }
      });
      if ((_base = klass.prototype).get == null) {
        _base.get = function(i) {
          return this[memberName].get(i);
        };
      }
      return (_base1 = klass.prototype).derive != null ? _base1.derive : _base1.derive = function() {
        var params, value, _ref;
        value = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
        return (_ref = this[memberName]).derive.apply(_ref, [value].concat(__slice.call(params)));
      };
    },
    objectList: function(array) {
      array.oldDerive = array.derive;
      array.derive = function() {
        var name, params, _ref;
        name = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
        if (util.objectList.derivations[name]) {
          return (_ref = util.objectList.derivations)[name].apply(_ref, [array].concat(__slice.call(params)));
        } else {
          return this.oldDerive.apply(this, [name].concat(__slice.call(params)));
        }
      };
      return array;
    },
    isScalar: function(obj) {
      return _.isNumber(obj) || _.isString(obj);
    },
    isValueContainer: function(obj) {
      return obj.__valueContainer;
    },
    isList: function(obj) {
      return obj.__list;
    },
    compare: function(a, b, order) {
      if (order == null) {
        order = 'asc';
      }
      if (a instanceof Date) {
        if (a) {
          a = a.getTime();
        }
        if (b) {
          b = b.getTime();
        }
      }
      if (a < b) {
        if (order === 'asc') {
          return -1;
        } else if (order === 'desc') {
          return 1;
        }
      } else if (a > b) {
        if (order === 'asc') {
          return 1;
        } else if (order === 'desc') {
          return -1;
        }
      } else {
        return 0;
      }
    },
    type: function(value) {
      if (util.isValueContainer(value)) {
        return value.meta('type');
      } else if (_.isString(value)) {
        return 'string';
      } else if (_.isNumber(value)) {
        if (value % 1 === 0) {
          return 'int';
        } else {
          return 'float';
        }
      }
    }
  };
});

//# sourceMappingURL=util.js.map
