define ['xyzp/UILayer'], (UILayer) ->
	class Breakpoints
		constructor: ->
			@list = []
			@breakpointsByName = {}
			@breakpoints = {}


		addBreakpoints: (name, breakpoints) ->
			@list.push breakpoints
			@breakpointsByName[name] = breakpoints
			@resolveBreakpoints()

		removeBreakpoints: (name) ->
			_.pull @list, @breakpointsByName[name]
			delete @breakpointsByName[name]
			@resolveBreakpoints()

		resolveBreakpoints: ->
			resolvedBreakpoints = {}
			for breakpoints in @list
				for width, breakpoint of breakpoints
					resolvedBreakpoints[width] ?= []
					resolvedBreakpoints[width].push breakpoint

			@breakpoints = resolvedBreakpoints
			# delete @currentBreakpoint

		update: (force=false) ->
			$('body').addClass 'breakpointed'
			widths = _.map(_.without(_.keys(@breakpoints), 'else'), (v)->parseInt v).sort (a, b) -> a - b
			breakpoint = 'else'
			for width in widths
				if $(window).width() < width
					breakpoint = width
					break

			if @currentBreakpoint != breakpoint || force
				$('body').removeClass "breakpoint-#{@currentBreakpoint}"
				$('body').addClass "breakpoint-#{breakpoint}"

				if @breakpointLayer
					@breakpointLayer.destruct()

				@breakpointLayer = new UILayer

				prevBreakpoint = @currentBreakpoint
				@currentBreakpoint = breakpoint
				# console.log breakpoint
				bp.init? @breakpointLayer for bp in @breakpoints[breakpoint] if @breakpoints[breakpoint]

				if @currentBreakpoint != prevBreakpoint && prevBreakpoint
					@onBreakpointChanged? @currentBreakpoint, prevBreakpoint


			bp.resize? $(window).width() for bp in @breakpoints[breakpoint] if @breakpoints[breakpoint]
