define ['app/UIHelpers', 'xyzp/ObjectListAggregate', 'xyzp/FormattedValue', 'xyzp/UILayer'], (UIHelpers, ObjectListAggregate, FormattedValue, UILayer) ->
	window.DivvyDose = DivvyDose =
		getPacketsByTimeOnDay: (day) ->
			packetsByTime = {}
			if g_userCont.get()
				date = moment(day).format 'YYYY-MM-DD'
				if divvyPacks = g_userCont.get().get('divvyPacks')
					for beginDate, divvyPack of divvyPacks
						for packet in divvyPack.packets
							if packet.time.substr(0, 10) == date
								time = packet.time.substr(11, 5)
								packetsByTime[time] = _.map packet.doses, (dose) ->
									if divvyPack.prescriptions[dose.rxNumber]
										divvyPack.prescriptions[dose.rxNumber]
									else
										console.log divvyPack.prescriptions
										console.log "#{dose.rxNumber} not found"
										name:'ERROR', presciber:'ERROR', sig:'ERROR'

			packetsByTime

		getPacketsByTime: ->
			DivvyDose.getPacketsByTimeOnDay moment()

		timesForDay: (day, beforeNow=false) ->
			times = []

			now = dataManager.now()
			if g_userCont.get()
				if divvyPacks = g_userCont.get().get('divvyPacks')
					for beginDate, divvyPack of divvyPacks
						day = moment(day).format('YYYY-MM-DD')
						for packet in divvyPack.packets
							if beforeNow && packet.time > now.toLocalMysqlFormat()
								continue

							if packet.time.substr(0, 10) == day
								times.push packet.time
			times

		nextTimes: (num) ->
			# return [Date.create('in 30 seconds'), Date.create('in 1 minute')]
			times = []
			if g_userCont.get()
				now = new Date().toLocalMysqlFormat()
				
				if divvyPacks = g_userCont.get().get('divvyPacks')
					for beginDate, divvyPack of divvyPacks
						t = {}
						for packet in divvyPack.packets
							t[packet.time] = true

						t = _.keys(t)
						t.sort()

						for time in t
							if time >= now
								if !(time in times)
									times.push Date.create time
									if times.length == num
										break
			times


		completedForDay: (day) ->
			if g_userCont.get().get('demo')
				switch moment().diff(moment(day), 'days')
					when 0 then 1
					when 1 then 1
					when 2 then 1
					when 3 then 3/4
					when 4 then 1
					when 5 then 1
					when 6 then 3/4
			else
				timesSoFar = DivvyDose.timesForDay day, true

				if timesSoFar.length
					totalTimes = DivvyDose.timesForDay day, false

					timesSoFar.length/totalTimes.length

					completed = 0
					for time in timesSoFar
						if g_userCont.get().get('medicineLogEntries').exists(time:time,event:'taken')
							completed++

					completed/timesSoFar.length

					(1 - timesSoFar.length/totalTimes.length) + timesSoFar.length/totalTimes.length * completed/timesSoFar.length
				else
					1


		timesTillNow: ->
			now = new Date()
			nowFormatted = now.toLocalMysqlFormat()
			if g_userCont.get()
				if divvyPacks = g_userCont.get().get('divvyPacks')
					times = {}
					startDates = _.keys divvyPacks
					startDates.sort()
					for startDate in startDates
						if Date.create(startDate).getTime() <= now.getTime()
							divvyPack = divvyPacks[startDate]
							for packet in divvyPack.packets
								if packet.time < nowFormatted
									times[packet.time] = true

					return _.keys(times).sort().reverse()
			return []

		backlog: ->
			times = DivvyDose.timesTillNow()
			g_userCont.get().get('medicineLogEntries').each (logEntry) ->
				_.pull times, logEntry.get('time')
			times#.reverse()

		packetForTime: (time) ->
			if divvyPacks = g_userCont.get().get('divvyPacks')
				for startDate, divvyPack of divvyPacks
					for packet in divvyPack.packets
						if packet.time == time
							return packet


		log: (time, event) ->
			console.log time, event
			if !dataManager.model('MedicineLogEntry').findOne(user:g_userCont.get(), time:time)
				packet = DivvyDose.packetForTime time
				if packet
					medicineLogEntry = dataManager.model('MedicineLogEntry').create user:g_userCont.get(), time:time, timestamp:new Date(), event:event
					for dose in packet.doses
						dataManager.model('MedicineLogEntryDose').create medicineLogEntry:medicineLogEntry, prescription:dataManager.model('Prescription').findOne(rxNumber:dose.rxNumber), quantity:dose.quantity


		prescriptionNameWithoutFormat: (name) ->
			formats = 'CAPSULE, GEL CAPSULE, TABLET, POWDER, PILL, PUFF, DROPS, EYE DROP, CREAM, CHEW, SUPPOSITORY, LIQUID, OINTMENT, SPRAY, SHAMPOO, SOLUTION, KIT, CLEANSER, CHEWABLE, ENEMA, FOAM, SUSPENSION, PUMP, ELIXIR, ACTUATION, VIAL, SYRUP, INHALER, CAPLET, DISKUS, AMPULE, SYRINGE'.split(', ')
			lastSpace = name.lastIndexOf(' ')
			
			if lastSpace != -1
				lastWord = name.substr(lastSpace + 1)
				for format in formats
					if lastWord == format.substr(0, lastWord.length)
						name = name.substr(0, lastSpace)
						break
			name



		monthlyProductPrice: (product, options) ->
			parseFloat(
				switch product.get('type')
					when 'pack'
						product.get('price')*options.quantity*28
					when 'item'
						switch options.packaging
							when 'divvyPACK'
								days = 0
								switch options.frequency
									when 'every day'
										days = 28
									when 'every other day'
										days = 14
									when 'on specific days'
										if options.specificDays.monday then ++ days
										if options.specificDays.tuesday then ++ days
										if options.specificDays.wednesday then ++ days
										if options.specificDays.thursday then ++ days
										if options.specificDays.friday then ++ days
										if options.specificDays.saturday then ++ days
										if options.specificDays.sunday then ++ days
										days *= 4

								quantity = 0

								for packetTime in options.packetTimes
									quantity += parseInt packetTime.quantity


								days*quantity*product.get('price')
							when 'Bottle'
								product.get 'computedPrice', options.packaging
			)
		dailyProductPrice: (product, options) ->
			parseFloat(
				switch product.get('type')
					when 'pack'
						product.get('price')*options.quantity
					when 'item'
						switch options.packaging
							when 'divvyPACK'
								quantity = 0

								for packetTime in options.packetTimes
									quantity += parseInt packetTime.quantity

								quantity*product.get('price')
							when 'Bottle'
								(product.get 'computedPrice', options.packaging)/28
			)

		orderProducts: (items, done) ->
			el = $ "<div class='divvyMarket-orderConfirmation'>#{rootLayer.tmpls.orderConfirmation}</div>"
			modalBox = UIHelpers.showModalBox el
			modalBox.layer.bind el, {
				user:g_userCont
				items:items
				cancel: -> modalBox.close()
				confirm: ->
					el.addClass 'loading'
					order = dataManager.model('Order').create user:g_userCont.get(), createdAt:new Date()
					for item in items
						dataManager.model('OrderItem').create order:order, product:item.product, options:item.options
					done?()

					setTimeout (->
						el = $ "<div class='divvyMarket-orderComplete'>#{rootLayer.tmpls.orderComplete}</div>"
						modalBox = UIHelpers.showModalBox el
						modalBox.layer.bind el, {
							user:g_userCont
							items:items
							gotIt: -> modalBox.close()
						}, {
							'items.price': (product, options) -> '$' + DivvyDose.monthlyProductPrice(product, options).format 2
						}
					), 2000
			}, {
				'items.price': (product, options) -> '$' + DivvyDose.monthlyProductPrice(product, options).format 2
			}

		# orderProducts: (items, done) ->


		openShoppingCart: ->
			UIHelpers.openModelView
				icon: 'shoppingCart.svg'
				html: rootLayer.tmpls.cart
				title: 'Cart'
				class: 'shoppingCartWindow'
				componentIniter: ->
					layer = @layer
					layer.bind @el,
						user:g_userCont
						total:new FormattedValue(((value) -> "$#{value.format 2}"), new ObjectListAggregate(g_userCont.get().get('shoppingCartItems'), 'monthlyPrice')).retain()
						checkOut: =>
							items = []
							g_userCont.get().get('shoppingCartItems').each (shoppingCartItem) ->
								items.push product:shoppingCartItem.get('product'), options:shoppingCartItem.get('options')
							DivvyDose.orderProducts items, ->
								shoppingCartItems = []
								g_userCont.get().get('shoppingCartItems').each (item) -> shoppingCartItems.push item
								item.delete() for item in shoppingCartItems

		productAddedToCartMessage: ->
			el = $('<a href="#" id="shoppingCartClone"><span class="count" bind-value="user.shoppingCartItems.length" /></a>')
			layer = new UILayer
			layer.bind el, user:g_userCont
			layer.addHtml $('body'), el
			srcEl = $('header .shoppingCart')

			el.css
				position:'absolute'
				left:srcEl.offset().left
				top:srcEl.offset().top
				zIndex:999999
			layer.addCss srcEl, visibility:'hidden'
			layer

			messageEl = $("<div class='addedToCartMessage'>#{rootLayer.tmpls.addedToCart}</div>")
			layer.addHtml $('body'), messageEl

			layer.bind messageEl,
				gotIt: -> layer.destruct()
				goToCart: ->
					layer.destruct()
					rootFrame.navigate 'shoppingCart'

			messageEl.css
				position:'absolute'
				left:el.offset().left + el.width()/2 - messageEl.outerWidth()/2
				top:el.offset().top + el.height() + 16
				zIndex:999999

			$('<div />').css(
				position:'absolute'
				left:0
				right: 0
				top: -11
				margin: 'auto'
				width:32
				height:11
				overflow:'hidden'
			).append($('<div />').css(
				'background-color': '#606467',
				'border-radius': '2px',
				'box-shadow': '0 2px 3px 0 rgba(0,0,0,0.24)',

				'transform': 'rotate(45deg)',
				'width': '32px',
				'height': '32px'

				position:'absolute'
				top:6

			)).appendTo messageEl
