define ['xyzp/UILayer', 'app/UIFrame', 'app/Component'], (UILayer, UIFrame, Component) ->
	class Stack
		constructor: ->
			@el = stackEl = $('<div class="stack">
				<div class="header">
					<a href="#" class="back" />
					<div class="title" />
					<a href="#" class="close" />
				</div>
				<div class="client" />
			</div>')

			@plates = []

			stackEl.find('.back').click => @popPlate(); false

			@layer = new UILayer

		initPlate: (conf:conf, frame:frame) ->
			if @plates.length == 1
				@el.addClass 'firstPlate'
				@el.find('.header .title').css 'backgroundImage', "url('app/images/#{conf.icon}')"
			else
				@el.removeClass 'firstPlate'
				@el.find('.header .title').css 'backgroundImage', ''

			@el.find('.header .title').html conf.title
			@el.find('.client').html "<div class='component #{conf.class}'>#{conf.html}</div>"

			component = new Component @layer.addLayer(new UILayer), @el.find('.client').children(':first'), conf.componentIniter
			component.stack = @
			component.frame = frame
			component.init()
			component.listen (args...) => conf.listener.call component, args...

			@currentComponent = component

		pushPlate: (conf) ->
			frame = new UIFrame
			conf.initFrame? frame:frame, stack:@
			@plates.push conf:conf, frame:frame
			@initPlate conf:conf, frame:frame
			frame.uiInited()

		popPlate: ->
			@currentComponent.layer.destruct()
			@plates[@plates.length - 1].frame.exit()
			@plates.pop()
			@initPlate @plates[@plates.length - 1]