define ->
	class UIFrame
		@nextFrameId:1
		@frames:{}
		constructor: ->
			if @framePackage = framePackage = UIFrame.framePackage
				delete UIFrame.framePackage
				@handle = framePackage.handle
				if @handle
					UIFrame.frames[@handle] = @

				@cameFrom = framePackage.navigatedFrom
				@rootFrame = @cameFrom.rootFrame
				@edge = @cameFrom.navigationalDirection

				@cameFrom.onFrame @, framePackage
			else
				@rootFrame = @
				@frames = {}


		setupUI: (cb) ->
			@_func = cb


		onDestroyUI: (@_onDestroyUI) ->
		onInitUI: (@_onInitUI) ->
		onReenterUI: (@_onReenterUI) ->

		destroyUI: ->
			@_onDestroyUI.call @ if @_onDestroyUI
			delete @slots
			UIFrame.frames = {}

		initUI: -> @_onInitUI.call @ if @_onInitUI

		onFrame: (frame, framePackage) ->
			@navigationFrame = frame
			if @nextSlot
				frame.slot = @nextSlot
				@slots ?= {}
				if framePackage.context == 'navigation'
					@slot[@nextSlot]?.exit?()

				@slot[@nextSlot] = frame
				delete @nextSlot

			if framePackage.context == 'navigation'
				frame.linkNumber = @rootFrame.extendChain frame.edge
			else if framePackage.context == 'restore'
				frame.linkNumber = framePackage.linkNumber
				@rootFrame.chain.push [] # TODO: FIX SUPER BIG HACKK!!1!11!!!eleven

			@rootFrame.frames[frame.linkNumber] = frame
		slot: (slot) ->
			@nextSlot = slot

		call: (params) ->
			# console.log @, params
			if @_func
				if @_func.call(@, _.clone params) == false
					if @cameFrom
						@cameFrom.call _.clone params
			else
				if @cameFrom
					@cameFrom.call _.clone params

		shift: (id, params, linkNumber, cb=null) ->
			UIFrame.framePackage = context:'restore', navigatedFrom:@, handle:UIFrame.nextFrameId++, cb:cb, linkNumber:linkNumber

			if _.isPlainObject id
				@navigationalDirection = id:id.id, params:id.params
				@call _.merge id, context:'restore', frameHandle:UIFrame.framePackage.handle
			else
				@navigationalDirection = id:id, params:params
				@call context:'restore', id:id, params:params, frameHandle:UIFrame.framePackage.handle

		navigate: (id, params,cb=null) ->
			# UIFrame.navigatedFrom = @
			# UIFrame.nextHandle = UIFrame.nextFrameId++

			UIFrame.framePackage = context:'navigation', navigatedFrom:@, handle:UIFrame.nextFrameId++, cb:cb

			if _.isPlainObject id
				@navigationalDirection = id:id.id, params:id.params
				# @_func.call @, _.merge id, context:'navigation', frameHandle:UIFrame.nextHandle
				@call _.merge id, context:'navigation', frameHandle:UIFrame.framePackage.handle
			else
				@navigationalDirection = id:id, params:params
				@call context:'navigation', id:id, params:params, frameHandle:UIFrame.framePackage.handle
				# @_func.call @, context:'navigation', id:id, params:params, frameHandle:UIFrame.nextHandle

		denavigate: ->
			# delete @navigationalDirection
			# delete @navigationFrame

		unlinkAt: (linkNumber) ->
			console.log linkNumber
			@chain = @chain.slice 0, linkNumber

			# iFrame = @
			# for i in [0...@chain.length]
			# 	iFrame = iFrame.navigationFrame
			iFrame = @frames[@chain.length - 1]

			console.log 'unlink', iFrame
			iFrame?.reenter?()

		unlink: (frame) -> @unlinkAt frame.linkNumber


		reenter: ->
			console.log @, 'reentered',@_onReenterUI
			@_onReenterUI.call @ if @_onReenterUI


		createSubFrame: ->
			# frame = new UIFrame
			# frame.parent = @
			# frame

			@adoptFrame new UIFrame

		adoptFrame: (frame) ->
			frame.parent = @
			frame

		extendChain: (edge) ->
			@chain ?= []
			linkNumber = @chain.length
			@chain.push edge
			linkNumber

		destruct: ->
			# console.log 'destruct', @

			if @cameFrom
				@cameFrom.denavigate @

			if @rootFrame
				@rootFrame.unlink @


			if @handle
				delete UIFrame.frames[@handle]


		exit: ->
			@destruct()

		return: ->
			@exit()
			
		exitFrame: (handle) ->
			UIFrame.frames[handle].exit()


		uiInited: ->
			if @framePackage?.cb
				@framePackage.cb @
