define ['xyzp/DataManager', 'xyzp/WebSocketTransport', 'xyzp/ObjectListAggregate', 'xyzp/XArray', 'xyzp/XValue', 'xyzp/CounterCall', 'app/DivvyDose', 'app/env'], (DataManager, WebSocketTransport, ObjectListAggregate, XArray, XValue, CounterCall, DivvyDose, env) ->
	->
		# env = 'prod'

		Date.prototype.stdTimezoneOffset = ->
			jan = new Date(this.getFullYear(), 0, 1)
			jul = new Date(this.getFullYear(), 6, 1)
			return Math.max(jan.getTimezoneOffset(), jul.getTimezoneOffset())


		Date.prototype.dst = ->
			return this.getTimezoneOffset() < this.stdTimezoneOffset()

		if IS_MOBILE  
			env = 'prod'


		getDevice = (cb) ->
			_device = 
				token:window.g_deviceToken
				# id:device.uuid
				platform:device.platform.toLowerCase()

			if _device.platform == 'ios'
				IDFVPlugin.getIdentifier (result) ->
					_device.id = result
					cb _device
			else
				_device.id = device.uuid
				cb _device



		getSession = (cb) ->
			if IS_MOBILE
				cb JSON.parse localStorage.getItem 'session'
			else
				$.ajax "#{appApiServer}/session.php",
					xhrFields:
						withCredentials:true
					success: cb
					error: ->
						console.log 'error', arguments

		[webSocketServer, dbmsServer, appApiServer] = switch env
			when 'dev' then ['ws://127.0.0.1:8080', 'http://dbms.divvydose.dev', 'http://server.divvydose.dev/app/v1']
			# when 'dev' then ['ws://127.0.0.1:8080', 'http://localhost/dbms', 'http://server.divvydose.dev/app/v1']
			when 'remote-dev' then ['wss://dbms-dev.divvydose.com:8080', 'https://dbms-dev.divvydose.com', 'https://server-dev.divvydose.com/app/v1']
			when 'prod' then ['wss://dbms.divvydose.com:8080', 'https://dbms.divvydose.com', 'https://server.divvydose.com/app/v1']

		window.g_conf =
			appApiServer:appApiServer
			env:env

		window.g_userId = null

		window.g_userCont = new XValue(false).retain()
		window.g_signedInUserCont = new XValue(false).retain()
		g_userCont.observe ->
			if user = g_userCont.get()
				window.g_userId = user.id
				user.set 'timezone', new Date().stdTimezoneOffset()
				$('body').removeClass('singedOut').addClass 'signedIn'
				Raven.setUserContext
					clientId: dataManager?.clientId
					userId:g_userId
			else
				window.g_userId = null
				$('body').addClass('signedOut').removeClass 'signedIn'
				Raven.setUserContext
					clientId: dataManager?.clientId


		failedToConnect: ->
			$('body').append '<div id="notConnected">
			<div><h3>Uh oh! Something\'s wrong...</h3>We were unable to establish a connection with our servers. If you have an active Internet connection, <a href="#" onclick="document.location.reload(); return false">please try reloading the page</a>. If that does not resolve the issue, <a target="_blank" href="https://www.divvydose.com/contact-us.html">contact customer support</a>, or try back again later. Sorry for the inconvenience!</div>
			</div>'
		init: (cb) ->
			getSession (response) ->
				userId = response?.userId
				if userId# && false
					g_userCont.set dataManager.model('User').instance userId
					g_signedInUserCont.set dataManager.model('User').instance userId
					woopra.identify
						email: g_userCont.get().get 'email'
						# name: g_userCont.get().get 'fullName'

				else
					g_userCont.set null

				cb()

		dataManager: (opts, cb) ->
			getSession (response) ->
				if response
					window.g_token = response.token
					transport = new WebSocketTransport webSocketServer
					_device = if IS_MOBILE
						token:window.g_deviceToken
						id:device.uuid
						platform:device.platform.toLowerCase()

					cb new DataManager '2', 'v1', 3, 'divvydose', '/user', dbmsServer, transport,
						env:env
						onClientId: (clientId) ->
							console.log clientId
							Raven.setUserContext
								clientId: clientId
								userId:g_userId

							if IS_MOBILE
								console.log _device
								if !_device.token
									if window.g_deviceToken
										_device.token = window.g_deviceToken
										@setClientParam 'device', _device
									else
										window.__onGetDeviceToken = =>
											_device.token = window.g_deviceToken
											@setClientParam 'device', _device
								else
									@setClientParam 'device', _device

						token:response.token
						offline:opts.offline
						client:
							type:if IS_MOBILE then 'mobile' else 'web'
							timezone: new Date().stdTimezoneOffset()
							dev:if env == 'dev' then true else undefined
							device:_device
							app:'divvydose'
						schemaMods:
							models:
								Supplement:
									form:
										display: 'fullName'

									attributes:
										fullName:
											type: 'computed'
											get: ->
												if @get('name') == @get('primaryName')
													@get('name')
												else
													"#{@get('name')} (#{@get('primaryName')})"

								SupplementStrength:
									form:
										display: 'name'

								Prescription:
									attributes:
										nameWithoutFormat:
											type: 'computed'
											get: ->
												DivvyDose.prescriptionNameWithoutFormat @get 'name' if @get 'name'

										format:
											type: 'computed'
											get: -> @get('name').substr(@get('nameWithoutFormat').length + 1)

									scopes:
										regular:
											test: (prescription) -> prescription.get('packaging') == 'In A Packet'

										asNeeded:
											test: (prescription) -> prescription.get('packaging') == 'Separate Bottle'

								PrescriptionDose:
									attributes:
										quantityNumber:
											type: 'computed'
											get: ->
												parseInt @get 'quantity'

								User:
									form:
										display: 'fullName'

									relationships:
										prescriptions:
											scopes:
												regular: (prescription) -> prescription.get('packaging') == 'In A Packet'
												asNeeded: (prescription) -> prescription.get('packaging') == 'Separate Bottle'

										addresses:
											scopes:
												nonCurrent: (address) -> !address.get 'isCurrent'

										caregivers:
											onAdd: (caregiver) ->
												
									attributes:
										formattedPhoneNumber:
											type: 'computed'
											get: ->
												if phoneNumber = @get('phoneNumber')
													"#{phoneNumber.substr 0, 3}.#{phoneNumber.substr 3, 3}.#{phoneNumber.substr 6}"
										current:
											type: 'computed'
											get: -> @ == g_userCont.get()
										fullName:
											type: 'computed'
											get: -> "#{@get 'firstName'} #{@get 'lastName'}"
										currentDivvyPack:
											type: 'computed'
											get: ->
												date = new Date().toLocalMysqlDateFormat()
												if @get 'divvyPacks'
													for startDate, divvyPack of @get 'divvyPacks'
														if date >= startDate && date <= divvyPack.packets[divvyPack.packets.length - 1].time.substr(0, 10)
															return divvyPack

										resolvedPicture:
											type: 'computed'
											get: ->
												@get('picture') ? 'app/images/profilePicturePlaceholder@2x.png'


										# doses:
										# 	type: 'computed'
										# 	get: ->
										# 		divvyPack = @get 'currentDivvyPack'
												


								Product:
									storage:
										localStorage:('productsDb' if IS_MOBILE)
										file:('app/products.json' if IS_MOBILE)
										remote: "#{dbmsServer}/v1/core/main.php?db=divvydose&resource=/products"


									attributes:
										inCart:
											type: 'computed'
											get: ->
												g_userCont.get().get('shoppingCartItems').exists product:@ if g_userCont.get()

										icon:
											type: 'computed'
											get: ->
												if @get('type') == 'pack'
													'bioPod'
												else if @get('type') == 'item'
													if @get('size') == 'BOTTLE'
														'bottle'
													else if @get('size') == 'TUBE'
														'tube'
													else
														switch @get('format')
															#when 'CAPSULE' then 
															when 'CHEW' then 'chew'
															when 'CHEWS' then 'chew'
															# when 'CREAM' 
															when 'DROP' then 'drops'
															when 'EYE DROP' then 'drops'
															# when 'GEL' then 
															# when 'LIQUID' then 
															# when 'OINTMENT' then
															# when 'PACK' then
															when 'PILL' then 'capsule'
															when 'CAPSULE' then 'capsule'
															# when 'POWDER' then 
															when 'SPRAY' then 'spray'
															when 'SUPPOSITORY' then 'suppository'
															when 'TABLET' then 'tablet'


										listingName:
											type: 'computed'
											get: ->
												if @get('type') == 'pack'
													"<picture style='background-image: url(app/images/#{@get 'icon'}.png)' /><span class='name'>#{@get 'name'}</span>"
												else
													name = "<picture style='background-image: url(app/images/#{@get 'icon'}.png)' /><span class='name'>#{@get 'name'} (#{@get 'primaryName'})</span>"

													dosePart = []
													if @get 'dose'
														dosePart.push @get 'dose'

														if @get 'size'
															dosePart.push @get 'size'

													if dosePart.length
														name += " <span class='dose'>#{dosePart.join ' &mdash; '}</span>"
													name

										# dailyPrice:
										# 	type: 'computed'
										# 	parameters:true
										# 	get: ()

										unitPrice:
											type: 'computed'
											parameters: true
											get: (packaging) ->
												if @get('type') == 'pack'
													"$#{@get('computedPrice')} per day"
												else
													price = @get 'computedPrice', packaging

													parts = price.toString().split '.'
													parts[1] ?= ''
													price = "#{parts[0]}.#{parts[1].substr(0, 2).padRight 2, 0}"
													"<span class='value'>$#{price}</span>/#{if packaging == 'Bottle' then "bottle (#{@get('size')} #{@get('format').toLowerCase()}s)" else @get('format').toLowerCase()}"

										computedPrice:
											type: 'computed'
											parameters: true
											get: (packaging) ->
												parseFloat if @get('type') == 'pack'
													@get('price')
												else
													price = if packaging == 'Bottle'
														if @get('options') == 'U'
															@get('price')*@get('size')
														else
															@get('price')
													else
														@get('price')

										titleName:
											type: 'computed'
											get: ->
												if @get('type') == 'pack'
													"<span class='name'>#{@get 'name'}</span>"
												else
													"<span class='name'>#{@get 'name'} (#{@get 'primaryName'})</span>"

								ShoppingCartItem:
									attributes:
										unitPrice:
											type: 'computed'
											get: ->
												@get('product').get('unitPrice', @get('options').packaging)

										computedPrice:
											type: 'computed'
											get: ->
												@get('product').get('computedPrice', @get('options').packaging)


										dailyPrice:
											type:'computed'
											get: -> DivvyDose.dailyProductPrice @get('product'), @get('options')


										monthlyPrice:
											type: 'computed'
											get: -> DivvyDose.monthlyProductPrice @get('product'), @get('options')
												# parseFloat(
												# 	switch @get('product').get('type')
												# 		when 'pack'
												# 			@get('product').get('price')*@get('options').quantity*28
												# 		when 'item'
												# 			switch @get('options').packaging
												# 				when 'divvyPACK'
												# 					days = 0
												# 					switch @get('options').frequency
												# 						when 'every day'
												# 							days = 28
												# 						when 'every other day'
												# 							days = 14
												# 						when 'on specific days'
												# 							if @get('options').specificDays.monday then ++ days
												# 							if @get('options').specificDays.tuesday then ++ days
												# 							if @get('options').specificDays.wednesday then ++ days
												# 							if @get('options').specificDays.thursday then ++ days
												# 							if @get('options').specificDays.friday then ++ days
												# 							if @get('options').specificDays.saturday then ++ days
												# 							if @get('options').specificDays.sunday then ++ days
												# 							days *= 4

												# 					quantity = 0

												# 					for packetTime in @get('options').packetTimes
												# 						quantity += parseInt packetTime.quantity


												# 					days*quantity*@get('product').get('price')
												# 				when 'Bottle'
												# 					@get('product').get 'computedPrice', @get('options').packaging
												# )

								MedicineLogEntry:
									attributes:
										event:
											forms:
												display: ->
													if @get('event') == 'taken' then 'Taken' else 'Not Taken'
										eventDisplay:
											type: 'computed'
											get: -> if @get('event') == 'taken' then 'Taken' else 'Not Taken'


								Address:
									attributes:
										isCurrent:
											type: 'computed'
											get: ->
												@get('user') && @ == @get('user').get('currentAddress')

											set: (v) ->
												if v
													if !@get 'isCurrent'
														@get('user').set 'currentAddress', @
												else
													if @get 'isCurrent'
														@get('user').set 'currentAddress', null
								Insurance:
									attributes:
										isCurrent:
											type: 'computed'
											get: ->
												@get('user') && @ == @get('user').get('currentInsurance')

											set: (v) ->
												if v
													if !@get 'isCurrent'
														@get('user').set 'currentInsurance', @
												else
													if @get 'isCurrent'
														@get('user').set 'currentInsurance', null

								PaymentMethod:
									attributes:
										numberDisplay:
											type: 'computed'
											get: ->
												if @get('number')
													placeholders = @get('number').length - 4
													str = ''
													for i in [0...placeholders]
														str += '*'
													str += @get('number').substr(placeholders)
													str
												else
													''
										isCurrent:
											type: 'computed'
											get: ->
												@get('user') && @ == @get('user').get('currentPaymentMethod')

											set: (v) ->
												if v
													if !@get 'isCurrent'
														@get('user').set 'currentPaymentMethod', @
												else
													if @get 'isCurrent'
														@get('user').set 'currentPaymentMethod', null
				else
					cb()


