define ['xyzp/XValue', 'xyzp/ComputedValue', 'xyzp/UILayer', 'app/DivvyDose'], (XValue, ComputedValue, UILayer, DivvyDose) ->
	(productObj) ->
		->
			viewEl = @el
			window.productLayer = layer = @layer

			getData = ->
				data = {}
				if productObj.get('type') == 'pack'
					data = quantity:layer.value('quantity').get()
				else
					data =
						packaging: layer.value('packaging').get()

					if data.packaging == 'divvyPACK'
						data.frequency = layer.value('frequency').get()
						if data.frequency == 'on specific days'
							data.specificDays =
								sunday:!!layer.value('onSunday').get()
								monday:!!layer.value('onMonday').get()
								tuesday:!!layer.value('onTuesday').get()
								wednesday:!!layer.value('onWednesday').get()
								thursday:!!layer.value('onThursday').get()
								friday:!!layer.value('onFriday').get()
								saturday:!!layer.value('onSaturday').get()

						packetTimes = []
						layer.value('packetTimes').each (packetTime) ->
							packetTimes.push time:packetTime.time.get(), quantity:packetTime.quantity.get()

						data.packetTimes = packetTimes
					else if data.packaging == 'Bottle'
						data.autoRefill = !!layer.value('autoRefill').get()
						# data.size = supplement.size
						# data.quantity = layer.value('quantity').get()
				data

			layer.value('frequency').set 'every day'
			switch productObj.get('type')
				when 'pack'
					layer.value('quantity').set 1
				when 'item'
					if productObj.get('options') in ['P', 'U']
						layer.value('packaging').set 'divvyPACK'

						if productObj.get('sig') != ''
							[number, time] = productObj.get('sig').split ' '
							number = parseInt number[1]

							times =
								QD: ['8:00AM']
								BID: ['8:00AM', '8:00PM']
								QHS: ['10:00PM']
								TID: ['8:00AM', '12:00AM', '8:00PM']

							packetTimes = []
							for t in times[time]
								packetTimes.push time: new XValue(t).retain(), quantity:new XValue(number).retain()

							layer.list('packetTimes').setArray packetTimes
						else
							layer.list('packetTimes').setArray [time: new XValue('8:00AM').retain(), quantity:new XValue(1).retain()]

					else if productObj.get('options') == 'B'
						layer.value('packaging').set 'Bottle'


			layer.value('autoRefill').set true				

			layer.withValue layer.value('packaging'), (packaging) ->
				viewEl.find('.packaging .selected').removeClass 'selected'
				viewEl.find(".packaging [data-value='#{packaging}']").addClass 'selected'

			viewEl.find('picture').css 'backgroundImage', "url(app/images/#{productObj.get('icon')}.png)"

			layer.addLayerProvider 'showMore', (layer, el:el, longText:longText, shortText:shortText) ->
				# console.log params
				layer.if (->shortText.get() && longText.get()), (l) ->
					valueEl = $('<span />')
					shortTextLayer = l.addLayer new UILayer
					showMoreEl = $('<a href="#">Show More</a>').click ->
						shortTextLayer.destruct()
						l.withValue longText, (longText) -> valueEl.html longText
						false
					l.addHtml el, valueEl
					shortTextLayer.addHtml el, showMoreEl
					shortTextLayer.withValue shortText, (shortText) -> valueEl.html shortText


				layer.if (->!shortText.get() || !longText.get()), (l) ->
					valueEl = $('<span />')
					text = if shortText.get()
						shortText
					else
						longText
					l.addHtml el, valueEl
					l.withValue text, (text) -> valueEl.html text



			layer.bind viewEl, {
				product:productObj
				addMedicationTotal: (new ComputedValue ->
					# productObj.get 'unitPrice', layer.value('packaging').get()
					'$' + parseFloat(
						switch productObj.get('type')
							when 'pack'
								productObj.get('price')*layer.value('quantity').get()
							when 'item'
								switch layer.value('packaging').get()
									when 'divvyPACK'
										# days = 0
										# switch layer.value('frequency').get()
										# 	when 'every day'
										# 		days = 28
										# 	when 'every other day'
										# 		days = 14
										# 	when 'on specific days'
										# 		if layer.value('onMonday').get() then ++ days
										# 		if layer.value('onTuesday').get() then ++ days
										# 		if layer.value('onWednesday').get() then ++ days
										# 		if layer.value('onThursday').get() then ++ days
										# 		if layer.value('onFriday').get() then ++ days
										# 		if layer.value('onSaturday').get() then ++ days
										# 		if layer.value('onSunday').get() then ++ days
										# 		days *= 4

										quantity = 0

										layer.value('packetTimes').each (packetTime) ->
											quantity += parseInt packetTime.quantity.get()


										quantity*productObj.get('price')
									when 'Bottle'
										(productObj.get 'computedPrice', layer.value('packaging').get())/28
					).format(2) + '/day'
				).retain()

			},
			'%packetTimes':
				delete: (el, [packetTime]) ->
					layer.list('packetTimes').remove packetTime

				quantityOptions: ->
					[
						{count:1, label:"1 #{productObj.get('format')}"}
						{count:2, label:"2 #{productObj.get('format')}"}
						{count:3, label:"3 #{productObj.get('format')}"}
						{count:4, label:"4 #{productObj.get('format')}"}
						{count:5, label:"5 #{productObj.get('format')}"}
						{count:6, label:"6 #{productObj.get('format')}"}
						{count:7, label:"7 #{productObj.get('format')}"}
						{count:8, label:"8 #{productObj.get('format')}"}
					]

			addPacketTime: ->
				layer.list('packetTimes').push time:new XValue('8:00AM'), quantity:new XValue(1)

			quantityOptions: ->
				[
					"28 #{productObj.get('format')}"
					"56 #{productObj.get('format')}"
					"84 #{productObj.get('format')}"
					"112 #{productObj.get('format')}"
				]

			addToCart: ->
				data = getData()
				# if productObj.get('type') == 'pack'
				# 	data = quantity:layer.value('quantity').get()
				# else
				# 	data =
				# 		packaging: layer.value('packaging').get()

				# 	if data.packaging == 'divvyPACK'
				# 		data.frequency = layer.value('frequency').get()
				# 		if data.frequency == 'on specific days'
				# 			data.specificDays =
				# 				sunday:!!layer.value('onSunday').get()
				# 				monday:!!layer.value('onMonday').get()
				# 				tuesday:!!layer.value('onTuesday').get()
				# 				wednesday:!!layer.value('onWednesday').get()
				# 				thursday:!!layer.value('onThursday').get()
				# 				friday:!!layer.value('onFriday').get()
				# 				saturday:!!layer.value('onSaturday').get()


				# 		packetTimes = []
				# 		layer.value('packetTimes').each (packetTime) ->
				# 			packetTimes.push time:packetTime.time.get(), quantity:packetTime.quantity.get()

				# 		data.packetTimes = packetTimes
				# 	else if data.packaging == 'Bottle'
				# 		data.autoRefill = !!layer.value('autoRefill').get()
				# 		# data.size = supplement.size
				# 		# data.quantity = layer.value('quantity').get()

				dataManager.model('ShoppingCartItem').create user:g_userCont.get(), product:productObj, options:data
				
				setTimeout (->DivvyDose.productAddedToCartMessage()), 0 if !rootFrame.isMobile()

			checkout: =>
				# @signal 'checkout'
				# DivvyDose.openShoppingCart()
				DivvyDose.orderProducts [product:productObj, options:getData()]

			if productObj.get('options') == 'U'
				viewEl.find('.packaging .option').click ->
					layer.value('packaging').set $(@).attr 'data-value'
			else
				viewEl.find('.packaging').addClass 'disabled'