define ['xyzp/UILayer', 'app/UIFrame', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'xyzp/FormattedValue', 'xyzp/ObjectListAggregate', 'app/Component', 'app/MobileNav', 'app/Breakpoints', 'app/UIHelpers'], (UILayer, UIFrame, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool, FormattedValue, ObjectListAggregate, Component, MobileNav) ->
	Breakpoints = require 'app/Breakpoints'
	UIHelpers = require 'app/UIHelpers'

	document.addEventListener 'animationstart', (event) ->
		if event.animationName == 'inserted'
			el = $ event.target

			if el.is 'select.hasLabel'
				if event.target.selectedIndex == 0
					$(event.target).addClass 'label'
				else
					$(event.target).removeClass 'label'

				$(event.target).change ->
					if @selectedIndex == 0 && ($(@).val() == '' || $(@).val() == null)
						$(@).addClass 'label'
					else
						$(@).removeClass 'label'
			else if el.is 'a[target="_blank"]'
				if IS_MOBILE
					el.click ->
						window.open $(@).attr('href'), '_system'
						false


			# else if el.is 'input[type="tel"]'
			# 	el.change ->
			# 		val = el.val().replace(/[() \-.]/g, '')
			# 		el.val val

	initMobile = ->
		woopra.track 'openedDivvyApp'

		window.getSchedule = ->
			if g_signedInUserCont.get()
				divvyPack = g_signedInUserCont.get().get 'currentDivvyPack'
				if divvyPack
					times = {}
					for dose in divvyPack.packets
						times[dose.time] = true
					_.keys(times).sort()
				else
					[]
			else
				[]

		window.scheduleNotification = (at, time, cb) ->
			console.log 'scheduleNotification', at, time
			cordova.plugins.notification.local.schedule
				id:at.getTime()
				at:at
				text: "Time for your #{Date.create(time).format('{12hr}:{mm}{TT}')} divvyPACK ;)"
				title: g_signedInUserCont.get().get('fullName')
				data: time
				cb

		window.scheduleLocalNotifications = ->
			if IS_MOBILE
				cordova.plugins.notification.local.cancelAll ->
					times = DivvyDose.nextTimes 64
					i = 0
					s = ->
						if i < times.length
							time = times[i++]
							if !dataManager.model('MedicineLogEntry').findOne(time:time.toLocalMysqlFormat())
								scheduleNotification time, time.toLocalMysqlFormat(), s
					s()

		
		onPushNotification (event) ->
			window.notificationEvent = event

			notification = null
			if device.platform in ['android', 'Android']
				if event.event == 'message'
					notification =
						foreground:event.foreground
						message:event.message
						time:event.payload.time
						type:event.payload.type
			else
				notification =
					foreground:event.foreground == '1'
					message:event.body
					time:event.time
					type:event.type

			console.log notification

			if notification
				if notification.foreground
					if notification.message
						if notification.type == 'reminder'
							showConfirmBox
								text:notification.message
								action: (action) ->
									DivvyDose.log notification.time, if action == 'Taken' then 'taken' else 'notTaken'

						else
							navigator.notification.alert notification.message, (->), 'divvyDOSE'


					if notification.sound
						snd = new Media notification.sound
						snd.play()

					if notification.badge
						plugins.pushNotification.setApplicationIconBadgeNumber (->), (->), notification.badge
				else
					showDoseConfirmation()
					DivvyDose.log notification.time, 'taken'
					scheduleLocalNotifications()

		onLocalNotification (event, notification) ->
			console.log event, notification
			setTimeout scheduleLocalNotifications, 1000
			window.notification = notification

			if event ==  'trigger'
				showConfirmBox
					text:notification.text
					action: (action) ->
						DivvyDose.log notification.data, if action == 'Taken' then 'taken' else 'notTaken'

			else if event == 'click'
				showDoseConfirmation()
				DivvyDose.log notification.data, 'taken'


		window.updateClientSchedule = ->
			console.log 'update schedule', getSchedule()
			dataManager.setClientParam 'schedule', getSchedule()

		timerId = null
		window.callUpdateClientSchedule = ->
			clearTimeout timerId
			setTimeout (->
				updateClientSchedule()
				scheduleLocalNotifications()
			), 0

		window.observePool = new ObservePool().retain()
		userChanged = ->
			observePool.allStopObserving()
			if g_userCont.get()
				observePool.observe g_userCont.get().prop('divvyPacks'), callUpdateClientSchedule
				callUpdateClientSchedule()

		userChanged()

	window.g_mobileNav = new MobileNav


	->
		GET = ((a) ->
		  if a == ''
		    return {}
		  b = {}
		  i = 0
		  while i < a.length
		    p = a[i].split('=', 2)
		    if p.length == 1
		      b[p[0]] = ''
		    else
		      b[p[0]] = decodeURIComponent(p[1].replace(/\+/g, ' '))
		    ++i
		  b
		)(window.location.search.substr(1).split('&'))

		window.showDoseConfirmation = ->
			window._showDoseConfirmation = true

		initMobile() if IS_MOBILE



		pages = ['dashboard', 'medications', 'billing', 'calendar', 'history', 'shipping', 'account', 'caregivers', 'contact', 'charts', 'divvymarket']

		backButtonLayer = null
		backButtonCbs = []
		window.pushBackButton = (cb) ->
			if backButtonCbs.length == 0
				backButtonLayer = rootLayer.addLayer new UILayer
				backButtonLayer.addDestructFunc -> backButtonCbs = []
				backButtonLayer.addClass $('body'), 'backButton'
				el = $('<div class="backButton" />')
				backButtonLayer.addHtml $('.headerWrapper'), el
				backButtonLayer.bindEvent el, 'click', ->
					backButtonCbs.pop()()
					if !backButtonCbs.length
						backButtonLayer.destruct()

			backButtonCbs.push cb

		window.breakpoints = breakpoints = new Breakpoints
		breakpoints.addBreakpoints 'main',
			614:
				name: 'mobile'
				init: (layer) ->
					layer.addHtml $('.headerWrapper'), '<a href="#" class="menu" />'
					menuLayer = null
					$('.headerWrapper .menu').click ->
						if menuLayer
							menuLayer.destruct()
						else
							menuLayer = new UILayer
							menuLayer.on 'destruct', -> menuLayer = null
							menuLayer.addClass $('.headerWrapper .menu'), 'open'
							layer.addLayer menuLayer
							menuEl = $('<div class="menu" />')
							menuLayer.addHtml $('body'), menuEl
							menuEl.append $('header .nav').children().clone()
							for p in pages
								do (p) ->
									menuLayer.if (->rootLayer.value('page').get() == p), (l) ->
										l.addClass menuEl.find('.' + p), 'active'

									menuEl.find('.' + p).click ->
										rootLayer.value('page').set p
										menuLayer.destruct()
										false
						false

		breakpoints.onBreakpointChanged = (currentBreakpoint, previousBreakpoint) ->
			# console.log currentBreakpoint, previousBreakpoint
			if currentBreakpoint == 614 || previousBreakpoint == 614
				rebuildUI()

		window.showConfirmBox = (opts={}) ->
			contEl = $ """<div class="dialogBoxWrapper"><div class="dialogBox">
				<p>#{opts.text ? 'asdf'}</p>
				<div class="actions">
					<button>Taken</button>
					<button>Not Taken</button>
				</div>
			</div></div>"""
			contEl.find('.actions button').click ->
				opts.action $(@).html()
				contEl.fadeOut -> contEl.remove()

			contEl.appendTo 'body'

		updateMenu = ->
			if $('body').hasClass 'signedIn'
				moreEl = $('header .nav li.more')
				navItemEls = $('header .nav li:not(.more)')
				# hide = false
				navItemEls.show()

				moreMenuEl = $('header .topBar .moreMenu')

				last = $(navItemEls[navItemEls.length - 1])
				hidden = []
				if last.offset().left + last.width() > $(window).width() - 10
					moreEl.show()

					for i in [navItemEls.length - 1..0]
						if moreEl.offset().left + moreEl.width() > $(window).width() - 10
							$(navItemEls[i]).hide()
							hidden.unshift navItemEls[i]
						else
							break
				else
					moreEl.hide()

				moreMenuEl.html ''
				for el in hidden

					moreMenuEl.append "<a href='#' data-page='#{$(el).attr 'data-page'}'>#{$(el).find('a').html()}</a>"
				moreMenuEl.find('a').click ->
					rootLayer.value('page').set $(@).attr 'data-page'
					$('header').removeClass 'showMoreMenu'
					false


				moreMenuEl.css
					left:moreEl.offset().left + moreEl.width() - moreMenuEl.outerWidth() - $('header .topBar').offset().left + 10
					top:moreEl.offset().top + moreEl.height() - 10 - $('header .topBar').offset().top





			# for el in navItemEls
			# 	$(el).show() if !hide
			# 	if hide || $(el).offset().left + $(el).width() > $(window).width()
			# 		hide = true
			# 		$(el).hide()

		# resizeTimer = null
		# $(window).resize ->
		# 	clearTimeout resizeTimer
		# 	resizeTimer = setTimeout (->
		# 		breakpoints.update()

		# 		if breakpoints.currentBreakpoint != 614
		# 			updateMenu()
		# 	), 50

		window.rootFrame = new UIFrame
		rootFrame.isMobile = -> $('body').hasClass 'breakpoint-614'

		rootFrame.setupUI (context:context, id:id, params:params) ->
			if id in pages
				@slot 'page'
				rootLayer.value('page').set id
				true
			else if id == 'shoppingCart'
				DivvyDose.openShoppingCart()
				true
			false


		window.rebuildUI = ->
			chain = _.clone rootFrame.chain
			rootFrame.chain = []
			rootFrame.destroyUI()
			rootFrame.initUI()
			frame = rootFrame

			doShift = (frame, linkNumber) ->
				if chain[linkNumber]
					frame.shift chain[linkNumber].id, chain[linkNumber].params, linkNumber, (f) -> doShift f, linkNumber + 1
				else
					rootFrame.chain = chain
					frame.reenter()
			doShift rootFrame, 0
			
		rootFrame.onDestroyUI ->
			rootLayer.destruct()

		rootFrame.onInitUI ->
			window.rootLayer = new UILayer
			rootLayer.el = $('body')
			rootLayer.addHtml rootLayer.el, mainTemplate
			rootLayer.value('page')#.set null

			resizeTimer = null
			rootLayer.bindEvent $(window), 'resize', ->
				clearTimeout resizeTimer
				resizeTimer = setTimeout (->
					breakpoints.update()

					if breakpoints.currentBreakpoint != 614
						updateMenu()
				), 50

			# rootFrame.navigate 'dashboard'

			rootLayer.globalScope =
				signedInUser:g_signedInUserCont
				setUser: (user) ->
					# console.log user
					g_userCont.set user
					rootLayer.value('showUserDropdown').set false

				setPage: (page) -> rootLayer.value('page').set page
				id: (instance, name) ->
					# console.log instance, name
					"#{instance.id}_#{name}"

			rootLayer.addValueFormatter (value, context:context, type:type) ->
				if context == 'editing'
					if !value? || _.isNaN value
						return ''
				else
					if !value? || _.isNaN(value) || value == ''
						# return '(none)'
						return ''

				# console.log value, type

				if type == 'duration'
					if value
						if value < 0
							'negative ' + juration.stringify(-value)
						else
							juration.stringify value
					else if context != 'editing'
						'nothing'
				else if type == 'date'
					# console.log 'asdf'
					return value.format '{Mon} {ord}, {year}'

			rootLayer.addLayerProvider 'value', (layer, params) ->
				layer.el = params.el

				layer.addClass layer.el, 'attribute'

				layer.value('editing').set false

				layer.addCss layer.el, position:'relative'

				layer.switch 'editing', [
					no, (l) ->
						l.bindValue layer.el, params.value
						l.bindEvent layer.el, 'click', (e) ->
							layer.value('editing').set true

					yes, (l) ->
						inputEl = l.addHtml layer.el, '<input type="text">'
						inputEl.attr 'placeholder', params.title
						inputEl.val layer.formatValue params.value.get(), context:'editing', type:util.type params.value
						inputEl.get(0).select()

						if params.value.meta('type') instanceof Model
							layer.el.find('input').keydown (e) ->
								if e.keyCode == 27
									layer.value('editing').set false
								# else if e.keyCode == 13
								# 	params.value.set inputEl.val()
								# 	layer.value('editing').set false

							list = params.value.meta('type')

							l.value('inputValue').set params.value.form('display').get()
							setTimeout (=>inputEl.get(0).select()), 0

							l.bindValue inputEl, l.value('inputValue')
							l.if (->l.value('inputValue').get()), (l2) ->
								pattern = ->
									new RegExp("\\b(#{l.value('inputValue').get().replace(/\\/g, '\\\\')})", 'i')

								filteredList = new FilteredArray list, (instance) ->
									if instance.form('display').get()
										instance.form('display').get().match pattern()


								layer.observe l.value('inputValue'), ->
									filteredList.update()


								listEl = $ """
									<ul class="autoSuggest" bind-list="list">
										<li bind-value="inputValue" />
										<li bind />
									</ul>
								"""
								l2.value('selected').set 1
								l2.bind listEl, {list:filteredList, inputValue:l.value('inputValue')},
									'list.init': (el, [instance], layer:l3, index:index) ->
										l3.withValue l2.value('selected'), (selected) ->
											if selected - 1 == index
												el.addClass 'selected'
											else
												el.removeClass 'selected'

										l3.withValue instance.form('display'), (display) ->
											el.html display.replace pattern(), "<b>$1</b>"

								l2.withValue l2.value('selected'), (selected) ->
									if selected == 0
										listEl.find('li:first').addClass 'selected'
									else
										listEl.find('li:first').removeClass 'selected'

								l2.addHtml layer.el, listEl
								listEl.css position:'absolute', left:0, zIndex:1

								l2.bindEvent inputEl, 'keydown', (e) ->
									length = filteredList.length() + 1
									switch e.keyCode
										when 38 # up
											l2.value('selected').set (((l2.value('selected').get() ? 0) - 1) + length) % length
											false
										when 40 # down
											l2.value('selected').set (((l2.value('selected').get() ? 0) + 1) + length) % length
											false
										when 13
											selected = l2.value('selected').get()
											if selected == 0 || !filteredList.get selected - 1
												params.value.set list.call 'byDisplay', l2.value('inputValue').get()
											else
												params.value.set filteredList.get selected - 1
											layer.value('editing').set false
											false
										else
											true

						else
							layer.el.find('input').keydown (e) ->
								if e.keyCode == 27
									layer.value('editing').set false
								else if e.keyCode == 13
									params.value.set inputEl.val()
									layer.value('editing').set false
				]


			# dose confirmation
			if !_showDoseConfirmation?
				rootLayer.el.find('.doseConfirmationWrapper').hide()
			else
				delete window._showDoseConfirmation

			window.showDoseConfirmation = ->
				rootLayer.el.find('.doseConfirmationWrapper').show()

			rootLayer.el.find('.doseConfirmationWrapper').click ->
				rootLayer.el.find('.doseConfirmationWrapper').fadeOut 350
				false

			breakpoints.update true

			rootLayer.bind rootLayer.el, {
				flashMessage: new XValue(if GET.resetpassword then 'Password was successfully reset.')
				rootLayer: -> rootLayer
				toggleUserDropdown: ->
					rootLayer.value('showUserDropdown').set !rootLayer.value('showUserDropdown').get()
				user:
					g_userCont
				signedInUser:
					g_signedInUserCont
				signedOutInit: ->
					breakpoints.update()
				exitCaregiverMode: ->
					g_userCont.set g_signedInUserCont.get()

				shoppingCart: ->
					# DivvyDose.openShoppingCart()
					rootFrame.navigate 'shoppingCart'
					
				main: ->
					firstPage = true
					page = (name) ->
						[name, (l) ->
							breakpoints.removeBreakpoints 'page'
							frame = rootFrame.createSubFrame()

							pageEl = $ '<main />'
							if !firstPage
								pageEl.hide()
							l.el = pageEl
							l.addHtml $('.mainWrapper'), pageEl
							l.addClass $('html'), "#{name}-page"

							l.addClass $(".nav .#{name}"), 'active'

							l.addFrame frame
							
							require ["app/pages/#{name}"], (page) ->
								onDone = ->
									breakpoints.update true
									updateMenu()
									if firstPage
										firstPage = false
									else
										pageEl.fadeIn 200
									frame.uiInited()
										
								pageEl.removeData 'bindVisited'
								if _.isFunction page
									page frame, l, onDone
								else
									breakpoints.addBreakpoints 'page', page.breakpoints if page.breakpoints
									page.init frame, l, onDone
								window.pageLayer = l
						]

					params = []
					for p in pages
						params = params.concat page(p)

					rootLayer.if (->g_userCont.get()), (layer) ->
						for p in pages
							do (p) ->
								$('.nav .' + p).click ->
									rootFrame.navigate p
									$('header').removeClass 'showMoreMenu'
									false

						layer.switch 'page', params

						layer.withValue rootLayer.value('page'), (page) -> woopra.track 'appPageView', page:page

				signIn: ->
					data = UIHelpers.inputData $('#signIn')
					$.ajax (if IS_MOBILE then "#{g_conf.appApiServer}/signIn.php?mobile=1" else "#{g_conf.appApiServer}/signIn.php"),
						method:'POST'
						data:data
						xhrFields:withCredentials:true
						success: (response) ->
							console.log response
							if response != 0
								if IS_MOBILE
									localStorage.setItem 'session', JSON.stringify response
									document.location.reload()
								else
									url = document.location.href.match(/^([^?]*)/)[1]
									if url == document.location.href
										document.location.reload()
									else
										document.location.href = url
							else
								alert 'failed to sign in'
			}, {
				logOut: ->
					if IS_MOBILE
						cordova.plugins.notification.local.cancelAll ->
							dataManager.offlineDb.clear()
							localStorage.removeItem 'session'
							dataManager.terminateClient ->
								document.location.reload()
					else
						$.ajax "#{g_conf.appApiServer}/signOut.php",
							xhrFields:withCredentials:true
							success: (response) ->
								document.location.reload()
				'#User.signIn': (el, [user]) ->
					g_userId = user.id
					g_userCont.set user
			}

			$('header .nav li.more').click ->
				$('header').toggleClass 'showMoreMenu'
				false

			rootLayer.el.find('.verifyEmail a').click ->
				$.ajax "#{g_conf.appApiServer}/resendVerificationEmail.php?token=#{g_token}",
					xhrFields:withCredentials:true
					success: (response) ->
						rootLayer.el.find('.verifyEmail a').html 'Resent'

			@uiInited()

		mainTemplate = null
		$.get base + 'app/templates/main.html', (_mainTemplate) ->
			mainTemplate = _mainTemplate
			rootFrame.initUI()
			rootFrame.navigate 'dashboard'
