define ['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'app/DivvyDose', 'app/UIHelpers'], (UILayer, FilteredArray, ArraySlice, XValue, ComputedValue, ComputedList, util, Model, ObservePool, DivvyDose, UIHelpers) ->
	breakpoints:
		else:
			init: (layer) ->
				col1 = $('<div class="col col1" />')
				col2 = $('<div class="col col2" />')
				col3 = $('<div class="col col3" />')

				$('article.personal').appendTo col1
				$('article.allergies').appendTo col2
				$('article.conditions').appendTo col2
				$('article.security').appendTo col3
				
				$('main .col').remove()
				col1.appendTo 'main'
				col2.appendTo 'main'
				col3.appendTo 'main'

		932:
			init: (layer) ->
				col1 = $('<div class="col col1" />')
				col2 = $('<div class="col col2" />')

				$('article.personal').appendTo col1
				$('article.allergies').appendTo col2
				$('article.conditions').appendTo col2
				$('article.security').appendTo col2
				
				$('main .col').remove()
				col1.appendTo 'main'
				col2.appendTo 'main'

		614:
			init: (layer) ->
				col1 = $('<div class="col col1" />')

				$('article.personal').appendTo col1
				$('article.allergies').appendTo col1
				$('article.conditions').appendTo col1
				$('article.security').appendTo col1
				
				$('main .col').remove()
				col1.appendTo 'main'

	init: (pageFrame, pageLayer, done) ->
		$.get base + 'app/templates/pages/account.html', (mainTemplate) ->
			pageLayer.el.append mainTemplate
			pageLayer.globalScope = 
				changeName:UIHelpers.editDialog
					fields:['firstName', 'lastName']
					instance: g_userCont.get()
					html:->pageLayer.tmpls.changeName
				changeEmail:UIHelpers.editDialog
					fields:['email']
					instance: g_userCont.get()
					html:->pageLayer.tmpls.changeEmail
				changePhoneNumber:UIHelpers.editDialog
					fields:['phoneNumber']
					instance: g_userCont.get()
					html:->pageLayer.tmpls.changePhoneNumber
					mask:phoneNumber:'999.999.9999'
					# init: (el) ->
					# 	el.find('input[type=text]').inputmask '999.999.9999'
					# display:
					# 	phoneNumber: (phoneNumber) -> "#{phoneNumber.substr 0, 3}.#{phoneNumber.substr 3, 3}.#{phoneNumber.substr 6}"
					filter:
						phoneNumber: (phoneNumber) -> phoneNumber.replace(/[() \-.]/g, '')#.match(/^\d{10}$/)
				changeSsn:UIHelpers.editDialog
					fields:['ssn']
					instance: g_userCont.get()
					html:->pageLayer.tmpls.changeSsn
					mask:ssn:'9999'
				changeDateOfBirth: ->
					UIHelpers.showDialog
						html:pageLayer.tmpls.changeDateOfBirth
						init: (el:el, close:close) ->
							UIHelpers.setInputData el,
								dateOfBirthYear:g_userCont.get().get('dateOfBirth').format '{yyyy}'
								dateOfBirthMonth:g_userCont.get().get('dateOfBirth').format '{MM}'
								dateOfBirthDay:g_userCont.get().get('dateOfBirth').format '{dd}'

							el.find('input[type="submit"]').click ->
								data = UIHelpers.inputData el
								g_userCont.get().set 'dateOfBirth', "#{data.dateOfBirthYear}-#{data.dateOfBirthMonth}-#{data.dateOfBirthDay}"
								close()
								false
							el.find('.cancel').click close

				changePassword: ->
					UIHelpers.showDialog
						html:pageLayer.tmpls.changePassword
						init: (el:el, close:close) ->
							el.find('input[type=submit]').click ->
								data = UIHelpers.inputData el
								$.ajax "#{g_conf.appApiServer}/changePassword.php",
									data:data
									method: 'POST'
									xhrFields:
										withCredentials:true
								close()
								false
							el.find('.cancel').click close

				uploadPicture: ->
					UIHelpers.showDialog
						html:pageLayer.tmpls.uploadPicture
						init: (el:el, close:close) ->
							picture = null
							el.find('input[type="file"]').fileupload
								url:"#{g_conf.appApiServer}/upload/"
								dataType: 'json'
								done: (e, data) ->
									picture = "https:#{data.result.files[0].url.substr(5)}"
									el.find('img').attr 'src', picture
							el.find('input[type=submit]').click ->
								g_userCont.get().set 'picture', picture
								close()
								false
							el.find('.cancel').click close

				addAllergy: ->
					UIHelpers.showDialog
						html:pageLayer.tmpls.addAllergy
						init: (el:el, close:close) ->
							el.find('input[type=submit]').click ->
								dataManager.model('Allergy').create user:g_userCont.get(), name:UIHelpers.inputData(el).name
								close()
								false
							el.find('.cancel').click ->
								close()
								false
				addCondition: ->
					UIHelpers.showDialog
						html:pageLayer.tmpls.addCondition
						init: (el:el, close:close) ->
							el.find('input[type=submit]').click ->
								dataManager.model('Condition').create user:g_userCont.get(), name:UIHelpers.inputData(el).name
								close()
								false
							el.find('.cancel').click ->
								close()
								false

			pageLayer.bind pageLayer.el,
				user:g_userCont
				logout: ->
					if IS_MOBILE
						dataManager.offlineDb.clear()
						localStorage.removeItem 'session'
						dataManager.terminateClient ->
							document.location.reload()
					else
						$.ajax "#{g_conf.appApiServer}/signOut.php",
							xhrFields:withCredentials:true
							success: (response) ->
								document.location.reload()




			# pageLayer.withValue g_userCont.get().prop('picture'), (picture) ->
			# 	pageLayer.el.find('.field.profilePicture img').attr 'src', picture
			done()
