define ['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'app/UIHelpers'], (UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool) ->
	UIHelpers = require 'app/UIHelpers'

	breakpoints:
		614:
			init: ->
				$('article.outstandingBalance').appendTo 'main'
				$('article.paymentHistory').appendTo 'main'
				$('article.paymentMethods').appendTo 'main'
				$('article.insurance').appendTo 'main'

				$('.right').remove()

		else:
			init: ->
				right = $ '<div class="right" />';
				$('article.paymentHistory').appendTo 'main'

				$('article.outstandingBalance').appendTo right
				$('article.paymentMethods').appendTo right
				$('article.insurance').appendTo right

				$('.right').remove()
				right.appendTo 'main'

	init: (pageFrame, pageLayer, done) ->
		$.get base + 'app/templates/pages/billing.html', (template) ->
			pageLayer.el.append template
			pageLayer.if (->g_userCont.get().get('outstandingBalance')), (layer) -> layer.addClass $('main'), 'hasOutstandingBalance'

			pageLayer.bind pageLayer.el, user:g_userCont

			pageLayer.globalScope =
				editInsuranceDialog: UIHelpers.editDialogBinding (->pageLayer.tmpls.editInsurance), 'Insurance', [
					'idNumber'
					'groupNumber'
					'rxBin'
					'isCurrent'
				]

				editPaymentMethodDialog: UIHelpers.editDialogBinding (->pageLayer.tmpls.editPaymentMethod), 'PaymentMethod',[
					'firstName'
					'lastName'
					'number'
					'type'
					'cvc'
					'expMonth'
					'expYear'
					'street1'
					'street2'
					'zip'
					'city'
					'state'
					'isCurrent'
				], (el, instance) ->
					if instance.get('isCurrent')
						el.find('[name=isCurrent]').prop 'disabled', true
						el.find('a.delete').remove()

				addPaymentMethodDialog: ->
					UIHelpers.showDialog 
						html: pageLayer.tmpls.addPaymentMethod
						init: (el:el, close:close) ->

							if !g_userCont.get().get('paymentMethods').length()
								el.find('[name=isCurrent]')
									.prop 'disabled', true
									.prop 'checked', true

							el.find('.cancel').click close
							el.submit ->
								UIHelpers.form.validate el,
									{
										firstName: 'notEmpty'
										lastName: 'notEmpty'
										type: 'notEmpty'
										cvc: 'notEmpty'
										expMonth: field:'expirationDate', validate:'notEmpty'
										expYear: field:'expirationDate', validate:'notEmpty'
										street1: 'notEmpty'
										# street2: 'notEmpty'
										zip: 'notEmpty'
										city: 'notEmpty'
										state: 'notEmpty'
										number: (val, el) -> if !el.validateCreditCard().valid then 'The credit card number you entered is not valid.'
									}
									(isValid) ->
										if isValid
											$.ajax "#{g_conf.appApiServer}/addPaymentMethod.php",
												method: 'post'
												data:UIHelpers.inputData el
												xhrFields:withCredentials:true
												success: (response) ->
													if response == true
														UIHelpers.form.setErrors el, {}
														close()
													else if response.errors
														errors = {}
														for field, e of response.errors
															errors[field] = e.human
														UIHelpers.form.setErrors el, errors
								false



			done()
