define ['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool'], (UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool) ->
	(pageFrame, pageLayer, done) ->
		$.get base + 'app/templates/pages/calendar.html', (template) ->

			today = new Date()#Date.create 'Aug 25'



			pageLayer.el.append template
			pageLayer.bind pageLayer.el, user:g_userCont, {}

			calendarEntries = []

			if g_userCont.get().get('currentDivvyPack')
				packets = g_userCont.get().get('currentDivvyPack').packets
				calendarEntries.push
					begin: Date.create packets[0].time
					end: Date.create packets[packets.length - 1].time

					beginFunc: (el) ->
						# console.log 'begin divvypack', el

						el.addClass 'divvypack-begin'
						el.append '<div class="divvypack-begin" />'
						el.append '<div class="item"><span>Current divvyPACK</span></div>'

					middleFunc: (el) ->
						# console.log 'within divvypack', el

						el.addClass 'divvypack-middle'
						el.append '<div class="divvypack-middle" />'

					endFunc: (el) ->
						el.addClass 'divvypack-end'
						el.append '<div class="divvypack-end" />'
						# console.log 'end divvypack', el

			if g_userCont.get().get('lastShipment')
				calendarEntries.push
					date: g_userCont.get().get('lastShipment')
					func: (el) ->
						el.addClass 'shipment'
						if today.is(g_userCont.get().get('lastShipment')) || today.isBetween g_userCont.get().get('lastShipment'), g_userCont.get().get('nextShipment')
							el.append '<a class="item" target="_blank" href="' + g_userCont.get().get('lastShipmentTrackingUrl') + '"><span>Shipment Sent</span></a>'
						else
							el.append '<div class="item"><span>Shipment Sent</span></div>'

			if g_userCont.get().get 'nextShipment'
				calendarEntries.push
					date: g_userCont.get().get('nextShipment')
					func: (el) ->
						el.addClass 'shipment'
						if today.is(g_userCont.get().get('nextShipment')) || today.isAfter g_userCont.get().get('nextShipment')
							el.append '<a target="_blank" href="' + g_userCont.get().get('lastShipmentTrackingUrl') + '" class="item"><span>Next Shipment</span></a>'
						else
							el.append '<div class="item"><span>Next Shipment</span></div>'

			updateCalendar = (date) ->
				monthDate = date.clone()
				pageLayer.el.find('.calendar').remove()
				date = date.startOf 'month'
				date.subtract date.day(), 'days'
				month = monthDate.month()
				calendarEl = $ """
					<div class="calendar">
						<div class="header">
							<a href="#" class="prev">prev</a>
							<a href="#" class="next">next</a>
							<span class="month">#{monthDate.format('MMMM, YYYY')}</span>
						</div>

						<div class="day">Sun</div>
						<div class="day">Mon</div>
						<div class="day">Tue</div>
						<div class="day">Wed</div>
						<div class="day">Thu</div>
						<div class="day">Fri</div>
						<div class="day">Sat</div>
						<div class="dates" />
					</div>
				"""

				calendarEl.find('.prev').click ->
					updateCalendar monthDate.subtract 1, 'month'
					false
				calendarEl.find('.next').click ->
					updateCalendar monthDate.add 1, 'month'
					false

				calendarEl.appendTo pageLayer.el


				for i in [0...35]
					dateEl = $ "<div class='date'><span class='number'>#{date.date()}</span></div>"
					if date.month() != month
						dateEl.addClass 'otherMonth'

					dateStr = date.format('YYYY-MM-DD')
					if dateStr == moment(today).format('YYYY-MM-DD')
						dateEl.addClass 'today'

					calendarEl.find('.dates').append dateEl

					for entry in calendarEntries
						if entry.date
							if moment(entry.date).format('YYYY-MM-DD') == dateStr
								entry.func dateEl, date
						else
							if dateStr > moment(entry.begin).format('YYYY-MM-DD') && dateStr < moment(entry.end).format('YYYY-MM-DD')
								entry.middleFunc dateEl, date
							else if dateStr == moment(entry.begin).format('YYYY-MM-DD')
								entry.beginFunc dateEl, date
							else if dateStr == moment(entry.end).format('YYYY-MM-DD')
								entry.endFunc dateEl, date


					date.add 1, 'day'

			updateCalendar moment today
			done()

