define ['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'app/DivvyDose', 'app/UIHelpers'], (UILayer, FilteredArray, ArraySlice, XValue, ComputedValue, ComputedList, util, Model, ObservePool, DivvyDose, UIHelpers) ->
	init: (pageFrame, pageLayer, done) ->
		$.get base + 'app/templates/pages/caregivers.html', (mainTemplate) ->
			pageLayer.el.append mainTemplate
			pageLayer.bind pageLayer.el, {
				user:g_userCont
				addCaregiver: ->
					UIHelpers.showDialog
						html: pageLayer.tmpls.addCaregiver
						init: (el:el, close:close, updatePosition:updatePosition) ->
							el.find('.cancel').click -> close(); false
							el.find('.close').click -> close(); false

							el.submit ->
								data = UIHelpers.inputData(el)
								if !(data.email && data.firstName && data.lastName)
									el.addClass 'error'
								else
									el.removeClass 'error'
									el.addClass 'loading'
									el.find('[type=submit]').prop 'disabled', true

									$.ajax "#{g_conf.appApiServer}/addCaregiver.php",
										data:
											token:g_token
											email:data.email
											firstName:data.firstName
											lastName:data.lastName
										xhrFields:
											withCredentials:true
										success: ->
											el.addClass('done').removeClass 'loading'
											updatePosition()

										error: ->
											console.log 'error', arguments
								false
				requestToBecomeCaregiver: ->
					UIHelpers.showDialog
						html: pageLayer.tmpls.requestToBecomeCaregiver
						init: (el:el, close:close, updatePosition:updatePosition) ->
							el.find('.cancel').click -> close(); false
							el.find('.close').click -> close(); false
							el.submit ->
								data = UIHelpers.inputData(el)
								if !(data.email && data.firstName && data.lastName)
									el.addClass 'error'
								else
									el.removeClass 'error'
									el.addClass 'loading'
									el.find('[type=submit]').prop 'disabled', true

									$.ajax "#{g_conf.appApiServer}/requestCaregiverStatus.php",
										data:
											token:g_token
											email:data.email
											firstName:data.firstName
											lastName:data.lastName
										xhrFields:
											withCredentials:true
										success: ->
											el.addClass('done').removeClass 'loading'
											updatePosition()

										error: ->
											console.log 'error', arguments
								false

			}, {
				'user.caringFor.viewAccount': (user) ->
					g_userCont.set user
			}
			done()
