define ['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool', 'app/DivvyDose'], (UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool, DivvyDose) ->
	# breakpoints:
	# 	614:
	# 		init: ->
	# 			$('article.outstandingBalance').appendTo 'main'
	# 			$('article.paymentHistory').appendTo 'main'
	# 			$('article.paymentMethods').appendTo 'main'
	# 			$('article.insurance').appendTo 'main'

	# 			$('.right').remove()

	# 	else:
	# 		init: ->
	# 			right = $ '<div class="right" />';
	# 			$('article.paymentHistory').appendTo 'main'

	# 			$('article.outstandingBalance').appendTo right
	# 			$('article.paymentMethods').appendTo right
	# 			$('article.insurance').appendTo right

	# 			$('.right').remove()
	# 			right.appendTo 'main'




	init: (pageFrame, pageLayer, done) ->
		window.packetContainsMedication = (divvyPack, packet, medication) ->
			for dose in packet.doses
				if DivvyDose.prescriptionNameWithoutFormat(divvyPack.prescriptions[dose.rxNumber].name) == medication.get('nameWithoutFormat')
					return true
			false


		_totalDoses = {}

		window.totalDoses = (medication, start, end) ->
			if g_userCont.get().get('demo')
				k = start+end+medication.get('id')
				if _totalDoses[k]
					_totalDoses[k]
				else
					r = Math.random()
					_totalDoses[k] = if r < .1
						0
					else
						2

			else
				count = 0
				if divvyPacks = g_userCont.get().get('divvyPacks')
					for startDate, divvyPack of divvyPacks
						for packet in divvyPack.packets
							if Date.create(packet.time).isBetween start, end
								if packetContainsMedication divvyPack, packet, medication
									count++
				count
		
		_totalTaken = {}

		window.totalTaken = (prescription, start, end) ->
			if g_userCont.get().get('demo')
				k = start+end+prescription.get('id')
				if _totalTaken[k]
					_totalTaken[k]
				else
					r = Math.random()
					_totalTaken[k] = if r < .2
						0
					else if r < .5
						Math.min _totalDoses[k], 1
					else
						Math.min _totalDoses[k], 2
			else
				count = 0

				g_userCont.get().get('medicineLogEntries').find(event:'taken').each (logEntry) ->
					if Date.create(logEntry.get('time')).isBetween start, end
						if logEntry.get('doses').exists(prescription:prescription)
							count++
				count




		inc = (date, i) ->
			switch timeScale.get()
				when 'days'
					date.addDays(i)
				when 'weeks'
					date.addWeeks(i)
				when 'months'
					date.addMonths(i)
				when 'years'
					date.addYears(i)

		dateAt = (i) -> inc start.get().clone(), i

		header = (i) ->
			switch timeScale.get()
				when 'days'
					dateAt(i).format '{Dow}'
				when 'weeks'
					dateAt(i).format '<span class="month">{Mon}</span><span class="day">{d}</span>'
				when 'months'
					dateAt(i).format '{Mon}'
				when 'years'
					dateAt(i).format '{year}'

		dateRange = (i) ->
			begin = dateAt i
			end = inc begin.clone(), 1

			now = Date.create()
			if end.isAfter now
				end = now

			[begin, end]

		window.timeScale = new XValue().retain()

		start = new XValue().retain()

		timeScale.observe ->
			start.set switch timeScale.get()
				when 'days' then Date.create().beginningOfDay()
				when 'weeks' then Date.create().beginningOfWeek()
				when 'months' then Date.create().beginningOfMonth()
				when 'years' then Date.create().beginningOfYear()

		timeScale.set 'weeks'

		$.get base + 'app/templates/pages/charts.html', (template) ->
			pageLayer.el.append template
			pageLayer.bind pageLayer.el, {user:g_userCont, timeScale:timeScale},
				prev: ->
					start.set inc start.get().clone(), -1

				next: ->
					start.set inc start.get().clone(), 1
				setTimeScale: (ts) -> timeScale.set ts

				header: (el) -> header el.index()

				'user.prescriptions:regular':
					init: (el, [medication], layer:layer) ->
						el.find('.name').click ->
							console.log medication.get 'name'
							nameEl = $ "<div class='fullName'>#{medication.get 'name'} <a href='#' class='close' /></div>"
							nameEl.click ->
								nameEl.remove()
								false
							# $('body').append nameEl
							layer.addHtml $('body'), nameEl
							pos = $(@).offset()
							nameEl.css top:pos.top + $(@).outerHeight()/2 - nameEl.outerHeight()/2, left:pos.left - 10



				'user.prescriptions:regular.state': (medication, el) ->
					index = el.index() - 1
					range = dateRange index

					td = totalDoses medication, range...
					tt = totalTaken medication, range...
					# console.log td, tt, range
					if td && tt == td
						'full'
					else if tt
						'partial'
					else
						'none'
			done()
