define ['xyzp/UILayer', 'xyzp/FilteredArray', 'xyzp/ArraySlice', 'xyzp/XValue', 'xyzp/ComputedList', 'xyzp/util', 'xyzp/Model', 'xyzp/ObservePool'], (UILayer, FilteredArray, ArraySlice, XValue, ComputedList, util, Model, ObservePool) ->
	init: (pageFrame, pageLayer, done) ->
		$.get base + 'app/templates/pages/medications.html', (template) ->
			pageLayer.bindEvent $(window), 'scroll', ->
				if $(window).scrollTop() > $('main').offset().top
					$('main').addClass 'floatingMedication'
				else
					$('main').removeClass 'floatingMedication'


			pageLayer.el.append template
			class Component
				@get: (name, params, cb) ->
					component = new Component @components[name]
					component.init params, -> cb component

				@components:
					List:
						init: (layer:layer, controller:controller, selectedMedication:selectedMedication, cb) ->
							$.get base + 'app/templates/pages/medications/list.html', (template) =>
								@el = $ '<div />'
								@layer = layer.addLayer new UILayer

								@el.append template

								initMedication = (el, [supplement], layer:layer) ->
									el.click ->
										controller.navigationalShift2 layer, 'medication', supplement

									layer.if (->selectedMedication.get() == supplement), (layer) ->
										layer.addClass el, 'active'

									layer.withValue supplement.prop('image'), (image) ->
										el.find('img').attr 'src', image

								@layer.bind @el, user:g_userCont, {
									'user.prescriptions:regular':init: initMedication
									'user.prescriptions:asNeeded':init: initMedication
								}

								cb()

					View:
						init: (layer:layer, controller:controller, selectedMedication:selectedMedication, cb) ->
							$.get base + 'app/templates/pages/medications/view.html', (template) =>
								@el = $ '<div />'
								@layer = layer.addLayer new UILayer
								@el.append template

								@layer.bind @el,
									prescription:selectedMedication
									user:g_userCont
									pause: ->
										selectedMedication.get().set 'state', 'paused'
										console.log selectedMedication


									resume: ->
										selectedMedication.get().set 'state','resumed'
								cb()


				constructor: (methods) ->
					for name, func of methods
						@[name] = func
			

			pageLayer.value('selectedMedication').set false
			{
				web:
					init: (cb) ->
						Component.get 'List', controller:@, selectedMedication:pageLayer.value('selectedMedication'), (component) =>
							pageLayer.el.append """
								<div class="list" />
								<div if="pageLayer.value('selectedMedication').get()" class="selectedMedication" />
							"""

							pageLayer.bind pageLayer.el
							pageLayer.el.find('.list').append component.el
							pageLayer.addLayer component.layer
							cb()

						# pageLayer.if (->pageLayer.value('selectedMedication').get()), (layer) =>
						# 	console.log 'asdf'
						# 	layer.addClass pageLayer.el, 'medicationSelected'
						# pageLayer.withValue pageLayer.value('selectedMedication'), (selectedMedication) -> console.log selectedMedication


						selectedMedicationLayer = null
						pageLayer.withValue pageLayer.value('selectedMedication'), (selectedMedication) ->
							if selectedMedication
								Component.get 'View', controller:@, selectedMedication:pageLayer.value('selectedMedication'), (component) =>
									if selectedMedicationLayer
										selectedMedicationLayer.destruct()
										selectedMedicationLayer = null

									selectedMedicationLayer = pageLayer.addLayer new UILayer
									selectedMedicationLayer.addHtml pageLayer.el.find('.selectedMedication'), component.el
									pageLayer.el.addClass 'medicationSelected'

							else
								pageLayer.el.removeClass 'medicationSelected'
								if selectedMedicationLayer
									selectedMedicationLayer.destruct()
									selectedMedicationLayer = null



				mobile:
					layer:pageLayer
					init: (cb) ->
						Component.get 'List', layer:pageLayer, controller:@, selectedMedication:pageLayer.value('selectedMedication'), (component) =>
							pageLayer.el.append """
								<div class="list" />
								<div if="pageLayer.value('selectedMedication').get()" class="selectedMedication" />
							"""

							pageLayer.bind pageLayer.el
							pageLayer.el.find('.list').append component.el
							cb()

						selectedMedicationLayer = null
						pageLayer.withValue pageLayer.value('selectedMedication'), (selectedMedication) ->
							if selectedMedication
								pushBackButton -> pageLayer.value('selectedMedication').set false

								if selectedMedicationLayer
									selectedMedicationLayer.destruct()
									selectedMedicationLayer = null

								selectedMedicationLayer = pageLayer.addLayer new UILayer
								# selectedMedicationLayer.addLayer component.layer

								Component.get 'View', layer:selectedMedicationLayer, controller:@, selectedMedication:pageLayer.value('selectedMedication'), (component) =>
									selectedMedicationLayer.addHtml pageLayer.el.find('.selectedMedication'), component.el
									pageLayer.el.addClass 'medicationSelected'

							else
								pageLayer.el.removeClass 'medicationSelected'
								if selectedMedicationLayer
									selectedMedicationLayer.destruct()
									selectedMedicationLayer = null



					navigationalShift2: (layer, type, params...) ->
						@navigation ?= {}

						if @navigation[type]
							eq = true
							for param, i in params
								if @navigation[type].params[i] != param
									eq = false
									break

							console.log eq
							@navigation[type].layer.destruct()
							if eq
								# delete @navigation[type]
								return

						@navigation[type] = params:params
						@navigation[type].layer = navigationLayer = layer.addLayer new UILayer
						navigationLayer.addDestructFunc =>
							if @navigation[type].layer == navigationLayer
								delete @navigation[type]




						{
							medication: (supplement) ->
								# pageLayer.value('selectedMedication').set supplement
								navigationLayer.setValue pageLayer.value('selectedMedication'), supplement

						}[type] params...


					navigationalShift: (layer, type, params...) ->
						{
							medication: (supplement) ->
								if pageLayer.value('selectedMedication').get() == supplement

									pageLayer.value('selectedMedication').set false
								else
									pageLayer.value('selectedMedication').set supplement

						}[type] params...



					navigationalShift: (layer, type, params...) ->
						{
							medication: (supplement) ->
								if pageLayer.value('selectedMedication').get() == supplement
									pageLayer.value('selectedMedication').set false
								else
									pageLayer.value('selectedMedication').set supplement

						}[type] params...

			}.mobile.init done
