Raven.setExtraContextProp 'version', '1.0.0'
templateFile = (name) -> "text!../../app/templates/#{name}.html"
window.OFFLINE = false
window.OPTS = offline:false
initMobile = null
window.IS_MOBILE = typeof cordova != 'undefined'

if IS_MOBILE
	resetState = ->
		localStorage.clear()
		if cordova?.plugins?.notification?.local
			cordova.plugins.notification.local.cancelAll -> location.reload()
		else
			location.reload()

	Raven.setExtraContextProp 'mobile', true
	initMobile = (cb) ->
		$('html').addClass(navigator.platform.toLowerCase().replace(' ', '-'))
		navigator.splashscreen.hide()

		$ ->
			$('#status .reload').click ->
				document.location.reload()
				false

			$('#status .reset').click ->
				if confirm 'Are you sure?'
					dataManager.reset()
					setTimeout (->
						document.location.reload()
					), 1000
				
				false

		OPTS.offline = true
		window.OFFLINE = false

		connectTimer = null

		goOffline = ->
			if connectTimer
				clearTimeout connectTimer
				connectTimer = null

			if !window.OFFLINE
				console.log 'offline'
				g_online.set false
				window.OFFLINE = true
				if dataManager?
					dataManager.transport.ws.close()

		goOnline = ->
			if window.OFFLINE
				console.log 'online'
				window.OFFLINE = false
				g_online.set true
				if dataManager?
					connectTimer = setTimeout (->dataManager.connect(); connectTimer=null), 1000

		document.addEventListener 'offline', goOffline, false
		document.addEventListener 'online', goOnline, false

		setInterval (->
			if navigator.connection.type in [Connection.UNKNOWN, Connection.NONE]
				goOffline()
			else
				goOnline()
		), 1000

		g_online.set !(navigator.connection.type in [Connection.UNKNOWN, Connection.NONE])

	registerPushNotifications = ->
		console.log 'registering push notification...'
		if device.platform.toLowerCase() == 'android'
			plugins.pushNotification.register(
				(result) ->
					console.log 'success', result
					
				(result) ->
					console.log 'failure', result
				senderID: '622634218825'
				ecb: '__onPushNotification'
			)
		else
			plugins.pushNotification.register(
				(token) ->
					console.log 'Token: ' + token
					window.g_deviceToken = token
					window.__onGetDeviceToken?()

					cb?()

				(error) ->
					console.log 'Error: ' + error
					cb?()
				{
					'badge':'true',
					'sound':'true',
					'alert':'true',
					'ecb':'__onPushNotification'
				}
			)


	document.addEventListener 'deviceready', ->
		window.onPushNotification = (cb) ->
			window._pushNotificationCb = cb

			if _pushNotification?
				cb _pushNotification
				delete window._pushNotification

		window.onLocalNotification = (cb) ->
			window._localNotificationCb = cb

			if _localNotification?
				cb _localNotification...
				delete window._localNotification

		handled = {}
		cordova.plugins.notification.local.on 'click', (notification) ->
			if device.platform.toLowerCase() == 'android'
				handled[notification.id] = true

			console.log ['click', notification]
			window.lastLocalNotification = ['click', notification]
			if _localNotificationCb?
				_localNotificationCb 'click', notification
			else
				window._localNotification = ['click', notification]


		cordova.plugins.notification.local.on 'trigger', (notification) ->
			console.log window.lastLocalNotification = ['trigger', notification]
			if device.platform.toLowerCase() == 'android'
				# TODO: Fix ugly hack
				setTimeout (->
					if !handled[notification.id]
						if _localNotificationCb?
							_localNotificationCb 'trigger', notification
						else
							window._localNotification = ['trigger', notification]
					else
						delete handled[notification.id]


				), 100
			else
				if _localNotificationCb?
					_localNotificationCb 'trigger', notification
				else
					window._localNotification = ['trigger', notification]

		window.__onPushNotification = (notification) ->
			# console.log notification
			window.lastPushNotification = window.pushNotification = notification

			if device.platform.toLowerCase() == 'android' && notification.event == 'registered'
				window.g_deviceToken = notification.regid
				window.__onGetDeviceToken?()
				cb?()
			else
				if _pushNotificationCb?
					window._pushNotificationCb notification
				else
					window._pushNotification = notification


		registerPushNotifications()

	document.addEventListener 'resume', ->
		if !g_deviceToken?
			registerPushNotifications()

define ['xyzp/init'], ->
	require ['app/init', 'app/config', 'xyzp/XValue'], (initApp, config, XValue) ->
		window.g_online = new XValue

		window.start = ->
			$('html').addClass 'loading'
			
			done = ->
				$('html').removeClass 'loading'
				initApp()


			if !IS_MOBILE
				g_online.set true

			config = config()
			if OPTS.offline
				$('html').addClass 'supportsOfflineMode'

			config.dataManager offline:OPTS.offline, (dataManager) ->
				if dataManager
					window.dataManager = dataManager

					dataManager.offline.observe ->
						if dataManager.offline.get()
							$('html').addClass 'offline'
							$('html').removeClass 'online'
						else
							$('html').removeClass 'offline'
							$('html').addClass 'online'


					dataManager.connected.observe ->
						if dataManager.connected.get()
							$('html').addClass 'connected'
						else
							$('html').removeClass 'connected'

					dataManager.status.observe ->
						$('#status .status').html dataManager.status.get()

					console.log 'init...!'
					dataManager.init (success, error) ->
						if success
							console.log 'starting init!'
							if config.init
								config.init done
							else
								done()
							window.BOOTSTRAP_OK = true
						else
							if error == 'outdatedSchemaNoConnection'
								if IS_MOBILE
									$('html').removeClass 'loading'
									document.addEventListener 'online', -> document.location.reload()
									alert 'Update required. The application must have access to the Internet before you may continue to use it.'

							else
								$('html').removeClass 'loading'
								config.failedToConnect?()
				else
					console.log 'starting init (no data manager)!'
					if config.init
						config.init done
					else
						done()
					window.BOOTSTRAP_OK = true

		if IS_MOBILE
			document.addEventListener 'deviceready', ->
				console.log 'device ready', device
				initMobile()
				start()
		else
			start()
