class UILayer
	constructor: (@name) ->

	destruct: (removeFromParent=true) ->
		if @parent && removeFromParent
			@parent.removeLayer @

		if @layers
			layer.destruct false for layer in @layers

		if @destructFuncs
			func() for func in @destructFuncs

	addElement: (el, name) ->
		@elements ?= {}
		@elements[name] = el

	addElementBinding: (elementName, valueName) ->
		el = @elements[elementName]
		value = @value valueName
		el.val value.get()
		value.observe -> el.val value.get() if el.val() != value.get()
		if el.attr('type') == 'text'
			el.keyup ->
				if value.get() != el.val()
					value.set el.val()
				true

	addLayer: (layer) ->
		@layers ?= []
		@layers.push layer
		layer.parent = @
		layer.debug = @debug
		layer.globalScope = @globalScope

		if layer.name
			@layersByName ?= {}
			@layersByName[layer.name] = layer

		layer

	removeLayer: (layer) ->
		_.pull @layers, layer
		if layer.name
			delete @layersByName[layer.name]

	layer: (name) -> 
		if @layersByName[name]
			@layersByName[name]

		@tmpls[id] = html


	newLayers: (layers) ->
		for params in layers
			@new params

	addHtml: (el, html) ->
		newEl = $ html
		el.append newEl
		@addDestructFunc -> newEl.remove()
		newEl

	addClass: (el, className) ->
		el.addClass className
		@addDestructFunc -> el.removeClass className

	addCss: (el, css) ->
		prevValues = {}
		for attr, value of css
			if el.get(0).style[attr]
				prevValues[attr] = el.get(0).style[attr]
			else
				prevValues[attr] = ''
		el.css css

		@addDestructFunc -> el.css prevValues

class Breakpoints
	constructor: ->
		@list = []
		@breakpointsByName = {}
		@breakpoints = {}


	addBreakpoints: (name, breakpoints) ->
		@list.push breakpoints
		@breakpointsByName[name] = breakpoints
		@resolveBreakpoints()

	removeBreakpoints: (name) ->
		_.pull @list, @breakpointsByName[name]
		delete @breakpointsByName[name]
		@resolveBreakpoints()

	resolveBreakpoints: ->
		resolvedBreakpoints = {}
		for breakpoints in @list
			for width, breakpoint of breakpoints
				resolvedBreakpoints[width] ?= []
				resolvedBreakpoints[width].push breakpoint

		@breakpoints = resolvedBreakpoints
		# delete @currentBreakpoint

	update: (force=false) ->
		$('body').addClass 'breakpointed'
		widths = _.map(_.without(_.keys(@breakpoints), 'else'), (v)->parseInt v).sort (a, b) -> a - b
		breakpoint = 'else'
		for width in widths
			if $(window).width() < width
				breakpoint = width
				break

		if @currentBreakpoint != breakpoint || force
			$('body').removeClass "breakpoint-#{@currentBreakpoint}"
			$('body').addClass "breakpoint-#{breakpoint}"

			if @breakpointLayer
				@breakpointLayer.destruct()

			@breakpointLayer = new UILayer
			@currentBreakpoint = breakpoint
			bp.init? @breakpointLayer for bp in @breakpoints[breakpoint] if @breakpoints[breakpoint]


		bp.resize? $(window).width() for bp in @breakpoints[breakpoint] if @breakpoints[breakpoint]
